<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR) && $METHOD != 'x_autocompletar') {
	header("Location: ?p=login");
	die;
}

class BancosCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Bancos.
	 *
	 * @var Bancos
	 */
	private $Bancos;
		
	function __construct() {
		parent::__construct();
		$this->Bancos = new Bancos();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Bancos.
	 *
	 */
	public function listado() {
		$this->menu_lateral();
		
		if (isset($_GET['buscar'])) {
			if (@$_GET['codigo']) {
				$this->Bancos->Codigo = $_GET['codigo'];
			}
			if (@$_GET['nombre']) {
				$this->Bancos->Nombre = $_GET['nombre'];
			}
		}
		
		if(isset($_GET['alfabetica'])) {
			$this->Bancos->PorLetra = $_GET['alfabetica'];
		}
		
		$this->Bancos->Page = @$_GET['pg'];
		$this->Bancos->OrderBy = 'nombre';
		$this->Buffer['listado'] = $this->Bancos->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Bancos->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('bancos/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Bancos.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Bancos y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Bancos->IdBanco = $_GET['id_banco'];
		$this->Buffer['datos'] = $this->Bancos->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Bancos.
	 *
	 */
	public function formulario() {
		$this->menu_lateral();
		
		$this->Buffer['paso'] = 1;
		
		//$this->Buffer['formulario'] = $this->Template->Load('bancos/formulario-bancos.tpl.php', $this->Buffer);
		//$this->Buffer['body'] = $this->Template->Load('bancos/formulario.tpl.php', $this->Buffer);
		$this->Buffer['body'] = $this->Template->Load('bancos/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Bancos.
	 *
	 */
	public function guardar() {
		$this->Bancos->IdBanco = $_POST['id_banco'];
		$this->Bancos->Obtener();
		$this->Bancos->Codigo = $_POST['codigo'];
		$this->Bancos->Nombre = $_POST['nombre'];
		$this->Bancos->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=bancos"); }
		die;
	}
		
	/**
	 * @desc
	 * Menu lateral para todas las secciones.
	 *
	 */
	private function menu_lateral() {
		$this->Buffer['menu_lateral'] = $this->Template->Load('bancos/menu-lateral.tpl.php');
	}
	
	/**
	 * @desc
	 * Buscador AJAX de Bancos.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['codigo']) {
				$this->Bancos->Codigo = $_GET['codigo'];
			}
			if (@$_GET['nombre']) {
				$this->Bancos->Nombre = $_GET['nombre'];
			}
		}
		
		//$this->Bancos->Activo = null;
		$this->Bancos->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Bancos->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Bancos->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('bancos/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('bancos/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Bancos->IdBanco = $_POST['id_banco'];
		$this->Bancos->Codigo = $_POST['codigo'];
		$this->Bancos->Nombre = $_POST['nombre'];
		$this->Bancos->Guardar();
		
		echo $this->Bancos->IdBanco;
	}
	
	/**
	 * @desc
	 * Marca un bancos como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Bancos->IdBanco = $_POST['id_banco'];
		$this->Bancos->Eliminar();
	}
	
	/**
	 * @desc
	 * Devuelve un Bancos.
	 *
	 */
	public function x_obtener() {
		$this->Bancos->IdBanco = $_GET['id_banco'];
		$aDatos = $this->Bancos->Obtener();
		header('Content-type: application/xml; charset=utf-8');
		
		echo "<datos>";
		foreach ($aDatos as $columna => $valor) {
			echo "<{$columna}>".htmlspecialchars($valor, ENT_QUOTES, 'UTF-8')."</{$columna}>\r\n";
		}
		echo "</datos>";
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Bancos->Nombre = @$_GET['q'];
		$this->Bancos->OrderBy = 'nombre';
		$this->Bancos->LimitCant = null;
		$aDatos = $this->Bancos->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['nombre'])."|{$item['id_banco']}\n";
		}
	}
}

$oCont = new BancosCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>