<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR)) {
	header("Location: ?p=login");
	die;
}

class ChequesCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Cheques.
	 *
	 * @var Cheques
	 */
	private $Cheques;
		
	function __construct() {
		parent::__construct();
		$this->Cheques = new Cheques();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Cheques.
	 *
	 */
	public function listado() {
		$this->menu_lateral();
		
		
		if (!isset($_GET['cobrado'])) {
			$_GET['buscar'] = 1;
			$_GET['cobrado'] = '0';
			$_GET['depositado'] = '0';
		}

		if (isset($_GET['buscar'])) {
			if (@$_GET['id_cliente']) {
				$this->Cheques->IdCliente = $_GET['id_cliente'];
			}
			if (@$_GET['id_banco']) {
				$this->Cheques->IdBanco = $_GET['id_banco'];
			}
			if (@$_GET['numero']) {
				$this->Cheques->Numero = $_GET['numero'];
			}
			if (@$_GET['fecha_ingreso']) {
				$this->Cheques->FechaIngreso = $_GET['fecha_ingreso'];
			}
			if (@$_GET['fecha_vencimiento']) {
				$this->Cheques->FechaVencimiento = $_GET['fecha_vencimiento'];
			}
			if ($_GET['depositado'] !== '') {
				$this->Cheques->Depositado = $_GET['depositado'];
			}
			if ($_GET['cobrado'] !== '') {
				$this->Cheques->Cobrado = $_GET['cobrado'];
				if ($_GET['cobrado'] == 1) {
					$this->Cheques->FueEntregado = true;
				}
				else {
					$this->Cheques->FueEntregado = false;
				}
			}
		}
		
		$this->Cheques->Page = @$_GET['pg'];
		$this->Cheques->OrderBy = 'fecha_vencimiento';
		$this->Buffer['listado'] = $this->Cheques->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Cheques->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('cheques/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Cheques.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		if (isset($_GET['id_cliente'])) {
			$oCliente = new Clientes();
			$oCliente->IdCliente = $_GET['id_cliente'];
			$oCliente->Obtener();
			
			$this->Buffer['datos']['id_cliente'] = $oCliente->IdCliente;
			$this->Buffer['datos']['cliente'] = $oCliente->Nombre;
		}
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Cheques y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Cheques->IdCheque = $_GET['id_cheque'];
		$this->Buffer['datos'] = $this->Cheques->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Cheques.
	 *
	 */
	public function formulario() {
		$this->menu_lateral();
		
		$this->Buffer['paso'] = 1;
		
		//$this->Buffer['formulario'] = $this->Template->Load('cheques/formulario-cheques.tpl.php', $this->Buffer);
		//$this->Buffer['body'] = $this->Template->Load('cheques/formulario.tpl.php', $this->Buffer);
		$this->Buffer['body'] = $this->Template->Load('cheques/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Cheques.
	 *
	 */
	public function guardar() {
		$this->Cheques->IdCheque = $_POST['id_cheque'];
		$this->Cheques->Obtener();
		$this->Cheques->IdCliente = $_POST['id_cliente'];
		$this->Cheques->IdBanco = $_POST['id_banco'];
		$this->Cheques->Numero = $_POST['numero'];
		$this->Cheques->FechaIngreso = date2mysql($_POST['fecha_ingreso']);
		$this->Cheques->FechaVencimiento = date2mysql($_POST['fecha_vencimiento']);
		$this->Cheques->Importe = $_POST['importe'];
		$this->Cheques->Depositado = @$_POST['depositado'];
		$this->Cheques->Cobrado = @$_POST['cobrado'];
		$this->Cheques->IdProveedor = @$_POST['id_proveedor'];
		$this->Cheques->FechaEgreso = date2mysql(@$_POST['fecha_egreso']);
		$this->Cheques->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=cheques"); }
		die;
	}
		
	/**
	 * @desc
	 * Menu lateral para todas las secciones.
	 *
	 */
	private function menu_lateral() {
		$this->Buffer['menu_lateral'] = $this->Template->Load('cheques/menu-lateral.tpl.php');
	}
	
	/**
	 * @desc
	 * Buscador AJAX de Cheques.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['id_cliente']) {
				$this->Cheques->IdCliente = $_GET['id_cliente'];
			}
			if (@$_GET['id_banco']) {
				$this->Cheques->IdBanco = $_GET['id_banco'];
			}
		}
		
		//$this->Cheques->Activo = null;
		$this->Cheques->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Cheques->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Cheques->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('cheques/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('cheques/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Cheques->IdCheque = $_POST['id_cheque'];
		$this->Cheques->IdCliente = $_POST['id_cliente'];
		$this->Cheques->IdBanco = $_POST['id_banco'];
		$this->Cheques->Numero = $_POST['numero'];
		$this->Cheques->FechaIngreso = $_POST['fecha_ingreso'];
		$this->Cheques->FechaVencimiento = $_POST['fecha_vencimiento'];
		$this->Cheques->Importe = $_POST['importe'];
		$this->Cheques->Guardar();
		
		echo $this->Cheques->IdCheque;
	}
	
	/**
	 * @desc
	 * Marca un cheques como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Cheques->IdCheque = $_POST['id_cheque'];
		$this->Cheques->Eliminar();
	}
	
	/**
	 * @desc
	 * Devuelve un Cheques.
	 *
	 */
	public function x_obtener() {
		$this->Cheques->IdCheque = $_GET['id_cheque'];
		$aDatos = $this->Cheques->Obtener();
		header('Content-type: application/xml; charset=utf-8');
		
		echo "<datos>";
		foreach ($aDatos as $columna => $valor) {
			echo "<{$columna}>".htmlspecialchars($valor, ENT_QUOTES, 'UTF-8')."</{$columna}>\r\n";
		}
		echo "</datos>";
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Cheques->IdCheque = @$_GET['q'];
		$this->Cheques->OrderBy = 'IdCheque';
		$this->Cheques->LimitCant = 50;
		$aDatos = $this->Cheques->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_cheque'])."|{$item['id_cheque']}\n";
		}
	}
}

$oCont = new ChequesCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>