<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR)) {
	header("Location: ?p=login");
	die;
}

class CobranzasCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Cobranzas.
	 *
	 * @var Cobranzas
	 */
	private $Cobranzas;
		
	function __construct() {
		parent::__construct();
		$this->Cobranzas = new Cobranzas();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Cobranzas.
	 *
	 */
	public function listado() {
		$this->menu_lateral();
		
		if (isset($_GET['buscar'])) {
			if (@$_GET['desde']) {
				$this->Cobranzas->Desde = date2mysql($_GET['desde'], '%d/%m/%Y', false);
			}
			if (@$_GET['hasta']) {
				$this->Cobranzas->Hasta = date2mysql($_GET['hasta'], '%d/%m/%Y', false);
			}
			if (@$_GET['id_cliente']) {
				$this->Cobranzas->IdCliente = $_GET['id_cliente'];
			}
			if (@$_GET['importe']) {
				$this->Cobranzas->Importe = $_GET['importe'];
			}
		}
		
		$this->Cobranzas->Page = @$_GET['pg'];
		$this->Cobranzas->OrderBy = 'fecha DESC, id_cobranza DESC';
		$this->Buffer['listado'] = $this->Cobranzas->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Cobranzas->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('cobranzas/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Cobranzas.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Cobranzas y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Cobranzas->IdCobranza = $_GET['id_cobranza'];
		$this->Buffer['datos'] = $this->Cobranzas->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Cobranzas.
	 *
	 */
	public function formulario() {
		$this->menu_lateral();
		
		$this->Buffer['paso'] = 1;
		
		//$this->Buffer['formulario'] = $this->Template->Load('cobranzas/formulario-cobranzas.tpl.php', $this->Buffer);
		//$this->Buffer['body'] = $this->Template->Load('cobranzas/formulario.tpl.php', $this->Buffer);
		$this->Buffer['body'] = $this->Template->Load('cobranzas/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Cobranzas.
	 *
	 */
	public function guardar() {
		$this->Cobranzas->IdCobranza = $_POST['id_cobranza'];
		$this->Cobranzas->Obtener();
		$this->Cobranzas->Fecha = date2mysql($_POST['fecha']);
		$this->Cobranzas->IdCliente = $_POST['id_cliente'];
		$this->Cobranzas->IdMoneda = $_POST['id_moneda'];
		$this->Cobranzas->Importe = $_POST['importe'];
		$this->Cobranzas->Notas = $_POST['notas'];
		$this->Cobranzas->Guardar();
		
		if (@$_POST['cheque']) {
			header("Location: ./?p=cheques|nuevo&id_cliente={$this->Cobranzas->IdCliente}");
			die;
		}
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ./?p=cobranzas"); }
		die;
	}
		
	/**
	 * @desc
	 * Menu lateral para todas las secciones.
	 *
	 */
	private function menu_lateral() {
		$this->Buffer['menu_lateral'] = $this->Template->Load('cobranzas/menu-lateral.tpl.php');
	}
	
	/**
	 * @desc
	 * Buscador AJAX de Cobranzas.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['fecha']) {
				$this->Cobranzas->Fecha = $_GET['fecha'];
			}
			if (@$_GET['id_cliente']) {
				$this->Cobranzas->IdCliente = $_GET['id_cliente'];
			}
		}
		
		//$this->Cobranzas->Activo = null;
		$this->Cobranzas->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Cobranzas->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Cobranzas->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('cobranzas/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('cobranzas/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Cobranzas->IdCobranza = $_POST['id_cobranza'];
		$this->Cobranzas->Fecha = $_POST['fecha'];
		$this->Cobranzas->IdCliente = $_POST['id_cliente'];
		$this->Cobranzas->IdMoneda = $_POST['id_moneda'];
		$this->Cobranzas->Importe = $_POST['importe'];
		$this->Cobranzas->Notas = $_POST['notas'];
		$this->Cobranzas->Guardar();
		
		echo $this->Cobranzas->IdCobranza;
	}
	
	/**
	 * @desc
	 * Marca un cobranzas como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Cobranzas->IdCobranza = $_POST['id_cobranza'];
		$this->Cobranzas->Eliminar();
	}
	
	/**
	 * @desc
	 * Devuelve un Cobranzas.
	 *
	 */
	public function x_obtener() {
		$this->Cobranzas->IdCobranza = $_GET['id_cobranza'];
		$aDatos = $this->Cobranzas->Obtener();
		header('Content-type: application/xml; charset=utf-8');
		
		echo "<datos>";
		foreach ($aDatos as $columna => $valor) {
			echo "<{$columna}>".htmlspecialchars($valor, ENT_QUOTES, 'UTF-8')."</{$columna}>\r\n";
		}
		echo "</datos>";
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Cobranzas->IdCobranza = @$_GET['q'];
		$this->Cobranzas->OrderBy = 'IdCobranza';
		$this->Cobranzas->LimitCant = 50;
		$aDatos = $this->Cobranzas->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_cobranza'])."|{$item['id_cobranza']}\n";
		}
	}
}

$oCont = new CobranzasCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>