<?
class Condiciones_fiscalesCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Condiciones_fiscales.
	 *
	 * @var Condiciones_fiscales
	 */
	private $Condiciones_fiscales;
		
	function __construct() {
		parent::__construct();
		$this->Condiciones_fiscales = new Condiciones_fiscales();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Condiciones_fiscales.
	 *
	 */
	public function listado() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Condiciones_fiscales->Nombre = $_GET['nombre'];
			}
			if (@$_GET['letra']) {
				$this->Condiciones_fiscales->Letra = $_GET['letra'];
			}
			if (@$_GET['iva']) {
				$this->Condiciones_fiscales->Iva = $_GET['iva'];
			}
			if (@$_GET['identificador']) {
				$this->Condiciones_fiscales->Identificador = $_GET['identificador'];
			}
		}
		
		if(isset($_GET['alfabetica']) && strlen($_GET['alfabetica'])) {
			$this->Condiciones_fiscales->PorLetra = $_GET['alfabetica'];
		}
		
		$this->Condiciones_fiscales->Page = @$_GET['pg'];
		$this->Condiciones_fiscales->OrderBy = 'id_condicionfiscal';
		$this->Buffer['listado'] = $this->Condiciones_fiscales->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Condiciones_fiscales->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('condiciones_fiscales/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Condiciones_fiscales.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Condiciones_fiscales y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Condiciones_fiscales->IdCondicionfiscal = $_GET['id_condicionfiscal'];
		$this->Buffer['datos'] = $this->Condiciones_fiscales->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Condiciones_fiscales.
	 *
	 */
	public function formulario() {
		$this->Buffer['body'] = $this->Template->Load('condiciones_fiscales/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Condiciones_fiscales.
	 *
	 */
	public function guardar() {
		$this->Condiciones_fiscales->IdCondicionfiscal = $_POST['id_condicionfiscal'];
		$this->Condiciones_fiscales->Obtener();
		$this->Condiciones_fiscales->Nombre = $_POST['nombre'];
		$this->Condiciones_fiscales->Letra = $_POST['letra'];
		$this->Condiciones_fiscales->Iva = @$_POST['iva'];
		$this->Condiciones_fiscales->Grava = @$_POST['grava'];
		$this->Condiciones_fiscales->Identificador = $_POST['identificador'];
		$this->Condiciones_fiscales->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=condiciones_fiscales"); }
		die;
	}
		
	/**
	 * @desc
	 * Buscador AJAX de Condiciones_fiscales.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Condiciones_fiscales->Nombre = $_GET['nombre'];
			}
			if (@$_GET['letra']) {
				$this->Condiciones_fiscales->Letra = $_GET['letra'];
			}
		}
		
		//$this->Condiciones_fiscales->Activo = null;
		$this->Condiciones_fiscales->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Condiciones_fiscales->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Condiciones_fiscales->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('condiciones_fiscales/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('condiciones_fiscales/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Condiciones_fiscales->IdCondicionfiscal = $_POST['id_condicionfiscal'];
		$this->Condiciones_fiscales->Nombre = $_POST['nombre'];
		$this->Condiciones_fiscales->Letra = $_POST['letra'];
		$this->Condiciones_fiscales->Iva = $_POST['iva'];
		$this->Condiciones_fiscales->Identificador = $_POST['identificador'];
		$this->Condiciones_fiscales->Guardar();
		
		echo $this->Condiciones_fiscales->IdCondicionfiscal;
	}
	
	/**
	 * @desc
	 * Marca un registro como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Condiciones_fiscales->IdCondicionfiscal = $_POST['id_condicionfiscal'];
		$aData['eliminado'] = $this->Condiciones_fiscales->Eliminar();
		
		echo json_encode($aData);
	}
	
	/**
	 * @desc
	 * Devuelve un Condiciones_fiscales.
	 *
	 */
	public function x_obtener() {
		$this->Condiciones_fiscales->IdCondicionfiscal = $_GET['id_condicionfiscal'];
		$aDatos = $this->Condiciones_fiscales->Obtener();
		
		echo json_encode($aDatos);
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Condiciones_fiscales->Nombre = @$_GET['q'];
		$this->Condiciones_fiscales->OrderBy = 'nombre';
		$this->Condiciones_fiscales->LimitCant = 50;
		$aDatos = $this->Condiciones_fiscales->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['nombre'])."|{$item['id_condicionfiscal']}\n";
		}
	}
}

$oCont = new Condiciones_fiscalesCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>