<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR)) {
	header("Location: ?p=login");
	die;
}

class CotizacionesCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Cotizaciones.
	 *
	 * @var Cotizaciones
	 */
	private $Cotizaciones;
		
	function __construct() {
		parent::__construct();
		$this->Cotizaciones = new Cotizaciones();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Cotizaciones.
	 *
	 */
	public function listado() {
		$this->menu_lateral();
		
		if (isset($_GET['buscar'])) {
			if (@$_GET['fecha']) {
				$this->Cotizaciones->Fecha = $_GET['fecha'];
			}
			if (@$_GET['id_moneda']) {
				$this->Cotizaciones->IdMoneda = $_GET['id_moneda'];
			}
			if (@$_GET['importe']) {
				$this->Cotizaciones->Importe = $_GET['importe'];
			}
		}
		
		$this->Cotizaciones->Page = @$_GET['pg'];
		$this->Cotizaciones->OrderBy = 'fecha DESC';
		$this->Buffer['listado'] = $this->Cotizaciones->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Cotizaciones->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('cotizaciones/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Cotizaciones.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Cotizaciones y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Cotizaciones->IdCotizacion = $_GET['id_cotizacion'];
		$this->Buffer['datos'] = $this->Cotizaciones->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Cotizaciones.
	 *
	 */
	public function formulario() {
		$this->menu_lateral();
		
		$this->Buffer['paso'] = 1;
		
		//$this->Buffer['formulario'] = $this->Template->Load('cotizaciones/formulario-cotizaciones.tpl.php', $this->Buffer);
		//$this->Buffer['body'] = $this->Template->Load('cotizaciones/formulario.tpl.php', $this->Buffer);
		$this->Buffer['body'] = $this->Template->Load('cotizaciones/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Cotizaciones.
	 *
	 */
	public function guardar() {
		$this->Cotizaciones->IdCotizacion = $_POST['id_cotizacion'];
		$this->Cotizaciones->Obtener();
		$this->Cotizaciones->Fecha = date2mysql($_POST['fecha']);
		$this->Cotizaciones->IdMoneda = $_POST['id_moneda'];
		$this->Cotizaciones->Importe = $_POST['importe'];
		$this->Cotizaciones->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=cotizaciones"); }
		die;
	}
		
	/**
	 * @desc
	 * Menu lateral para todas las secciones.
	 *
	 */
	private function menu_lateral() {
		$this->Buffer['menu_lateral'] = $this->Template->Load('cotizaciones/menu-lateral.tpl.php');
	}
	
	/**
	 * @desc
	 * Buscador AJAX de Cotizaciones.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['fecha']) {
				$this->Cotizaciones->Fecha = $_GET['fecha'];
			}
			if (@$_GET['id_moneda']) {
				$this->Cotizaciones->IdMoneda = $_GET['id_moneda'];
			}
		}
		
		//$this->Cotizaciones->Activo = null;
		$this->Cotizaciones->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Cotizaciones->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Cotizaciones->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('cotizaciones/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('cotizaciones/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Cotizaciones->IdCotizacion = $_POST['id_cotizacion'];
		$this->Cotizaciones->Fecha = $_POST['fecha'];
		$this->Cotizaciones->IdMoneda = $_POST['id_moneda'];
		$this->Cotizaciones->Importe = $_POST['importe'];
		$this->Cotizaciones->Guardar();
		
		echo $this->Cotizaciones->IdCotizacion;
	}
	
	/**
	 * @desc
	 * Marca un cotizaciones como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Cotizaciones->IdCotizacion = $_POST['id_cotizacion'];
		$this->Cotizaciones->Eliminar();
	}
	
	/**
	 * @desc
	 * Devuelve un Cotizaciones.
	 *
	 */
	public function x_obtener() {
		$this->Cotizaciones->IdCotizacion = $_GET['id_cotizacion'];
		$aDatos = $this->Cotizaciones->Obtener();
		header('Content-type: application/xml; charset=utf-8');
		
		echo "<datos>";
		foreach ($aDatos as $columna => $valor) {
			echo "<{$columna}>".htmlspecialchars($valor, ENT_QUOTES, 'UTF-8')."</{$columna}>\r\n";
		}
		echo "</datos>";
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Cotizaciones->IdCotizacion = @$_GET['q'];
		$this->Cotizaciones->OrderBy = 'IdCotizacion';
		$this->Cotizaciones->LimitCant = 50;
		$aDatos = $this->Cotizaciones->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_cotizacion'])."|{$item['id_cotizacion']}\n";
		}
	}
}

$oCont = new CotizacionesCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>