<?
class CronjobsCtl extends Controller {
	
	/**
	 * @desc
	 * Conector a la base de datos.
	 *
	 * @var Dbconnection
	 */
	private $DB;
	
	/**
	 * @desc
	 * Modelo de Cronjobs.
	 *
	 * @var Cronjobs
	 */
	private $Cronjobs;
	
	function __construct() {
		parent::__construct();
		$this->DB = new Dbconnection();
		$this->Cronjobs = new Cronjobs();
	}
	
	/**
	 * @desc
	 * Ejecuta la tarea programada que debe tener lugar en este momento.
	 *
	 */
	public function index() {
		$sFp = fopen('cronjob.log', 'a+');
		fwrite($sFp, date('Y-m-d H:i:s')."\t");
		
		$this->DB = new Dbconnection();
		
		$cSql = "SELECT * FROM cronjobs WHERE ADDTIME(ultima_ejecucion, periodo_ejecucion) <= NOW() ORDER BY ultima_ejecucion LIMIT 1";
		$this->DB->Query($cSql);
		
		if ($this->DB->Count()) {
			$aTarea = $this->DB->Field();
			
			$cFunc = $aTarea['tarea'];
			fwrite($sFp, "`{$cFunc}`");
			$this->$cFunc();
			
			$cSql = "UPDATE cronjobs SET ultima_ejecucion = NOW() WHERE id_cronjob = '{$aTarea['id_cronjob']}' LIMIT 1";
			$this->DB->Query($cSql);
			
			fwrite($sFp, " ejecutado correctamente.\r\n");
		}
		else {
			fwrite($sFp, " sin tareas pendientes.\r\n");
		}
		
		
		fclose($sFp);
	}
	
	/**
	 * @desc
	 * Listado de Cronjobs.
	 *
	 */
	public function listado() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['tarea']) {
				$this->Cronjobs->Tarea = $_GET['tarea'];
			}
			if (@$_GET['descripcion']) {
				$this->Cronjobs->Descripcion = $_GET['descripcion'];
			}
			if (@$_GET['ultima_ejecucion']) {
				$this->Cronjobs->UltimaEjecucion = $_GET['ultima_ejecucion'];
			}
			if (@$_GET['periodo_ejecucion']) {
				$this->Cronjobs->PeriodoEjecucion = $_GET['periodo_ejecucion'];
			}
		}
		
		$this->Cronjobs->Page = @$_GET['pg'];
		$this->Cronjobs->OrderBy = 'ultima_ejecucion';
		$this->Buffer['listado'] = $this->Cronjobs->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Cronjobs->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('cronjobs/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Optimiza las tablas de la base de datos.
	 *
	 */
	private function optimize() {
		$cSql = "SHOW TABLES";
		$this->DB->Query($cSql);
		
		$aTablas = $this->DB->GetRecordset();
		
		foreach ($aTablas as $item) {
			$item = current($item);
			
			$cSql = "OPTIMIZE TABLE `{$item}`";
			$this->DB->Query($cSql);
			
			echo "Tabla {$item} optimizada.\r\n";
		}
	}
	
	private function historial_produccion() {
		$oFases = new Fases();
		$oProyectos = new Proyectos();
		$oDB = new Dbconnection();
		
		// Inserta la fecha del snapshot.
		$cSql = "INSERT INTO historial_produccion SET fecha = NOW()";
		$nId = $oDB->QueryInsert($cSql);
		
		$aFases = $oFases->Buscar();
		foreach ($aFases as $nFasePos => $item_fase) {
		for ($i=0; $i<2; ++$i) {
			$oProyectos->IdFaseactiva = $item_fase['id_fase'];
			$oProyectos->IdEstadofase = $i;
			$oProyectos->FinReal = false;
			$oProyectos->LimitCant = null;
			
			foreach ($oProyectos->Buscar() as $item_proyecto) {
				$cSql = "INSERT INTO detalles_historialproduccion SET 
					id_historial = {$nId},
					id_fase = {$oProyectos->IdFaseactiva},
					id_estado = {$i},
					id_proyecto = {$item_proyecto['id_proyecto']}";
				$oDB->Query($cSql);
			}
			
		}}
	}
}

$oCont = new CronjobsCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>