<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR, PERMISOS_FACTURACION)) {
	header("Location: ?p=login");
	die;
}

class CuentasCorrientesCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de facturas.
	 *
	 * @var Facturas
	 */
	private $Facturas;
	
	/**
	 * @desc
	 * Modelo de Cobranzas.
	 *
	 * @var Cobranzas
	 */
	private $Cobranzas;
	
	/**
	 * @desc
	 * Modelo de CuentasCorrientes.
	 *
	 * @var CuentasCorrientes
	 */
	private $CuentasCorrientes;
	
	function __construct() {
		parent::__construct();
		
		$this->Facturas = new Facturas();
		$this->Cobranzas = new Cobranzas();
		$this->CuentasCorrientes = new CuentasCorrientes();
	}
	
	function index() {
		$this->menu_lateral();
		
		if (isset($_GET['buscar'])) {
			if (@$_GET['id_cliente']) {
				$this->CuentasCorrientes->IdCliente = $_GET['id_cliente'];
			}
			
			//$this->Facturas->Page = @$_GET['pg'];
			$this->CuentasCorrientes->OrderBy = 'fecha';
			$this->Buffer['listado'] = $this->CuentasCorrientes->Buscar();
			
		} elseif(@$_SESSION['clienteactivo']) {
			$this->CuentasCorrientes->IdCliente = $_SESSION['clienteactivo'];
			$this->CuentasCorrientes->OrderBy = 'fecha';
			$this->Buffer['listado'] = $this->CuentasCorrientes->Buscar();
		}
		else {
			$this->Buffer['listado'] = array();
		}
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Facturas->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('cuentas_corrientes/listado.tpl.php', $this->Buffer);
		$this->Template->Load('default.tpl.php', $this->Buffer, false);
	}
	
	/**
	 * @desc
	 * Menu lateral para todas las secciones.
	 *
	 */
	private function menu_lateral() {
		$this->Buffer['menu_lateral'] = $this->Template->Load('cuentas_corrientes/menu-lateral.tpl.php');
	}
	
	public function x_exportar() {
		
		if(@$_SESSION['clienteactivo']) {
			$_GET['id_cliente'] = $_SESSION['clienteactivo'];
		}
		
		if (!@$_GET['id_cliente']) {
			header("Location: ?p=cuentas_corrientes");
			die;
		}
		
		// Busca los datos del cliente
		$oCliente = new Clientes();
		$oCliente->IdCliente = $_GET['id_cliente'];
		$oCliente->Obtener();
		
		// Busca los datos de la cuenta corriente
		$this->CuentasCorrientes->IdCliente = $_GET['id_cliente'];
		$this->CuentasCorrientes->OrderBy = 'fecha';
		$aListado = $this->CuentasCorrientes->Buscar();
		
		// Arma el PDF
		require_once('includes/fpdf/fpdf.php');
		$oPdf = new FPDF();
		$oPdf->IsUTF = true;
		$oPdf->AddPage();
		$oPdf->SetAuthor('Estudio Quadra');
		$oPdf->SetTitle('Factura');
		$oPdf->SetSubject('Factura', true);
		$oPdf->SetFont('Arial', '', 10);
		$oPdf->SetDrawColor(80,80,80);
		
		$oPdf->Cell(130,0,"CUENTA CORRIENTE DE {$oCliente->Nombre} AL ".date('d/m/Y'),0,0,'C');
		$oPdf->Ln(6);
		
		//Cabecera
		$oPdf->Cell(20,7,'Fecha',1,0,'C',0);
		$oPdf->Cell(50,7,'Detalle',1,0,'C',0);
		$oPdf->Cell(20,7,'Debe',1,0,'C',0);
		$oPdf->Cell(20,7,'Haber',1,0,'C',0);
		$oPdf->Cell(20,7,'Saldo',1,0,'C',0);
		$oPdf->Ln();
		
		// Cuerpo
		$nSaldo = 0;
		foreach ($aListado as $item) {
			$nSaldo += $item['haber'] - $item['debe'];
			
			if ($item['debe'] > 0) {
				$cDetalle = 'FACTURA '.($item['tipo'] ? $item['tipo'] : 'X');
			}
			else {
				$cDetalle = 'PAGO';
			}
			$cDetalle .= ' Nº '.($item['tipo'] ? sprintf('%08d', $item['comprobante']) : sprintf('%08d', $item['id']));

			$oPdf->Cell(20,7,mysql2date($item['fecha']),1);
			$oPdf->Cell(50,7,$cDetalle,1);
			$oPdf->Cell(20,7,$item['debe'] == 0 ? '' : $item['debe'],1,0,'R');
			$oPdf->Cell(20,7,$item['haber'] == 0 ? '' : $item['haber'],1,0,'R');
			$oPdf->Cell(20,7,sprintf('%0.2f', $nSaldo),1,0,'R');
			$oPdf->Ln();
		}
		
		$oPdf->Output("Cta Cte - {$oCliente->IdCliente}", 'I');
	}
}

$oCont = new CuentasCorrientesCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>