<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR)) {
	header("Location: ?p=login");
	die;
}

class DominiosCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Dominios.
	 *
	 * @var Dominios
	 */
	private $Dominios;
		
	function __construct() {
		parent::__construct();
		$this->Dominios = new Dominios();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Dominios.
	 *
	 */
	public function listado() {
		if (@$_GET['actualizar']) {
			$oSoapClient = new SoapClient("http://www.qserver.com.ar/soap/service.wsdl");
			$aSitios = $oSoapClient->sitios_instalados();
			
			foreach($aSitios as $item) {
				$this->Dominios->Nombre = $item;
				$this->Dominios->Guardar();
				$this->Dominios->Limpiar();
			}
		}
		
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Dominios->Nombre = $_GET['nombre'];
			}
			if (@$_GET['revisado'] !== "") {
				$this->Dominios->Revisado = $_GET['revisado'];
			}
		}
		
		if(isset($_GET['alfabetica']) && strlen($_GET['alfabetica'])) {
			$this->Dominios->PorLetra = $_GET['alfabetica'];
		}
		
		$this->Dominios->Page = @$_GET['pg'];
		$this->Dominios->OrderBy = 'nombre';
		$this->Buffer['listado'] = $this->Dominios->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Dominios->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('dominios/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Dominios.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Dominios y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Dominios->IdDominio = $_GET['id_dominio'];
		$this->Buffer['datos'] = $this->Dominios->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Dominios.
	 *
	 */
	public function formulario() {
		$this->Buffer['body'] = $this->Template->Load('dominios/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Dominios.
	 *
	 */
	public function guardar() {
		$this->Dominios->IdDominio = $_POST['id_dominio'];
		$this->Dominios->Obtener();
		$this->Dominios->Nombre = $_POST['nombre'];
		$this->Dominios->Revisado = $_POST['revisado'];
		$this->Dominios->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=dominios"); }
		die;
	}
		
	/**
	 * @desc
	 * Buscador AJAX de Dominios.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Dominios->Nombre = $_GET['nombre'];
			}
			if (@$_GET['revisado']) {
				$this->Dominios->Revisado = $_GET['revisado'];
			}
		}
		
		//$this->Dominios->Activo = null;
		$this->Dominios->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Dominios->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Dominios->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('dominios/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('dominios/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Dominios->IdDominio = $_POST['id_dominio'];
		$this->Dominios->Nombre = $_POST['nombre'];
		$this->Dominios->Revisado = $_POST['revisado'];
		$this->Dominios->Guardar();
		
		echo $this->Dominios->IdDominio;
	}
	
	/**
	 * @desc
	 * Marca un registro como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Dominios->IdDominio = $_POST['id_dominio'];
		$aData['eliminado'] = $this->Dominios->Eliminar();
		
		echo json_encode($aData);
	}
	
	/**
	 * @desc
	 * Devuelve un Dominios.
	 *
	 */
	public function x_obtener() {
		$this->Dominios->IdDominio = $_GET['id_dominio'];
		$aDatos = $this->Dominios->Obtener();
		
		echo json_encode($aDatos);
	}
	
	public function x_cambiar_estado() {
		$this->Dominios->IdDominio = $_POST['id_dominio'];
		$this->Dominios->Obtener();
		$this->Dominios->Revisado = $_POST['estado'];
		$this->Dominios->Guardar();
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Dominios->IdDominio = @$_GET['q'];
		$this->Dominios->OrderBy = 'IdDominio';
		$this->Dominios->LimitCant = 50;
		$aDatos = $this->Dominios->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_dominio'])."|{$item['id_dominio']}\n";
		}
	}
}

$oCont = new DominiosCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>