<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_SUPER)) {
	header("Location: ?p=login");
	die;
}

class EgresosCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Egresos.
	 *
	 * @var Egresos
	 */
	private $Egresos;
		
	function __construct() {
		parent::__construct();
		$this->Egresos = new Egresos();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Egresos.
	 *
	 */
	public function listado() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['fecha']) {
				$this->Egresos->Fecha = date2mysql($_GET['fecha'], '%d/%m/%Y', false);
			}
			if (@$_GET['desde']) {
				$this->Egresos->Desde = date2mysql($_GET['desde'], '%d/%m/%Y', false);
			}
			if (@$_GET['hasta']) {
				$this->Egresos->Hasta = date2mysql($_GET['hasta'], '%d/%m/%Y', false);
			}
			if (@$_GET['id_tipoegreso']) {
				$this->Egresos->IdTipoegreso = $_GET['id_tipoegreso'];
			}
			if (@$_GET['id_proyecto']) {
				$this->Egresos->IdProyecto = $_GET['id_proyecto'];
			}
			if (@$_GET['id_operador']) {
				$this->Egresos->IdOperador = $_GET['id_operador'];
			}
			if (@$_GET['computar']) {
				$this->Egresos->Computar = $_GET['computar'];
			}
			if (@$_GET['id_proveedor']) {
				$this->Egresos->IdProveedor = $_GET['id_proveedor'];
			}
			if (@$_GET['descripcion']) {
				$this->Egresos->Descripcion = $_GET['descripcion'];
			}
			if (@$_GET['importe']) {
				$this->Egresos->Importe = $_GET['importe'];
			}
		}
		
		$this->Egresos->Page = @$_GET['pg'];
		$this->Egresos->OrderBy = 'fecha DESC, id_egreso DESC';
		$this->Buffer['listado'] = $this->Egresos->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Egresos->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('egresos/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Egresos.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Egresos y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Egresos->IdEgreso = $_GET['id_egreso'];
		$this->Buffer['datos'] = $this->Egresos->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Egresos.
	 *
	 */
	public function formulario() {
		$this->Buffer['body'] = $this->Template->Load('egresos/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Egresos.
	 *
	 */
	public function guardar() {
		$this->Egresos->IdEgreso = $_POST['id_egreso'];
		$this->Egresos->Obtener();
		$this->Egresos->Fecha = date2mysql($_POST['fecha']);
		$this->Egresos->IdTipoegreso = $_POST['id_tipoegreso'];
		$this->Egresos->IdProyecto = $_POST['id_proyecto'];
		$this->Egresos->IdOperador = $_POST['id_operador'];
		$this->Egresos->Descripcion = $_POST['descripcion'];
		$this->Egresos->Computar = @$_POST['computar'];
		$this->Egresos->IdProveedor = $_POST['id_proveedor'];
		$this->Egresos->IdTipofactura = $_POST['id_tipofactura'];
		$this->Egresos->Comprobante = $_POST['comprobante'];
		$this->Egresos->Importe = $_POST['importe'];
		$this->Egresos->Nogravado = $_POST['nogravado'];
		$this->Egresos->Iva = $_POST['iva'];
		$this->Egresos->PercepcionIva = $_POST['percepcion_iva'];
		$this->Egresos->PercepcionIIBB = $_POST['percepcion_iibb'];
		$this->Egresos->Total = $_POST['total'];
		$this->Egresos->Notas = $_POST['notas'];
		$this->Egresos->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=egresos"); }
		die;
	}
		
	/**
	 * @desc
	 * Buscador AJAX de Egresos.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['fecha']) {
				$this->Egresos->Fecha = $_GET['fecha'];
			}
			if (@$_GET['id_tipoegreso']) {
				$this->Egresos->IdTipoegreso = $_GET['id_tipoegreso'];
			}
		}
		
		//$this->Egresos->Activo = null;
		$this->Egresos->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Egresos->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Egresos->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('egresos/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('egresos/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Egresos->IdEgreso = $_POST['id_egreso'];
		$this->Egresos->Fecha = $_POST['fecha'];
		$this->Egresos->IdTipoegreso = $_POST['id_tipoegreso'];
		$this->Egresos->IdProyecto = $_POST['id_proyecto'];
		$this->Egresos->IdOperador = $_POST['id_operador'];
		$this->Egresos->Descripcion = $_POST['descripcion'];
		$this->Egresos->Importe = $_POST['importe'];
		$this->Egresos->Nogravado = $_POST['nogravado'];
		$this->Egresos->Iva = $_POST['iva'];
		$this->Egresos->PercepcionIva = $_POST['percepcion_iva'];
		$this->Egresos->PercepcionIIBB = $_POST['percepcion_iibb'];
		$this->Egresos->Total = $_POST['total'];
		$this->Egresos->Notas = $_POST['notas'];
		$this->Egresos->Guardar();
		
		echo $this->Egresos->IdEgreso;
	}
	
	/**
	 * @desc
	 * Marca un registro como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Egresos->IdEgreso = $_POST['id_egreso'];
		$aData['eliminado'] = $this->Egresos->Eliminar();
		echo json_encode($aData);
	}
	
	/**
	 * @desc
	 * Devuelve un Egresos.
	 *
	 */
	public function x_obtener() {
		$this->Egresos->IdEgreso = $_GET['id_egreso'];
		$aDatos = $this->Egresos->Obtener();
		
		echo json_encode($aDatos);
	}
	
	/**
	 * @desc
	 * Verifica el tipo de comprobante y n�mero.
	 *
	 */
	public function x_verificar_comprobante() {
		$this->Egresos->IdProveedor = $_GET['id_proveedor'];
		$this->Egresos->IdTipofactura = $_GET['id_tipofactura'];
		$this->Egresos->Comprobante = $_GET['comprobante'];
		$this->Egresos->LimitCant = 1;
		
		$this->Egresos->Buscar();
		
		echo json_encode(array('ok' => (bool) $this->Egresos->FoundRows));
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Egresos->IdEgreso = @$_GET['q'];
		$this->Egresos->OrderBy = 'IdEgreso';
		$this->Egresos->LimitCant = 50;
		$aDatos = $this->Egresos->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_egreso'])."|{$item['id_egreso']}\n";
		}
	}
}

$oCont = new EgresosCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>