<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR, PERMISOS_FACTURACION)) {
	header("Location: ?p=login");
	die;
}

class FacturasCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Facturas.
	 *
	 * @var Facturas
	 */
	private $Facturas;
		
	function __construct() {
		parent::__construct();
		$this->Facturas = new Facturas();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Facturas.
	 *
	 */
	public function listado() {
		$this->menu_lateral();
		
		if (isset($_GET['buscar'])) {
			if (@$_GET['desde']) {
				$this->Facturas->Desde = date2mysql($_GET['desde']);
			}
			if (@$_GET['hasta']) {
				$this->Facturas->Hasta = date2mysql($_GET['hasta']);
			}
			if (@$_GET['id_cliente']) {
				$this->Facturas->IdCliente = $_GET['id_cliente'];
			}
			if (@$_GET['id_proyecto']) {
				$this->Facturas->IdProyecto = $_GET['id_proyecto'];
			}
			if (@$_GET['id_tipofactura']) {
				$this->Facturas->IdTipofactura = $_GET['id_tipofactura'];
			}
		} elseif(isset($_SESSION['clienteactivo'])){
			$this->Facturas->IdCliente = $_SESSION['clienteactivo'];
		}
		
		$this->Facturas->Page = @$_GET['pg'];
		$this->Facturas->OrderBy = 'fecha DESC, id_factura DESC';
		$this->Buffer['listado'] = $this->Facturas->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Facturas->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('facturas/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Facturas.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Facturas y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Facturas->IdFactura = $_GET['id_factura'];
		$this->Buffer['datos'] = $this->Facturas->Obtener();
		
		$oOrdenes = new Ordenes();
		$oOrdenes->IdFactura = $this->Facturas->IdFactura;
		$oOrdenes->LimitCant = null;
		$this->Buffer['listado'] = $oOrdenes->Buscar();
		$this->Buffer['ordenes_factura'] = $this->Template->Load('ordenes/x-listado.tpl.php', $this->Buffer);
		
		$oDetalles = new Detalles_factura();
		$oDetalles->IdFactura = $this->Facturas->IdFactura;
		$oDetalles->LimitCant = null;
		$this->Buffer['listado'] = $oDetalles->Buscar();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Facturas.
	 *
	 */
	public function formulario() {
		$this->menu_lateral();
		
		$this->Buffer['paso'] = 1;
		
		//$this->Buffer['formulario'] = $this->Template->Load('facturas/formulario-facturas.tpl.php', $this->Buffer);
		//$this->Buffer['body'] = $this->Template->Load('facturas/formulario.tpl.php', $this->Buffer);
		$this->Buffer['detalles_factura'] = $this->Template->Load('detalles_factura/x-listado.tpl.php', $this->Buffer);
		$this->Buffer['body'] = $this->Template->Load('facturas/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Facturas.
	 *
	 */
	public function guardar() {
		$oCliente = new Clientes();
		$oCliente->IdCliente = $_POST['id_cliente'];
		$oCliente->Obtener();
		
		$this->Facturas->IdFactura = $_POST['id_factura'];
		$this->Facturas->Obtener();
		$this->Facturas->Fecha = date2mysql($_POST['fecha']);
		$this->Facturas->IdCliente = $_POST['id_cliente'];
		$this->Facturas->IdProyecto = $_POST['id_proyecto'];
		$this->Facturas->IdCondicionfiscal = $oCliente->IdCondicionfiscal;
		$this->Facturas->IdTipofactura = $_POST['id_tipofactura'];
		$this->Facturas->Comprobante = $_POST['comprobante'];
		$this->Facturas->IdMoneda = $_POST['id_moneda'];
		if ($this->Facturas->IdTipofactura == 4) {
			$this->Facturas->Importe = round($_POST['importe'] / (1 + Configuracion::ObtenerCampoCargado('iva') / 100), 2);
			$this->Facturas->Iva = $_POST['total'] - $this->Facturas->Importe;
		}
		else {
			$this->Facturas->Importe = $_POST['importe'];
			$this->Facturas->Iva = $_POST['iva'];
		}
		$this->Facturas->Impuesto = $_POST['impuesto'];
		$this->Facturas->Total = $_POST['total'];
		$this->Facturas->Guardar();
		
		// Graba los ID de factura en las ordenes.
		if (@$_POST['id_orden']) {
			$oOrdenes = new Ordenes();
			foreach ($_POST['id_orden'] as $item) {
				$oOrdenes->IdOrden = $item;
				$oOrdenes->Obtener();
				$oOrdenes->IdFactura = $this->Facturas->IdFactura;
				$oOrdenes->DescripcionFactura = $_POST['descripcion'][$item];
				$oOrdenes->Guardar();
			}
		}
		
		if (@$_POST['id_detallefactura']) {
			$oDetalles = new Detalles_factura();
			foreach ($_POST['id_detallefactura'] as $pos => $item) {
				
				if ($item) {
					$oDetalles->IdDetallefactura = $item;
					$oDetalles->Obtener();
				}
				else {
					$oDetalles->IdDetallefactura = null;
				}
				
				$oDetalles->IdFactura = $this->Facturas->IdFactura;
				$oDetalles->Descripcion = $_POST['det_descripcion'][$pos];
				$oDetalles->Importe = $_POST['det_importe'][$pos];
				$oDetalles->Guardar();
			}
		}
		
		if (@$_POST['imprimir']) {
			header("Location: ?p=facturas|x_imprimir&id_factura={$this->Facturas->IdFactura}");
		}
		else {
			header("Location: ?p=facturas|nuevo");
		}
		die;
	}
		
	/**
	 * @desc
	 * Menu lateral para todas las secciones.
	 *
	 */
	private function menu_lateral() {
		$this->Buffer['menu_lateral'] = $this->Template->Load('facturas/menu-lateral.tpl.php');
	}
	
	/**
	 * @desc
	 * Buscador AJAX de Facturas.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['fecha']) {
				$this->Facturas->Fecha = $_GET['fecha'];
			}
			if (@$_GET['id_cliente']) {
				$this->Facturas->IdCliente = $_GET['id_cliente'];
			}
		}
		
		//$this->Facturas->Activo = null;
		$this->Facturas->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Facturas->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Facturas->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('facturas/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('facturas/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Facturas->IdFactura = $_POST['id_factura'];
		$this->Facturas->Fecha = $_POST['fecha'];
		$this->Facturas->IdCliente = $_POST['id_cliente'];
		$this->Facturas->IdProyecto = $_POST['id_proyecto'];
		$this->Facturas->Importe = $_POST['importe'];
		$this->Facturas->Iva = $_POST['iva'];
		$this->Facturas->Impuesto = $_POST['impuesto'];
		$this->Facturas->Total = $_POST['total'];
		$this->Facturas->Guardar();
		
		echo $this->Facturas->IdFactura;
	}
	
	/**
	 * @desc
	 * Marca un facturas como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Facturas->IdFactura = $_POST['id_factura'];
		$this->Facturas->Eliminar();
	}
	
	/**
	 * @desc
	 * Devuelve un Facturas.
	 *
	 */
	public function x_obtener() {
		$this->Facturas->IdFactura = $_GET['id_factura'];
		$aDatos = $this->Facturas->Obtener();
		header('Content-type: application/xml; charset=utf-8');
		
		echo "<datos>";
		foreach ($aDatos as $columna => $valor) {
			echo "<{$columna}>".htmlspecialchars($valor, ENT_QUOTES, 'UTF-8')."</{$columna}>\r\n";
		}
		echo "</datos>";
	}
	
	public function x_imprimir() {
		$this->Facturas->IdFactura = $_GET['id_factura'];
		$aFactura = $this->Facturas->Obtener();
		$aFecha = explode('-', $this->Facturas->Fecha);
		
		$oCliente = new Clientes();
		$oCliente->IdCliente = $this->Facturas->IdCliente;
		$aCliente = $oCliente->Obtener();
		
		$oOrdenes = new Ordenes();
		$oOrdenes->IdFactura = $this->Facturas->IdFactura;
		$oOrdenes->LimitCant = null;
		$aOrdenes = $oOrdenes->Buscar();
		
		$oDetalles = new Detalles_factura();
		$oDetalles->IdFactura = $this->Facturas->IdFactura;
		$oDetalles->LimitCant = null;
		$aDetalles = $oDetalles->Buscar();
		
		// Componer PDF.
		$nDebug = 0;
		$nX = 0;
		$nY = 1;
		
		if ($this->Facturas->IdTipofactura) {
			$this->PDF = new FPDF();
			$this->PDF->AddPage('', array(210,302));
		}
		else {
			$this->PDF = new FPDI();
			$this->PDF->AddPage();
			$this->PDF->setSourceFile('./files/fuentes/recibo provisorio.pdf');
			$sSrc = $this->PDF->importPage(1);
			$this->PDF->useTemplate($sSrc, 0, 0);
		}
		
		$this->PDF->SetAuthor('Estudio Quadra');
		$this->PDF->SetTitle('Factura');
		$this->PDF->SetSubject('Factura', true);
		$this->PDF->SetFillColor(220,0,0);
		
		if (!$this->Facturas->IdTipofactura) {
			// numero
			$this->PDF->SetFont('Arial', '', 15);
			$this->PDF->SetXY($nX+135, $nY+23);
			$this->PDF->Cell(40,6,sprintf('0001-%08d', $aFactura['id_factura']),0,0,'L',$nDebug);
		}
		
		$this->PDF->SetFont('Arial', '', 10);
		
		// fecha
		$this->PDF->SetXY($nX+167, $nY+34);
		$this->PDF->Cell(40,6,"{$aFecha[2]}        {$aFecha[1]}       {$aFecha[0]}",0,0,'L',$nDebug);
		
		// cliente
		$this->PDF->SetXY($nX+32, $nY+64);
		$this->PDF->Cell(120,6,utf8_decode($aFactura['razon_social'].($oCliente->Telefono ? " ({$oCliente->Telefono})" : '')),0,0,'L',$nDebug);
		
		// domicilio
		$this->PDF->SetXY($nX+32, $nY+73.5);
		$this->PDF->Cell(80,6,utf8_decode($oCliente->Domicilio),0,0,'L',$nDebug);
		
		// IVA
		$this->PDF->SetXY($nX+25, $nY+87);
		$this->PDF->Cell(80,6,utf8_decode($aCliente['condicion_fiscal']),0,0,'L',$nDebug);
		
		// cuit
		$this->PDF->SetXY($nX+135, $nY+85);
		$this->PDF->Cell(40,6,utf8_decode($oCliente->Cuit),0,0,'L',$nDebug);
		
		// consumidor final
		/*
		$this->PDF->SetFont('', '', 8);
		$this->PDF->SetXY($nX+90, $nY+69);
		$this->PDF->Cell(6,6,'X',0,0,'L',$nDebug);
		$this->PDF->SetFont('', '', 14);
		*/
		
		if ($this->Facturas->IdTipofactura) {
			$nPrincipio = 120;
		}
		else {
			$nPrincipio = 110;
		}
		
		// Renglones de órdenes.
		$pos=-1;
		foreach ($aOrdenes as $pos => $item) {
			if ($this->Facturas->IdTipofactura) {
				$this->PDF->SetXY($nX+15, $nY+$nPrincipio+$pos*6);
				$this->PDF->Cell(15,6,1,0,0,'R',$nDebug);
				
				$this->PDF->SetXY($nX+35, $nY+$nPrincipio+$pos*6);
				$this->PDF->Cell(75,6,utf8_decode($item['descripcion_factura']),0,0,'L',$nDebug);
			}
			else {
				$this->PDF->SetXY($nX+15, $nY+$nPrincipio+$pos*6);
				$this->PDF->Cell(75,6,utf8_decode($item['descripcion_factura']),0,0,'L',$nDebug);
			}
			
			
			if ($aFactura['id_tipofactura'] == 2 || $aFactura['id_condicionfiscal'] == 2) { // Factura E o es exento
				$this->PDF->SetXY($nX+146, $nY+$nPrincipio+$pos*6);
				$this->PDF->Cell(20,6,sprintf('%0.2f', round($item['importe'], 2)),0,0,'R',$nDebug);
				
				$this->PDF->SetXY($nX+178, $nY+$nPrincipio+$pos*6);
				$this->PDF->Cell(20,6,sprintf('%0.2f', round($item['importe'], 2)),0,0,'R',$nDebug);
			}
			elseif ($aFactura['id_tipofactura'] == 3) { // Factura A
				$this->PDF->SetXY($nX+146, $nY+$nPrincipio+$pos*6);
				$this->PDF->Cell(20,6,sprintf('%0.2f', round($item['importe'], 2)),0,0,'R',$nDebug);
				
				$this->PDF->SetXY($nX+178, $nY+$nPrincipio+$pos*6);
				$this->PDF->Cell(20,6,sprintf('%0.2f', round($item['importe'], 2)),0,0,'R',$nDebug);
			}
			elseif ($aFactura['id_tipofactura']) { // Factura B
				$this->PDF->SetXY($nX+146, $nY+$nPrincipio+$pos*6);
				$this->PDF->Cell(20,6,sprintf('%0.2f', round($item['importe'] * (Configuracion::ObtenerCampoCargado('iva')/100+1), 2)),0,0,'R',$nDebug);
				
				$this->PDF->SetXY($nX+178, $nY+$nPrincipio+$pos*6);
				$this->PDF->Cell(20,6,sprintf('%0.2f', round($item['importe'] * (Configuracion::ObtenerCampoCargado('iva')/100+1), 2)),0,0,'R',$nDebug);
			}
			else { // Recibo
				$this->PDF->SetXY($nX+178, $nY+$nPrincipio+$pos*6);
				$this->PDF->Cell(20,6,sprintf('%0.2f', round($item['importe'], 2)),0,0,'R',$nDebug);
			}
		}
		
		// Renglones de detalles.
		$nAltura = $nY+$nPrincipio+$pos*6 + 6;
		foreach ($aDetalles as $pos => $item) {
			if ($this->Facturas->IdTipofactura) {
				$this->PDF->SetXY($nX+15, $nY+$nPrincipio+$pos*6);
				$this->PDF->Cell(15,6,1,0,0,'R',$nDebug);
				
				$this->PDF->SetXY($nX+35, $nAltura+$pos*6);
				$this->PDF->Cell(75,6,utf8_decode($item['descripcion']),0,0,'L',$nDebug);
			}
			else {
				$this->PDF->SetXY($nX+15, $nAltura+$pos*6);
				$this->PDF->Cell(75,6,utf8_decode($item['descripcion']),0,0,'L',$nDebug);
			}
			
			
			if ($aFactura['id_tipofactura'] == 2 || $aFactura['id_condicionfiscal'] == 2) { // Factura E o exento
				$this->PDF->SetXY($nX+146, $nAltura+$pos*6);
				$this->PDF->Cell(20,6,sprintf('%0.2f', round($item['importe'], 2)),0,0,'R',$nDebug);
				
				$this->PDF->SetXY($nX+178, $nAltura+$pos*6);
				$this->PDF->Cell(20,6,sprintf('%0.2f', round($item['importe'], 2)),0,0,'R',$nDebug);
			}
			elseif ($aFactura['id_tipofactura'] == 3) { // Factura A
				$this->PDF->SetXY($nX+146, $nAltura+$pos*6);
				$this->PDF->Cell(20,6,sprintf('%0.2f', round($item['importe'], 2)),0,0,'R',$nDebug);
				
				$this->PDF->SetXY($nX+178, $nAltura+$pos*6);
				$this->PDF->Cell(20,6,sprintf('%0.2f', round($item['importe'], 2)),0,0,'R',$nDebug);
			}
			elseif ($aFactura['id_tipofactura']) { // Factura B
				$this->PDF->SetXY($nX+146, $nAltura+$pos*6);
				$this->PDF->Cell(20,6,sprintf('%0.2f', round($item['importe'] * (Configuracion::ObtenerCampoCargado('iva')/100+1), 2)),0,0,'R',$nDebug);
				
				$this->PDF->SetXY($nX+178, $nAltura+$pos*6);
				$this->PDF->Cell(20,6,sprintf('%0.2f', round($item['importe'] * (Configuracion::ObtenerCampoCargado('iva')/100+1), 2)),0,0,'R',$nDebug);
			}
			else { // Recibo
				$this->PDF->SetXY($nX+178, $nAltura+$pos*6);
				$this->PDF->Cell(20,6,sprintf('%0.2f', round($item['importe'], 2)),0,0,'R',$nDebug);
			}
		}
		
		$nUsados = count($aOrdenes) + count($aDetalles);
		
		if ($this->Facturas->IdTipofactura == 4) {
			$nYfinal = 264;
		}
		elseif ($this->Facturas->IdTipofactura) {
			$nYfinal = 235;
		}
		else {
			$nYfinal = 250;
		}
		
		$this->PDF->SetLineWidth(0.3);
		$this->PDF->Line($nX+170, $nY+($nPrincipio+4)+$nUsados*6, $nX+198, $nY+$nYfinal);
		
		$oMomedas = new Monedas();
		$oMomedas->IdMoneda = $aFactura['id_moneda'];
		$oMomedas->Obtener();
		
		$nDif = 0;
		if ($aFactura['id_tipofactura'] == 2) { //Factura E
			// subtotal
			$this->PDF->SetXY($nX+178, $nY+242);
			$this->PDF->Cell(20,6,sprintf('%0.2f', $aFactura['importe']),0,0,'R',$nDebug);
			
			// impuesto
			$this->PDF->SetXY($nX+178, $nY+250);
			$this->PDF->Cell(20,6,sprintf('%0.2f', 0),0,0,'R',$nDebug);
			
			// iva
			$this->PDF->SetXY($nX+178, $nY+258);
			$this->PDF->Cell(20,6,sprintf('%0.2f', 0),0,0,'R',$nDebug);
		}
		elseif ($aFactura['id_tipofactura'] == 3) { //Factura A
			$nDif = 6;
			
			// subtotal
			$this->PDF->SetXY($nX+178, $nY+242+$nDif);
			$this->PDF->Cell(20,6,sprintf('%0.2f', $aFactura['importe']),0,0,'R',$nDebug);
			
			// impuesto
			$this->PDF->SetXY($nX+178, $nY+250+$nDif);
			$this->PDF->Cell(20,6,sprintf('%0.2f', $aFactura['impuesto']),0,0,'R',$nDebug);
			
			// iva
			$this->PDF->SetXY($nX+178, $nY+258+$nDif);
			$this->PDF->Cell(20,6,sprintf('%0.2f', $aFactura['iva']),0,0,'R',$nDebug);
		}
		
		if ($this->Facturas->IdTipofactura) {
			$nYfinal = 266;
		}
		else {
			$nYfinal = 256;
		}
		
		if ($aFactura['id_tipofactura'] == 3) { //Factura A
			$nYfinal += $nDif;
		}
		
		// moneda
		$this->PDF->SetFont('', 'B', 11);
		$this->PDF->SetXY($nX+90, $nY+$nYfinal);
		$this->PDF->Cell(20,6,iconv('UTF-8', 'Windows-1252', "Importe expresado en {$oMomedas->Nombre}"),0,0,'R',$nDebug);
		
		// total
		$this->PDF->SetFont('', 'B', 11);
		$this->PDF->SetXY($nX+178, $nY+$nYfinal);
		$this->PDF->Cell(20,6,sprintf('%0.2f', $aFactura['total']),0,0,'R',$nDebug);
		
		if ($this->Facturas->IdTipofactura) {
			$this->PDF->Output(sprintf("Factura {$aFactura['tipo_factura']} %06d.pdf", $this->Facturas->Comprobante), 'I');
			$this->PDF->Output(sprintf("files/facturas/cola/{$aFactura['tipo_factura']}-%06d.pdf", $this->Facturas->Comprobante), 'F');
		}
		else {
			$this->PDF->Output(sprintf('Recibo %06d.pdf', $this->Facturas->IdFactura), 'I');
			$this->PDF->Output(sprintf('files/facturas/cola/X-%06d.pdf', $this->Facturas->IdFactura), 'F');
		}
		die;
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Facturas->IdFactura = @$_GET['q'];
		$this->Facturas->OrderBy = 'IdFactura';
		$this->Facturas->LimitCant = 50;
		$aDatos = $this->Facturas->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_factura'])."|{$item['id_factura']}\n";
		}
	}
}

include_once('includes/fpdf/fpdf.php');
include_once('includes/fpdi/fpdi.php');

$oCont = new FacturasCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>