<?
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR) && $METHOD != 'x_autocompletar') {
	header("Location: ?p=login");
	die;
}

class FasesCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Fases.
	 *
	 * @var Fases
	 */
	private $Fases;
		
	function __construct() {
		parent::__construct();
		$this->Fases = new Fases();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Fases.
	 *
	 */
	public function listado() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Fases->Nombre = $_GET['nombre'];
			}
		}
		
		if(isset($_GET['alfabetica'])) {
			$this->Fases->PorLetra = $_GET['alfabetica'];
		}
		
		$this->Fases->Page = @$_GET['pg'];
		$this->Fases->OrderBy = 'id_fase';
		$this->Buffer['listado'] = $this->Fases->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Fases->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('fases/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Fases.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Fases y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Fases->IdFase = $_GET['id_fase'];
		$this->Buffer['datos'] = $this->Fases->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Fases.
	 *
	 */
	public function formulario() {
		$this->Buffer['body'] = $this->Template->Load('fases/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Fases.
	 *
	 */
	public function guardar() {
		$this->Fases->IdFase = $_POST['id_fase'];
		$this->Fases->Obtener();
		$this->Fases->Nombre = $_POST['nombre'];
		$this->Fases->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=fases"); }
		die;
	}
		
	/**
	 * @desc
	 * Buscador AJAX de Fases.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Fases->Nombre = $_GET['nombre'];
			}
		}
		
		//$this->Fases->Activo = null;
		$this->Fases->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Fases->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Fases->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('fases/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('fases/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Fases->IdFase = $_POST['id_fase'];
		$this->Fases->Nombre = $_POST['nombre'];
		$this->Fases->Guardar();
		
		echo $this->Fases->IdFase;
	}
	
	/**
	 * @desc
	 * Marca un registro como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Fases->IdFase = $_POST['id_fase'];
		$aData['eliminado'] = $this->Fases->Eliminar();
		
		echo json_encode($aData);
	}
	
	/**
	 * @desc
	 * Devuelve un Fases.
	 *
	 */
	public function x_obtener() {
		$this->Fases->IdFase = $_GET['id_fase'];
		$aDatos = $this->Fases->Obtener();
		
		echo json_encode($aDatos);
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Fases->IdFase = @$_GET['q'];
		$this->Fases->OrderBy = 'IdFase';
		$this->Fases->LimitCant = 50;
		$aDatos = $this->Fases->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_fase'])."|{$item['id_fase']}\n";
		}
	}
}

$oCont = new FasesCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>