<?
class Historial_trabajoCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Historial_trabajo.
	 *
	 * @var Historial_trabajo
	 */
	private $Historial_trabajo;
		
	function __construct() {
		parent::__construct();
		$this->Historial_trabajo = new Historial_trabajo();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Historial_trabajo.
	 *
	 */
	public function listado() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['fecha']) {
				$this->Historial_trabajo->Fecha = date2mysql($_GET['fecha'], '%d/%m/%Y', false);
			}
			if (@$_GET['id_operador']) {
				$this->Historial_trabajo->IdOperador = $_GET['id_operador'];
			}
			if (@$_GET['id_cliente']) {
				$this->Historial_trabajo->IdCliente = $_GET['id_cliente'];
			}
			if (@$_GET['id_proyecto']) {
				$this->Historial_trabajo->IdProyecto = $_GET['id_proyecto'];
			}
			if (@$_GET['tiempo']) {
				$this->Historial_trabajo->Tiempo = $_GET['tiempo'];
			}
			if (@$_GET['nota']) {
				$this->Historial_trabajo->Nota = $_GET['nota'];
			}
		}
		
		$this->Historial_trabajo->Page = @$_GET['pg'];
		$this->Historial_trabajo->OrderBy = 'fecha DESC, id_historial DESC';
		$this->Buffer['listado'] = $this->Historial_trabajo->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Historial_trabajo->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('historial_trabajo/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Historial_trabajo.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Historial_trabajo y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Historial_trabajo->IdHistorial = $_GET['id_historial'];
		$this->Buffer['datos'] = $this->Historial_trabajo->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Historial_trabajo.
	 *
	 */
	public function formulario() {
		$this->Buffer['body'] = $this->Template->Load('historial_trabajo/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Historial_trabajo.
	 *
	 */
	public function guardar() {
		$this->Historial_trabajo->IdHistorial = $_POST['id_historial'];
		$this->Historial_trabajo->Obtener();
		$this->Historial_trabajo->Fecha = date2mysql($_POST['fecha']);
		$this->Historial_trabajo->IdOperador = $_POST['id_operador'];
		$this->Historial_trabajo->IdCliente = $_POST['id_cliente'];
		$this->Historial_trabajo->IdProyecto = $_POST['id_proyecto'];
		$this->Historial_trabajo->Tiempo = '0'.$_POST['tiempo'];
		$this->Historial_trabajo->Nota = $_POST['nota'];
		$this->Historial_trabajo->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=historial_trabajo"); }
		die;
	}
		
	/**
	 * @desc
	 * Buscador AJAX de Historial_trabajo.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['fecha']) {
				$this->Historial_trabajo->Fecha = $_GET['fecha'];
			}
			if (@$_GET['id_operador']) {
				$this->Historial_trabajo->IdOperador = $_GET['id_operador'];
			}
		}
		
		//$this->Historial_trabajo->Activo = null;
		$this->Historial_trabajo->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Historial_trabajo->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Historial_trabajo->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('historial_trabajo/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('historial_trabajo/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		//$this->Historial_trabajo->IdHistorial = $_POST['id_historial'];
		$this->Historial_trabajo->Fecha = date2mysql($_POST['fecha']);
		$this->Historial_trabajo->IdOperador = $_SESSION['operador']['id_operador'];
		$this->Historial_trabajo->IdCliente = $_POST['id_cliente'];
		$this->Historial_trabajo->IdProyecto = $_POST['id_proyecto'];
		$this->Historial_trabajo->Tiempo = '0'.$_POST['tiempo'];
		$this->Historial_trabajo->Nota = @$_POST['nota'];
		$this->Historial_trabajo->Guardar();
		
		echo $this->Historial_trabajo->IdHistorial;
	}
	
	/**
	 * @desc
	 * Marca un registro como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Historial_trabajo->IdHistorial = $_POST['id_historial'];
		$aData['eliminado'] = $this->Historial_trabajo->Eliminar();
		
		echo json_encode($aData);
	}
	
	/**
	 * @desc
	 * Devuelve un Historial_trabajo.
	 *
	 */
	public function x_obtener() {
		$this->Historial_trabajo->IdHistorial = $_GET['id_historial'];
		$aDatos = $this->Historial_trabajo->Obtener();
		
		echo json_encode($aDatos);
	}
	
	public function x_listado() {
	$oHistorial = new Historial_trabajo();
	$oHistorial->IdOperador = $_SESSION['operador']['id_operador'];
	$oHistorial->OrderBy = 'fecha DESC, id_historial DESC';
	$oHistorial->LimitCant = 5;
	$historial = $oHistorial->Buscar();
	?>
	<?foreach ($historial as $item):?>
	<tr>
		<td><?=mysql2date($item['fecha'])?></td>
		<td><?=$item['cliente']?></td>
		<td><?=$item['proyecto']?></td>
		<td>0<?=substr($item['tiempo'], 1, 4)?></td>
		<td></td>
	</tr>
	<?endforeach;?>
	<?
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Historial_trabajo->IdHistorial = @$_GET['q'];
		$this->Historial_trabajo->OrderBy = 'IdHistorial';
		$this->Historial_trabajo->LimitCant = 50;
		$aDatos = $this->Historial_trabajo->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_historial'])."|{$item['id_historial']}\n";
		}
	}
}

$oCont = new Historial_trabajoCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>