<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR, PERMISOS_FACTURACION, PERMISOS_GESTION)) {
	header("Location: ?p=login");
	die;
}

class InformesCtl extends Controller {
	
	public function __construct() {
		parent::__construct();
	}
	
	/**
	 * @desc
	 * Informe de órdenes sin facturar.
	 *
	 */
	public function ordenes() {
		$this->Buffer['body'] = $this->Template->Load('informes/ordenes.tpl.php');
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Generador PDF de órdenes sin facturar.
	 *
	 */
	public function x_ordenes() {
		// Buscar todas las ordenes sin facturar.
		$oOrdenes = new Ordenes();
		$oOrdenes->Desde = date2mysql($_POST['desde'], '%d/%m/%Y', false);
		$oOrdenes->Hasta = date2mysql($_POST['hasta'], '%d/%m/%Y', false);
		if ($_POST['id_cliente']) {
			$oOrdenes->IdCliente = $_POST['id_cliente'];
		}
		$oOrdenes->Facturado = false;
		$oOrdenes->OrderBy = 'fecha, cliente';
		$oOrdenes->LimitCant = null;
		//$oOrdenes->GroupBy = array('select' => 'SUM(importe) importe', 'group'=> 'clientes.id_cliente');
		$aOrdenes = $oOrdenes->Buscar();
		
		// Calcular resumen.
		$aResumen = array('cantidad_ordenes'=>count($aOrdenes), 'importe_total'=>0);
		
		// Componer PDF.
		$nDebug = 0;
		$oPdf = new MyPDFInformes();
		$oPdf->Titulo = "Informe de órdenes sin facturar";
		$oPdf->AddPage();
		$oPdf->SetFont('Arial','',12);
		
		$oPdf->Cell(0,6,utf8_decode("PERÍODO DEL INFORME: {$_POST['desde']} a {$_POST['hasta']}"),$nDebug,0,'C');
		$oPdf->Ln(12);
		
		//Colores, ancho de línea y fuente en negrita
		$oPdf->SetFillColor(120,120,120);
		$oPdf->SetTextColor(255);
		$oPdf->SetDrawColor(80,80,80);
		$oPdf->SetLineWidth(.3);
		$oPdf->SetFont('','B');
		
		//Cabecera
		$oPdf->Cell(20,7,'Fecha',1,0,'C',1);
		$oPdf->Cell(40,7,'Cliente',1,0,'C',1);
		$oPdf->Cell(100,7,'Descripcion',1,0,'C',1);
		$oPdf->Cell(25,7,'Importe',1,0,'C',1);
		$oPdf->Ln();
		
		//Restauración de colores y fuentes
		$oPdf->SetFillColor(224,235,255);
		$oPdf->SetTextColor(0);
		$oPdf->SetFont('', '', 10);
		
		$nFill = false;
		foreach ($aOrdenes as $item) {
			$oPdf->Cell(20,6,mysql2date($item['fecha']),'LR',0,'L',$nFill);
			$oPdf->Cell(40,6,utf8_decode($item['cliente']),'LR',0,'L',$nFill);
			$oPdf->Cell(100,6,utf8_decode($item['descripcion']),'LR',0,'L',$nFill);
			$oPdf->Cell(25,6,sprintf('$ %0.2f', $item['importe']),'LR',0,'R',$nFill);
			$oPdf->Ln();
			
			$nFill = !$nFill;
			$aResumen['importe_total'] += $item['importe'];
		}
		
		$oPdf->SetFillColor(190,190,190);
		$oPdf->Cell(160,6,'IMPORTE TOTAL:',1,0,'R',1);
		$oPdf->Cell(25,6,sprintf('$ %0.2f', $aResumen['importe_total']),1,0,'R',1);
		
		$oPdf->SetAuthor('Estudio Quadra');
		$oPdf->SetTitle('Informe de órdenes');
		$oPdf->SetSubject('Detalle de órdenes', true);
		
		$oPdf->Output("Órdenes.pdf", 'D');
		die;
	}
	
	/**
	 * @desc
	 * Informe de egresos.
	 *
	 */
	public function egresos() {
		$this->Buffer['body'] = $this->Template->Load('informes/egresos.tpl.php');
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Informe de egresos.
	 *
	 */
	public function x_egresos() {
		// Buscar todos los egresos.
		$oEgresos = new Egresos();
		$oEgresos->Desde = date2mysql($_POST['desde'], '%d/%m/%Y', false);
		$oEgresos->Hasta = date2mysql($_POST['hasta'], '%d/%m/%Y', false);
		
		if (@$_POST['computar'] !== '') {
			$oEgresos->Computar = @$_POST['computar'];
		}
		if (@$_POST['deducible'] === '1') {
			$oEgresos->IdTipofactura = true;
		}
		elseif (@$_POST['deducible'] === '0') {
			$oEgresos->IdTipofactura = false;
		}
		if ($_POST['id_tipoegreso']) {
			$oEgresos->IdTipoegreso = $_POST['id_tipoegreso'];
		}
		
		$oEgresos->OrderBy = 'fecha';
		$oEgresos->LimitCant = null;
		$aEgresos = $oEgresos->Buscar();
		
		// Calcular resumen.
		$aResumen = array('cantidad_egresos'=>count($aEgresos), 'importe_total'=>0);
		
		// Componer PDF.
		$nDebug = 0;
		$oPdf = new MyPDFInformes();
		$oPdf->Titulo = "Informe de egresos";
		$oPdf->AddPage();
		$oPdf->SetFont('Arial','',12);
		
		$oPdf->Cell(0,6,utf8_decode("PERÍODO DEL INFORME: {$_POST['desde']} a {$_POST['hasta']}"),$nDebug,0,'C');
		$oPdf->Ln(12);
		
		//Colores, ancho de línea y fuente en negrita
		$oPdf->SetFillColor(120,120,120);
		$oPdf->SetTextColor(255);
		$oPdf->SetDrawColor(80,80,80);
		$oPdf->SetLineWidth(.3);
		$oPdf->SetFont('','B');
		
		//Cabecera
		$oPdf->Cell(20,7,'Fecha',1,0,'C',1);
		//$oPdf->Cell(50,7,'Tipo',1,0,'C',1);
		$oPdf->Cell(140,7,'Descripcion',1,0,'C',1);
		$oPdf->Cell(25,7,'Importe',1,0,'C',1);
		$oPdf->Ln();
		
		//Restauración de colores y fuentes
		$oPdf->SetFillColor(224,235,255);
		$oPdf->SetTextColor(0);
		$oPdf->SetFont('', '', 10);
		
		$nFill = false;
		foreach ($aEgresos as $item) {
			$oPdf->Cell(20,6,mysql2date($item['fecha']),'LR',0,'L',$nFill);
			//$oPdf->Cell(50,6,utf8_decode($item['tipo_egreso']),'LR',0,'L',$nFill);
			$oPdf->Cell(140,6,utf8_decode($item['descripcion']),'LR',0,'L',$nFill);
			$oPdf->Cell(25,6,sprintf('$ %0.2f', $item['total']),'LR',0,'R',$nFill);
			$oPdf->Ln();
			
			$nFill = !$nFill;
			$aResumen['importe_total'] += $item['total'];
		}
		
		$oPdf->SetFillColor(190,190,190);
		$oPdf->Cell(160,6,'IMPORTE TOTAL:',1,0,'R',1);
		$oPdf->Cell(25,6,sprintf('$ %0.2f', $aResumen['importe_total']),1,0,'R',1);
		
		$oPdf->SetAuthor('Estudio Quadra');
		$oPdf->SetTitle('Informe de egresos');
		$oPdf->SetSubject('Detalle de egresos', true);
		
		$oPdf->Output("Egresos.pdf", 'D');
		die;
	}
	
	/**
	 * @desc
	 * Informe de cobranzas.
	 *
	 */
	public function cobranzas() {
		$this->Buffer['body'] = $this->Template->Load('informes/cobranzas.tpl.php');
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Informe de cobranzas.
	 *
	 */
	public function x_cobranzas() {
		// Buscar todas las cobranzas.
		$oCobranzas = new Cobranzas();
		$oCobranzas->Desde = date2mysql($_POST['desde'], '%d/%m/%Y', false);
		$oCobranzas->Hasta = date2mysql($_POST['hasta'], '%d/%m/%Y', false);
		$oCobranzas->OrderBy = 'fecha';
		$oCobranzas->LimitCant = null;
		$aCobranzas = $oCobranzas->Buscar();
		
		// Calcular resumen.
		$aResumen = array('cantidad_cobranzas'=>count($aCobranzas), 'importe_total'=>0);
		
		// Componer PDF.
		$nDebug = 0;
		$oPdf = new MyPDFInformes();
		$oPdf->Titulo = "Informe de cobranzas";
		$oPdf->AddPage();
		$oPdf->SetFont('Arial','',12);
		
		$oPdf->Cell(0,6,utf8_decode("PERÍODO DEL INFORME: {$_POST['desde']} a {$_POST['hasta']}"),$nDebug,0,'C');
		$oPdf->Ln(12);
		
		//Colores, ancho de línea y fuente en negrita
		$oPdf->SetFillColor(120,120,120);
		$oPdf->SetTextColor(255);
		$oPdf->SetDrawColor(80,80,80);
		$oPdf->SetLineWidth(.3);
		$oPdf->SetFont('','B');
		
		//Cabecera
		$oPdf->Cell(20,7,'Fecha',1,0,'C',1);
		$oPdf->Cell(140,7,'Cliente',1,0,'C',1);
		$oPdf->Cell(25,7,'Importe',1,0,'C',1);
		$oPdf->Ln();
		
		//Restauración de colores y fuentes
		$oPdf->SetFillColor(224,235,255);
		$oPdf->SetTextColor(0);
		$oPdf->SetFont('', '', 10);
		
		$oCotizacion = new Cotizaciones();
		
		$nFill = false;
		foreach ($aCobranzas as $item) {
			if ($item['id_moneda'] != 1) {
				// Busca la cotizacion.
				$oCotizacion->IdMoneda = $item['id_moneda'];
				$oCotizacion->Hasta = $item['fecha'];
				$oCotizacion->OrderBy = 'fecha DESC';
				$oCotizacion->LimitCant = 1;
				$aCotizacion = $oCotizacion->Buscar();
				
				$item['cliente'] .= ' (cotiz. '.mysql2date($aCotizacion[0]['fecha']).' x '.sprintf($aCotizacion[0]['formato'], $item['importe']).' a '.$aCotizacion[0]['importe'].')';
				$item['importe'] *= $aCotizacion[0]['importe'];
			}
			
			$oPdf->Cell(20,6,mysql2date($item['fecha']),'LR',0,'L',$nFill);
			$oPdf->Cell(140,6,utf8_decode($item['cliente']),'LR',0,'L',$nFill);
			$oPdf->Cell(25,6,sprintf('$ %0.2f', $item['importe']),'LR',0,'R',$nFill);
			$oPdf->Ln();
			
			$nFill = !$nFill;
			$aResumen['importe_total'] += $item['importe'];
		}
		
		$oPdf->SetFillColor(190,190,190);
		$oPdf->Cell(160,6,'IMPORTE TOTAL:',1,0,'R',1);
		$oPdf->Cell(25,6,sprintf('$ %0.2f', $aResumen['importe_total']),1,0,'R',1);
		
		$oPdf->SetAuthor('Estudio Quadra');
		$oPdf->SetTitle('Informe de cobranzas');
		$oPdf->SetSubject('Detalle de cobranzas', true);
		
		$oPdf->Output("Cobranzas.pdf", 'D');
		die;
	}
	
	/**
	 * @desc
	 * Informe de facturas.
	 *
	 */
	public function facturas() {
		$this->Buffer['body'] = $this->Template->Load('informes/facturas.tpl.php');
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Informe de facturas.
	 *
	 */
	public function x_facturas() {
		// Buscar todas las facturas.
		$oFacturas = new Facturas();
		$oFacturas->Desde = date2mysql($_POST['desde'], '%d/%m/%Y', false);
		$oFacturas->Hasta = date2mysql($_POST['hasta'], '%d/%m/%Y', false);
		$oFacturas->OrderBy = 'fecha';
		$oFacturas->LimitCant = null;
		$aFacturas = $oFacturas->Buscar();
		
		// Calcular resumen.
		$aResumen = array('cantidad_facturas'=>count($aFacturas), 'importe_total'=>0);
		
		// Componer PDF.
		$nDebug = 0;
		$oPdf = new MyPDFInformes();
		$oPdf->Titulo = "Informe de facturación";
		$oPdf->AddPage();
		$oPdf->SetFont('Arial','',12);
		
		$oPdf->Cell(0,6,utf8_decode("PERÍODO DEL INFORME: {$_POST['desde']} a {$_POST['hasta']}"),$nDebug,0,'C');
		$oPdf->Ln(12);
		
		//Colores, ancho de línea y fuente en negrita
		$oPdf->SetFillColor(120,120,120);
		$oPdf->SetTextColor(255);
		$oPdf->SetDrawColor(80,80,80);
		$oPdf->SetLineWidth(.3);
		$oPdf->SetFont('','B');
		
		//Cabecera
		$oPdf->Cell(20,7,'Fecha',1,0,'C',1);
		$oPdf->Cell(140,7,'Cliente',1,0,'C',1);
		$oPdf->Cell(25,7,'Importe',1,0,'C',1);
		$oPdf->Ln();
		
		//Restauración de colores y fuentes
		$oPdf->SetFillColor(224,235,255);
		$oPdf->SetTextColor(0);
		$oPdf->SetFont('', '', 10);
		
		$oCotizacion = new Cotizaciones();
		
		$nFill = false;
		foreach ($aFacturas as $item) {
			if ($item['id_moneda'] != 1) {
				// Busca la cotizacion.
				$oCotizacion->IdMoneda = $item['id_moneda'];
				$oCotizacion->Hasta = $item['fecha'];
				$oCotizacion->OrderBy = 'fecha DESC';
				$oCotizacion->LimitCant = 1;
				$aCotizacion = $oCotizacion->Buscar();
				
				$item['cliente'] .= ' (cotiz. '.mysql2date($aCotizacion[0]['fecha']).' x '.sprintf(utf8_decode($aCotizacion[0]['formato']), $item['importe']).' a '.$aCotizacion[0]['importe'].')';
				$item['total'] *= $aCotizacion[0]['importe'];
			}
			
			$oPdf->Cell(20,6,mysql2date($item['fecha']),'LR',0,'L',$nFill);
			$oPdf->Cell(140,6,utf8_decode($item['cliente']),'LR',0,'L',$nFill);
			$oPdf->Cell(25,6,sprintf('$ %0.2f', $item['total']),'LR',0,'R',$nFill);
			$oPdf->Ln();
			
			$nFill = !$nFill;
			$aResumen['importe_total'] += $item['total'];
		}
		
		$oPdf->SetFillColor(190,190,190);
		$oPdf->Cell(160,6,'IMPORTE TOTAL:',1,0,'R',1);
		$oPdf->Cell(25,6,sprintf('$ %0.2f', $aResumen['importe_total']),1,0,'R',1);
		
		$oPdf->SetAuthor('Estudio Quadra');
		$oPdf->SetTitle('Informe de facturacion');
		$oPdf->SetSubject('Detalle de facturacion', true);
		
		$oPdf->Output("Facturación.pdf", 'D');
		die;
	}
	
	/**
	 * @desc
	 * Informe de liquidez.
	 *
	 */
	public function liquidez() {
		$this->Buffer['body'] = $this->Template->Load('informes/liquidez.tpl.php');
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Informe de liquidez.
	 *
	 */
	public function x_liquidez() {
		// Buscar saldo de las cobranzas.
		$oCobranzas = new Cobranzas();
		$oCobranzas->Desde = date2mysql($_POST['desde'], '%d/%m/%Y', false);
		$oCobranzas->Hasta = date2mysql($_POST['hasta'], '%d/%m/%Y', false);
		$nCobranzas = $oCobranzas->SaldoGeneral();
		
		// Buscar saldo de los egresos.
		$oEgresos = new Egresos();
		$oEgresos->Desde = date2mysql($_POST['desde'], '%d/%m/%Y', false);
		$oEgresos->Hasta = date2mysql($_POST['hasta'], '%d/%m/%Y', false);
		$nEgresos = $oEgresos->Saldo();
		
		// Buscar saldo de las facturas.
		$oFacturas = new Facturas();
		$oFacturas->Desde = date2mysql($_POST['desde'], '%d/%m/%Y', false);
		$oFacturas->Hasta = date2mysql($_POST['hasta'], '%d/%m/%Y', false);
		$nFacturas = $oFacturas->Saldo();
		
		// Buscar saldo de las ordenes.
		$oOrdenes = new Ordenes();
		$oOrdenes->Desde = date2mysql($_POST['desde'], '%d/%m/%Y', false);
		$oOrdenes->Hasta = date2mysql($_POST['hasta'], '%d/%m/%Y', false);
		$nOrdenes = $oOrdenes->Saldo();
		
		// Componer PDF.
		$nDebug = 0;
		$oPdf = new MyPDFInformes();
		$oPdf->Titulo = "Informe de liquidez";
		$oPdf->AddPage();
		$oPdf->SetFont('Arial','',12);
		
		$oPdf->Cell(0,6,utf8_decode("PERÍODO DEL INFORME: {$_POST['desde']} a {$_POST['hasta']}"),$nDebug,0,'C');
		$oPdf->Ln(12);
		
		//Colores, ancho de línea y fuente en negrita
		$oPdf->SetLineWidth(.3);
		$oPdf->SetFillColor(224,235,255);
		$oPdf->SetTextColor(0);
		$oPdf->SetFont('', '', 10);
		
		//Datos
		$oPdf->Cell(40,7,'Egresos',1,0,'R',0);
		$oPdf->Cell(40,7,sprintf('%0.2f', $nEgresos),1,0,'R',0);
		$oPdf->Ln();
		$oPdf->Cell(40,7,'Cobranzas',1,0,'R',1);
		$oPdf->Cell(40,7,sprintf('%0.2f', $nCobranzas),1,0,'R',1);
		$oPdf->Cell(40,7,'Liquidez',1,0,'R',1);
		$oPdf->Cell(40,7,sprintf('%0.2f', $nCobranzas - $nEgresos),1,0,'R',1);
		$oPdf->Ln();
		$oPdf->Cell(40,7,'Facturas',1,0,'R',0);
		$oPdf->Cell(40,7,sprintf('%0.2f', $nFacturas),1,0,'R',0);
		$oPdf->Ln();
		$oPdf->Cell(40,7,'Ordenes',1,0,'R',0);
		$oPdf->Cell(40,7,sprintf('%0.2f', $nOrdenes),1,0,'R',0);
		$oPdf->Ln();
		/*
		//Restauración de colores y fuentes
		$oPdf->SetFillColor(224,235,255);
		$oPdf->SetTextColor(0);
		$oPdf->SetFont('', '', 10);
		
		$oCotizacion = new Cotizaciones();
		
		$nFill = false;
		foreach ($aFacturas as $item) {
			if ($item['id_moneda'] != 1) {
				// Busca la cotizacion.
				$oCotizacion->IdMoneda = $item['id_moneda'];
				$oCotizacion->Hasta = $item['fecha'];
				$oCotizacion->OrderBy = 'fecha DESC';
				$oCotizacion->LimitCant = 1;
				$aCotizacion = $oCotizacion->Buscar();
				
				$item['cliente'] .= ' (cotiz. '.mysql2date($aCotizacion[0]['fecha']).' x '.sprintf($aCotizacion[0]['formato'], $item['importe']).' a '.$aCotizacion[0]['importe'].')';
				$item['importe'] *= $aCotizacion[0]['importe'];
			}
			
			$oPdf->Cell(20,6,mysql2date($item['fecha']),'LR',0,'L',$nFill);
			$oPdf->Cell(140,6,utf8_decode($item['cliente']),'LR',0,'L',$nFill);
			$oPdf->Cell(25,6,sprintf('$ %0.2f', $item['importe']),'LR',0,'R',$nFill);
			$oPdf->Ln();
			
			$nFill = !$nFill;
			$aResumen['importe_total'] += $item['importe'];
		}
		
		$oPdf->SetFillColor(190,190,190);
		$oPdf->Cell(160,6,'IMPORTE TOTAL:',1,0,'R',1);
		$oPdf->Cell(25,6,sprintf('$ %0.2f', $aResumen['importe_total']),1,0,'R',1);
		*/
		$oPdf->SetAuthor('Estudio Quadra');
		$oPdf->SetTitle('Informe de liquidez');
		$oPdf->SetSubject('Detalle de liquidez', true);
		
		$oPdf->Output("Liquidez.pdf", 'D');
		die;
	}
	
	/**
	 * @desc
	 * Informe para facturacion.
	 *
	 */
	public function para_facturacion() {
		$this->Buffer['body'] = $this->Template->Load('informes/para-facturacion.tpl.php');
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Informe de liquidez.
	 *
	 */
	public function x_para_facturacion() {
		// Suma importes de órdenes no facturadas agrupado por cliente.
		$oOrdenes = new Ordenes();
		$aOrdenes = $oOrdenes->BuscarDeudas();
		
		// Componer PDF.
		$nDebug = 0;
		$oPdf = new MyPDFInformes();
		$oPdf->Titulo = "Informe de órdenes sin facturar";
		$oPdf->AddPage();
		$oPdf->SetFont('Arial','',12);
		
		$oPdf->Cell(0,6,utf8_decode("PERÍODO DEL INFORME: COMPLETO"),$nDebug,0,'C');
		$oPdf->Ln(12);
		
		//Colores, ancho de línea y fuente en negrita
		$oPdf->SetFillColor(120,120,120);
		$oPdf->SetTextColor(255);
		$oPdf->SetDrawColor(80,80,80);
		$oPdf->SetLineWidth(.3);
		$oPdf->SetFont('','B');
		
		//Cabecera
		$oPdf->Cell(80,7,'Cliente',1,0,'C',1);
		$oPdf->Cell(80,7,'Telefono',1,0,'C',1);
		$oPdf->Cell(25,7,'Importe',1,0,'C',1);
		$oPdf->Ln();
		
		//Restauración de colores y fuentes
		$oPdf->SetFillColor(224,235,255);
		$oPdf->SetTextColor(0);
		$oPdf->SetFont('', '', 10);
		
		$aResumen['importe_total'] = 0;
		$nFill = false;
		foreach ($aOrdenes as $item) {
			$oPdf->Cell(80,6,utf8_decode($item['nombre']),'LR',0,'L',$nFill);
			$oPdf->Cell(80,6,utf8_decode($item['telefono']),'LR',0,'L',$nFill);
			$oPdf->Cell(25,6,sprintf('$ %0.2f', $item['total']),'LR',0,'R',$nFill);
			$oPdf->Ln();
			
			$nFill = !$nFill;
			$aResumen['importe_total'] += $item['total'];
		}
		
		$oPdf->SetFillColor(190,190,190);
		$oPdf->Cell(160,6,'IMPORTE TOTAL:',1,0,'R',1);
		$oPdf->Cell(25,6,sprintf('$ %0.2f', $aResumen['importe_total']),1,0,'R',1);
		
		$oPdf->SetAuthor('Estudio Quadra');
		$oPdf->SetTitle('Informe para facturacion');
		$oPdf->SetSubject('Detalle para facturacion', true);
		
		$oPdf->Output("Órdenes sin facturar por cliente.pdf", 'D');
		die;
	}

	/**
	 * @desc
	 * Informe de facturado y no pagado.
	 *
	 */
	public function cuentas_corrientes() {
		$this->Buffer['body'] = $this->Template->Load('informes/cuentas_corrientes.tpl.php');
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Informe de facturado y no pagado.
	 *
	 */
	public function x_cuentas_corrientes() {
		// Suma importes de facturas no cobradas agrupado por cliente.
		$oCuentasCorrientes = new CuentasCorrientes();
		$oCuentasCorrientes->Saldos = true;
		$oCuentasCorrientes->OrderBy = 'cliente';
		$aDeudas = $oCuentasCorrientes->Buscar();
		
		// Componer PDF.
		$nDebug = 0;
		$oPdf = new MyPDFInformes();
		$oPdf->Titulo = "Informe de cuentas corrientes de clientes";
		$oPdf->AddPage();
		$oPdf->SetFont('Arial','',12);
		
		$oPdf->Cell(0,6,utf8_decode("PERÍODO DEL INFORME: COMPLETO"),$nDebug,0,'C');
		$oPdf->Ln(12);
		
		//Colores, ancho de línea y fuente en negrita
		$oPdf->SetFillColor(120,120,120);
		$oPdf->SetTextColor(255);
		$oPdf->SetDrawColor(80,80,80);
		$oPdf->SetLineWidth(.3);
		$oPdf->SetFont('','B');
		
		//Cabecera
		$oPdf->Cell(160,7,'Cliente',1,0,'C',1);
		$oPdf->Cell(25,7,'Saldo',1,0,'C',1);
		$oPdf->Ln();
		
		//Restauración de colores y fuentes
		$oPdf->SetFillColor(224,235,255);
		$oPdf->SetTextColor(0);
		$oPdf->SetFont('', '', 10);
		
		$aResumen['saldo_total'] = 0;
		$nFill = false;
		foreach ($aDeudas as $item) {
			$oPdf->Cell(160,6,utf8_decode($item['cliente']),'LR',0,'L',$nFill);
			
			if ($item['saldo'] < 0) {
				$oPdf->SetTextColor(220, 0, 0);
			}
			$oPdf->Cell(25,6,sprintf('$ %0.2f', $item['saldo']),'LR',0,'R',$nFill);
			$oPdf->SetTextColor(0);
			
			$oPdf->Ln();
			
			$nFill = !$nFill;
			$aResumen['saldo_total'] += $item['saldo'];
		}
		
		$oPdf->SetFillColor(190,190,190);
		$oPdf->Cell(160,6,'SALDO TOTAL:',1,0,'R',1);
		$oPdf->Cell(25,6,sprintf('$ %0.2f', $aResumen['saldo_total']),1,0,'R',1);
		
		$oPdf->SetAuthor('Estudio Quadra');
		$oPdf->SetTitle('Informe de cuentas corrientes');
		//$oPdf->SetSubject('Detalle para facturacion', true);
		
		$oPdf->Output("Cta Cte por cliente.pdf", 'D');
		die;
	}
	
	/**
	 * @desc
	 * Informe de carga laboral por fase.
	 *
	 */
	public function carga_fases() {
		$this->Buffer['body'] = $this->Template->Load('informes/carga_fases.tpl.php');
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * PDF de carga laboral por fase.
	 *
	 */
	public function x_carga_fases() {
		$oFases = new Fases();
		
		//$oFases->LimitCant = null;
		if ($_GET['sector'] != 0) {
			
		}
		
		$oFases->IdFase = $_GET['sector'];
		$this->Buffer['fases'][] = $oFases->Obtener();
		$this->Buffer['fecha'] = date2mysql($_GET['fecha'], '%d/%m/%Y', false);
		
		echo $this->Buffer['body'] = $this->Template->Load('informes/x-carga-fases.tpl.php', $this->Buffer);
	}
	
	/**
	 * Línea de producción.
	 *
	 */
	public function linea_produccion() {
		$this->Buffer['css']['#cuerpo']['width'] = '1400px';
		$this->Buffer['css']['#area-activa']['width'] = '100%';
		
		$this->Buffer['body'] = $this->Template->Load('informes/linea-produccion.tpl.php');
		if (isset($_GET['guardar'])) {
			file_put_contents(sprintf('files/produccion/%s', date('Y-m-d Hi')).'.html', $this->Buffer['body']);
			return;
		}
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Informe de ventas.
	 *
	 */
	public function ventas() {
		$this->Buffer['body'] = $this->Template->Load('informes/ventas.tpl.php');
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Informe PDF de ventas.
	 *
	 */
	public function x_ventas() {
		// Buscar todas las ventas.
		$oVentas = new Ventas();
		$oVentas->Desde = date2mysql($_POST['desde'], '%d/%m/%Y', false);
		$oVentas->Hasta = date2mysql($_POST['hasta'], '%d/%m/%Y', false);
		if ($_POST['id_comercial']) {
			$oVentas->IdComercial = $_POST['id_comercial'];
		}
		else {
			$oVentas->AgruparComercial = true;
			//$oVentas->IdComercial = $_POST['id_comercial'];
			$oVentas->GroupBy = 'ventas.id_comercial';
		}
		$oVentas->OrderBy = 'fecha';
		$oVentas->LimitCant = null;
		$aVentas = $oVentas->Buscar();
		
		// Calcular resumen.
		$aResumen = array('cantidad_egresos'=>count($aVentas), 'importe_total'=>0);
		
		// Componer PDF.
		$nDebug = 0;
		$oPdf = new MyPDFInformes();
		$oPdf->Titulo = "Informe de ventas";
		$oPdf->AddPage();
		$oPdf->SetFont('Arial','',12);
		
		$oPdf->Cell(0,6,utf8_decode("PERÍODO DEL INFORME: {$_POST['desde']} a {$_POST['hasta']}"),$nDebug,0,'C');
		$oPdf->Ln(12);
		
		//Colores, ancho de línea y fuente en negrita
		$oPdf->SetFillColor(120,120,120);
		$oPdf->SetTextColor(255);
		$oPdf->SetDrawColor(80,80,80);
		$oPdf->SetLineWidth(.3);
		$oPdf->SetFont('','B');
		
		//Cabecera
		$oPdf->Cell(20,7,'Fecha',1,0,'C',1);
		$oPdf->Cell(50,7,'Comercial',1,0,'C',1);
		$oPdf->Cell(90,7,'Cliente',1,0,'C',1);
		$oPdf->Cell(25,7,'Importe',1,0,'C',1);
		$oPdf->Ln();
		
		//Restauración de colores y fuentes
		$oPdf->SetFillColor(224,235,255);
		$oPdf->SetTextColor(0);
		$oPdf->SetFont('', '', 10);
		
		$nFill = false;
		foreach ($aVentas as $item) {
			if ($_POST['id_comercial']) {
				$oPdf->Cell(20,6,mysql2date($item['fecha']),'LR',0,'L',$nFill);
				$oPdf->Cell(50,6,utf8_decode($item['comercial']),'LR',0,'L',$nFill);
				$oPdf->Cell(90,6,utf8_decode($item['cliente']),'LR',0,'L',$nFill);
			}
			else {
				$oPdf->Cell(20,6,"--/--/----",'LR',0,'L',$nFill);
				$oPdf->Cell(50,6,utf8_decode($item['comercial']),'LR',0,'L',$nFill);
				$oPdf->Cell(90,6,utf8_decode('VARIOS'),'LR',0,'L',$nFill);
			}
			
			
			
			$oPdf->Cell(25,6,sprintf('$ %0.2f', $item['importe']),'LR',0,'R',$nFill);
			$oPdf->Ln();
			
			$nFill = !$nFill;
			$aResumen['importe_total'] += $item['importe'];
		}
		
		$oPdf->SetFillColor(190,190,190);
		$oPdf->Cell(160,6,'IMPORTE TOTAL:',1,0,'R',1);
		$oPdf->Cell(25,6,sprintf('$ %0.2f', $aResumen['importe_total']),1,0,'R',1);
		
		$oPdf->SetAuthor('Estudio Quadra');
		$oPdf->SetTitle('Informe de ventas');
		$oPdf->SetSubject('Detalle de ventas', true);
		
		$oPdf->Output("Ventas.pdf", 'D');
		die;
	}
	
	/**
	 * Informe de historial de producción.
	 *
	 * @param bool $nNoVista
	 */
	public function historial_produccion($nNoVista=false) {
		$oDB = new Dbconnection();
		
		
		$cDesde = @$_GET['desde'] ? date2mysql($_GET['desde']) : date('Y-m-d', time() - 60*60*24*60);
		$cHasta = @$_GET['desde'] ? date2mysql($_GET['hasta']) : date('Y-m-d', time() + 60*60*24);
		
		$cSql = 
		"
		SELECT
			his.fecha,
			fases.id_fase,
			fases.nombre fase,
			det.id_estado,
			COUNT(det.id_proyecto) cantidad
		FROM 
			historial_produccion his
			LEFT JOIN detalles_historialproduccion det ON 
				det.id_historial = his.id_historial
			LEFT JOIN fases ON 
				fases.id_fase = det.id_fase
		WHERE his.fecha BETWEEN '{$cDesde}' AND '{$cHasta}'
		GROUP BY
			det.id_historial, det.id_fase, det.id_estado
		ORDER BY his.fecha, fases.id_fase, det.id_estado
		";
		$oDB->Query($cSql);
		$this->Buffer['datos'] = $oDB->GetRecordset();
		
		if ($nNoVista) {return;}
		
		$this->Buffer['body'] = $this->Template->Load('informes/historial-produccion.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * Gráfico de historial de producción.
	 *
	 */
	public function x_ofc_historial_produccion() {
		$aData = array();
		
		
		$cDesde = @$_GET['desde'] ? date2mysql($_GET['desde']) : date('Y-m-d', time() - 60*60*24*60);
		$cHasta = @$_GET['desde'] ? date2mysql($_GET['hasta']) : date('Y-m-d', time() + 60*60*24);
		
		$cSql = 
		"
		SELECT
			his.fecha,
			fases.id_fase,
			fases.nombre fase,
			det.id_estado,
			COUNT(det.id_proyecto) cantidad
		FROM 
			historial_produccion his
			LEFT JOIN detalles_historialproduccion det ON 
				det.id_historial = his.id_historial
			LEFT JOIN fases ON 
				fases.id_fase = det.id_fase
		WHERE (his.fecha BETWEEN '{$cDesde}' AND '{$cHasta}')
		GROUP BY
			det.id_historial, det.id_fase
		ORDER BY his.fecha, fases.id_fase, det.id_estado
		";
		$oDB = new Dbconnection();
		$oDB->Query($cSql);
		$this->Buffer['datos'] = $oDB->GetRecordset();
		
		$aData['title'] = array('text' => 'GRÁFICO DE HISTORIAL', 'style' => 'font-size: 14px; color: #56789D; font-weight: bold;');
		$aData['y_legend'] = array('text' => 'Proyectos', 'style' => 'color: #56789D;');
		
		$aValores = array();
		foreach ($this->Buffer['datos'] as $item) {
			$aValores[$item['fase']][] = (int)$item['cantidad'];
			$aFechas[$item['fase']][] = mysql2date($item['fecha']);
		}
		
		$aData['elements'][] = array(
			'type' => 'line',
			'colour' => '#990099',
			'text' => 'Análisis',
			'font-size' => 10,
			'width' => 2,
			'values' => $aValores['ANALISIS'],
		);
		$aData['elements'][] = array(
			'type' => 'line',
			'colour' => '#990000',
			'text' => 'Diseño',
			'font-size' => 10,
			'width' => 2,
			'values' => $aValores['DISEÑO'],
		);
		$aData['elements'][] = array(
			'type' => 'line',
			'colour' => '#009900',
			'text' => 'Maquetación',
			'font-size' => 10,
			'width' => 2,
			'values' => $aValores['MAQUETACION'],
		);
		$aData['elements'][] = array(
			'type' => 'line',
			'colour' => '#000099',
			'text' => 'Programación',
			'font-size' => 10,
			'width' => 2,
			'values' => $aValores['PROGRAMACION'],
		);
		
		$aData['x_axis']['labels']['rotate'] = '30';
		$aData['x_axis']['labels']['steps'] = 5;
		$aData['x_axis']['labels']['labels'] = $aFechas['ANALISIS'];
		
		$aData['y_axis']['min'] = 0;
		$aData['y_axis']['max'] = 50;
		$aData['y_axis']['steps'] = 5;
		
		echo json_encode($aData);
		die;
		?>
		{
			"y_legend":{
				"text":   "Time of day",
				"style": "{color: #736AFF;}"
			},
		
			"elements":[
				{
					"type":      "line",
					"colour":    "#736AFF",
					"text":      "Avg. wave height (cm)",
					"font-size": 10,
					"width":     2,
					"values" :   [
						1.5,1.69,1.88,2.06,2.21,2.34,2.43,
						2.48,2.49,2.47,2.40,2.30,2.17,2.01,
						1.83,1.64,1.44,1.24,1.05,0.88,0.74,
						0.62,0.54,0.50,0.50,0.54,0.61,0.72,
						0.86,1.03,1.22,1.41,1.61,1.81,1.99,
						2.15,2.29,2.39,2.46,2.49,2.48,
						{"value":2.44,"colour":"#FF0000","tip":"monkies"},
						2.35,2.23,2.08
					]
				}
			],
		
			"x_axis":{
				"labels": {
					"rotate": "vertical",
					"labels":["2:00am % £","2:10","2:20","2:30","2:40","2:50",
					"3:00am","3:10","3:20","3:30","3:40","3:50",
					"4:00am","4:10","4:20","4:30","4:40","4:50",
					"5:00am","5:10","5:20","5:30","5:40","5:50",
					"6:00am","6:10","6:20","6:30","6:40","6:50",
					"7:00am","7:10","7:20","7:30","7:40","7:50",
					"8:00am","8:10","8:20","8:30","8:40","8:50",
					"9:00am","9:10","9:20"]
				}
			},
		
			"y_axis__":{
				"max":   3
			}
		
		}
		<?
	}
	
	/**
	 * Informe de historial de trabajo.
	 *
	 * @param bool $nNoVista
	 */
	public function historial_trabajo($nNoVista=false) {
		$this->Buffer['body'] = $this->Template->Load('informes/historial-trabajo.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Informe PDF de historial de trabajo.
	 *
	 */
	public function x_historial_trabajo() {
		require_once(APP_FUNCTIONS_PATH.'/date_functions.php');
		
		// Obtiene datos.
		$oHistorial = new Historial_trabajo();
		
		if ($_POST['id_operador']) {
			$oHistorial->IdOperador = $_POST['id_operador'];
		}
		if ($_POST['id_cliente']) {
			$oHistorial->IdCliente = $_POST['id_cliente'];
		}
		if ($_POST['id_proyecto']) {
			$oHistorial->IdProyecto = $_POST['id_proyecto'];
		}
		if ($_POST['desde']) {
			$oHistorial->Desde = date2mysql($_POST['desde'], '%d/%m/%Y', false);
		}
		if ($_POST['hasta']) {
			$oHistorial->Hasta = date2mysql($_POST['hasta'], '%d/%m/%Y', false);
		}
		
		if ($_POST['modo'] == 'por_operador') {
			$oHistorial->PorOperador = true;
			$oHistorial->OrderBy = 'cliente';
		}
		else {
			$oHistorial->OrderBy = 'fecha';
		}
		
		$oHistorial->LimitCant = null;
		
		$aListado = $oHistorial->Buscar();
		
		// Componer PDF.
		$nDebug = 0;
		$oPdf = new MyPDFInformes();
		$oPdf->IsUTF = true;
		$oPdf->Titulo = "Informe de historial de trabajo";
		$oPdf->AddPage();
		$oPdf->SetFont('Arial','',12);
		
		$cTexto = '';
		if ($_POST['desde']) {
			$cTexto .= "desde {$_POST['desde']} ";
		}
		if ($_POST['hasta']) {
			$cTexto .= "hasta {$_POST['hasta']} ";
		}
		
		if ($cTexto) {
			$oPdf->Cell(0,6,"PERÍODO DEL INFORME: {$cTexto}",$nDebug,0,'C');
			$oPdf->Ln(12);
		}
		
		//Colores, ancho de línea y fuente en negrita
		$oPdf->SetFillColor(120,120,120);
		$oPdf->SetTextColor(255);
		$oPdf->SetDrawColor(80,80,80);
		$oPdf->SetLineWidth(.3);
		$oPdf->SetFont('','B');
		
		//Cabecera
		if ($_POST['modo'] == 'por_operador') {
			$oPdf->Cell(40,7,'Operador',1,0,'C',1);
			$oPdf->Cell(65,7,'Cliente',1,0,'C',1);
			$oPdf->Cell(60,7,'Proyecto',1,0,'C',1);
			$oPdf->Cell(20,7,'Tiempo',1,0,'C',1);
		}
		else {
			$oPdf->Cell(20,7,'Fecha',1,0,'C',1);
			$oPdf->Cell(40,7,'Operador',1,0,'C',1);
			$oPdf->Cell(50,7,'Cliente',1,0,'C',1);
			$oPdf->Cell(60,7,'Proyecto',1,0,'C',1);
			$oPdf->Cell(15,7,'Horas',1,0,'C',1);
		}
		$oPdf->Ln();
		
		//Restauración de colores y fuentes
		$oPdf->SetFillColor(224,235,255);
		$oPdf->SetTextColor(0);
		$oPdf->SetFont('', '', 10);
		
		$nFill = false;
		$aResumen['tiempo_totalizado'] = 0;
		foreach ($aListado as $item) {
			if ($_POST['modo'] == 'por_operador') {
				$oPdf->Cell(40,6,$item['operador'],'LR',0,'L',$nFill);
				$oPdf->Cell(65,6,$item['cliente'],'LR',0,'L',$nFill);
				$oPdf->Cell(60,6,$item['proyecto'],'LR',0,'L',$nFill);
				$oPdf->Cell(20,6,sec2time($item['tiempo_total']),'LR',0,'R',$nFill);
				$aResumen['tiempo_totalizado'] += $item['tiempo_total'];
			}
			else {
				$oPdf->Cell(20,6,mysql2date($item['fecha']),'LR',0,'L',$nFill);
				$oPdf->Cell(40,6,$item['operador'],'LR',0,'L',$nFill);
				$oPdf->Cell(50,6,$item['cliente'],'LR',0,'L',$nFill);
				$oPdf->Cell(60,6,$item['proyecto'],'LR',0,'L',$nFill);
				$oPdf->Cell(15,6,sec2time($item['segundos']),'LR',0,'R',$nFill);
				$aResumen['tiempo_totalizado'] += $item['segundos'];
			}
			
			$oPdf->Ln();
			$nFill = !$nFill;
		}
		
		$oPdf->SetFillColor(190,190,190);
		if ($_POST['modo'] == 'por_operador') {
			$oPdf->Cell(165,6,'TIEMPO TOTAL:',1,0,'R',1);
			$oPdf->Cell(20,6,sec2time($aResumen['tiempo_totalizado']),1,0,'R',1);
		}
		else {
			$oPdf->Cell(170,6,'TIEMPO TOTAL:',1,0,'R',1);
			$oPdf->Cell(15,6,sec2time($aResumen['tiempo_totalizado']),1,0,'R',1);
		}
		
		$oPdf->SetAuthor('Estudio Quadra');
		$oPdf->SetTitle('Informe de historial de trabajo');
		$oPdf->SetSubject('Detalle de historial de trabajo', true);
		
		$oPdf->Output("Historial de trabajo.pdf", 'D');
		die;
	}
	
	/**
	 * Situación general.
	 *
	 */
	public function estado_general() {
		$oDb = new Dbconnection();
		
		$cInicio = date('Y-m-01', mktime(null, null, null, date('m')-4, 1));
		$cFinal = date('Y-m-d', mktime(null, null, null, date('m'), 0));
		$cSql = "SELECT SUM(egresos.total) / 4 promedio FROM egresos WHERE egresos.fecha BETWEEN '{$cInicio}' AND '{$cFinal}'";
		$oDb->Query($cSql);
		$this->Buffer['promedio_gasto'] = $oDb->Field('promedio');
		
		$this->Buffer['ordenes_desde'] = $cInicio = date('Y-m-01', mktime(null, null, null, date('m'), 1));
		$this->Buffer['ordenes_hasta'] = $cFinal = date('Y-m-d', mktime(null, null, null, date('m')+1, 0));
		$cSql = "SELECT SUM(ordenes.importe) total FROM ordenes WHERE ordenes.fecha BETWEEN '{$cInicio}' AND '{$cFinal}'";
		$oDb->Query($cSql);
		$this->Buffer['ordenes'] = $oDb->Field('total');
		
		$this->Buffer['facturas_desde'] = $cInicio = date('Y-m-01', mktime(null, null, null, date('m'), 1));
		$this->Buffer['facturas_hasta'] = $cFinal = date('Y-m-d', mktime(null, null, null, date('m')+1, 0));
		$cSql = "SELECT SUM(facturas.total) total FROM facturas WHERE facturas.fecha BETWEEN '{$cInicio}' AND '{$cFinal}'";
		$oDb->Query($cSql);
		$this->Buffer['facturas'] = $oDb->Field('total');
		
		$this->Buffer['cobranzas_desde'] = $cInicio = date('Y-m-01', mktime(null, null, null, date('m'), 1));
		$this->Buffer['cobranzas_hasta'] = $cFinal = date('Y-m-d', mktime(null, null, null, date('m')+1, 0));
		$cSql = "SELECT SUM(cobranzas.importe) total FROM cobranzas INNER JOIN elementos ON elementos.id_entidad = cobranzas.id_cobranza AND elementos.id_tipoelemento = ".ELEMENTOS_COBRANZA." AND elementos.eliminado = 0 WHERE cobranzas.fecha BETWEEN '{$cInicio}' AND '{$cFinal}'";
		$oDb->Query($cSql);
		$this->Buffer['cobranzas'] = $oDb->Field('total');
		
		$this->Buffer['body'] = $this->Template->Load('informes/estado-general.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * Informe genérico de cosas varias (GABO).
	 *
	 */
	public function varios() {
		$oDb = new Dbconnection();
		
		$this->Buffer['a_maquetacion']['meses'] = 3;
		$this->Buffer['a_maquetacion']['inicio'] = date('Y-m-01', mktime(null, null, null, date('m')-($this->Buffer['a_maquetacion']['meses']-1), 1));
		$this->Buffer['a_maquetacion']['final'] = date('Y-m-d', mktime(null, null, null, date('m')+($this->Buffer['a_maquetacion']['meses']-2), 0));
		
		
		$cSql = "
			SELECT det.*, his.fecha 
			FROM detalles_historialproduccion det
				INNER JOIN historial_produccion his ON his.id_historial = det.id_historial
			WHERE (his.fecha BETWEEN '{$this->Buffer['a_maquetacion']['inicio']}' AND '{$this->Buffer['a_maquetacion']['final']}') AND det.id_fase = 3
			ORDER BY his.fecha
			";
		$oDb->Query($cSql);
		
		$aPrimeras = array();
		$aRestantes = array();
		$aTodas = array();
		$aUltima = array();
		$nIdHis = null;
		$nAct = null;
		
		while ($item = $oDb->Field()) {
			if ($nIdHis == null) {
				$nIdHis = $item['id_historial'];
			}
			
			if ($nIdHis == $item['id_historial']) {
				$aPrimeras[$item['id_proyecto']] = $item;
			}
			else {
				if (!isset($aRestantes[$item['id_proyecto']])) {
					$aRestantes[$item['id_proyecto']] = $item;
				}
			}
			
			if (!isset($aTodas[$item['id_proyecto']])) {
				$aTodas[$item['id_proyecto']] = $item;
			}
			
			if ($nAct != $item['id_historial']) {
				$aUltima = array();
				$nAct = $item['id_historial'];
			}
			$aUltima[$item['id_proyecto']] = $item;
		}
		
		$this->Buffer['a_maquetacion']['todas'] = $aTodas;
		$this->Buffer['a_maquetacion']['al_inicio'] = $aPrimeras;
		$this->Buffer['a_maquetacion']['al_final'] = $aUltima;
		$this->Buffer['a_maquetacion']['entraron'] = array_diff_key($this->Buffer['a_maquetacion']['todas'], $this->Buffer['a_maquetacion']['al_inicio']);
		$this->Buffer['a_maquetacion']['salieron'] = array_diff_key($this->Buffer['a_maquetacion']['todas'], $this->Buffer['a_maquetacion']['al_final']);
		
		
		$this->Buffer['body'] = $this->Template->Load('informes/varios.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Informe de libro de IVA.
	 *
	 */
	public function iva() {
		$this->Buffer['body'] = $this->Template->Load('informes/iva.tpl.php');
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Generador PDF de libro de iva.
	 *
	 */
	public function x_iva() {
		// Período indicado.
		$this->Buffer['desde'] = $_POST['desde'];
		$this->Buffer['hasta'] = $_POST['hasta'];
		$cDesde = date2mysql($_POST['desde'], '%d/%m/%Y', false);
		$cHasta = date2mysql($_POST['hasta'], '%d/%m/%Y', false);
		
		// Busca la facturacion dentro del período.
		$oFacturas = new Facturas();
		$oFacturas->Desde = $cDesde;
		$oFacturas->Hasta = $cHasta;
		$oFacturas->EnBlanco = true;
		$oFacturas->OrderBy = 'fecha, id_factura';
		$oFacturas->LimitCant = null;
		$this->Buffer['facturas'] = $oFacturas->Buscar();
		
		$oCotizacion = new Cotizaciones();
		$nCant = count($this->Buffer['facturas']);
		for ($i=0; $i<$nCant; ++$i) {
			
			if ($this->Buffer['facturas'][$i]['id_moneda'] != 1) {
				// Busca la cotizacion.
				$oCotizacion->IdMoneda = $this->Buffer['facturas'][$i]['id_moneda'];
				$oCotizacion->Hasta = $this->Buffer['facturas'][$i]['fecha'];
				$oCotizacion->OrderBy = 'fecha DESC';
				$oCotizacion->LimitCant = 1;
				$aCotizacion = $oCotizacion->Buscar();
				
				$this->Buffer['facturas'][$i]['importe'] *= $aCotizacion[0]['importe'];
				$this->Buffer['facturas'][$i]['impuesto'] *= $aCotizacion[0]['importe'];
				$this->Buffer['facturas'][$i]['iva'] *= $aCotizacion[0]['importe'];
				$this->Buffer['facturas'][$i]['total'] *= $aCotizacion[0]['importe'];
			}
		}
		
		// Busca las compras dentro del período.
		$oEgresos = new Egresos();
		$oEgresos->Desde = $cDesde;
		$oEgresos->Hasta = $cHasta;
		$oEgresos->Factura = true;
		$oEgresos->OrderBy = 'fecha, id_egreso';
		$oEgresos->LimitCant = null;
		$this->Buffer['egresos'] = $oEgresos->Buscar();
		
		$cFileName = tempnam('files/tmp/', 'iva_');
		$vista = $this->Template->Load('informes/iva.xml.php', $this->Buffer);
		file_put_contents($cFileName, $vista);
		$nFileSize = filesize($cFileName);
		
		header("Pragma: public");
		header("Expires: 0");
		header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
		header("Content-Transfer-Encoding: binary");
		header("Content-Description: File Transfer");
		header("Content-Length: {$nFileSize}");
		header("Content-Disposition: attachment; filename=\"Libro de iva {$cDesde} a {$cHasta}.xls\"");
		readfile($cFileName);
		unlink($cFileName);
	}
	
	public function ganancias() {
		
		if (@$_GET['desde']) {
			$cDesde = date2mysql($_GET['desde'], '%d/%m/%Y', false);
			$cHasta = date2mysql($_GET['hasta'], '%d/%m/%Y', false);
			
			$this->Buffer['informe'] = array();
			
			// Objetos.
			$oFact = new Facturas();
			$oFact->Desde = $cDesde;
			$oFact->Hasta = $cHasta;
			$oEgre = new Egresos();
			$oEgre->Desde = $cDesde;
			$oEgre->Hasta = $cHasta;
			
			// Facturación declarada y no declarada.
			$this->Buffer['informe']['facturacion'] = $oFact->GranTotal();
			
			// Egresos declarados.
			$oEgre->IdTipofactura = true;
			$this->Buffer['informe']['egresos']['declarado'] = $oEgre->GranTotal();
			
			// Egresos sin declarar.
			$oEgre->Computar = 1;
			$oEgre->IdTipofactura = false;
			$this->Buffer['informe']['egresos']['otros'] = $oEgre->GranTotal();
			
			// Egresos declarados de quadra.
			$oEgre->Computar = 0;
			$oEgre->IdTipofactura = true;
			$this->Buffer['informe']['egresos']['no_quadra'] = $oEgre->GranTotal();
		}
		
		$this->Buffer['body'] = $this->Template->Load('informes/ganancias.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	public function rentabilidad_proyectos() {
		if (@$_GET['id_proyecto']) {
			$nIdProyecto = $_GET['id_proyecto'];
			
			// Datos del proyecto.
			$oProy = new Proyectos();
			$oProy->IdProyecto = $nIdProyecto;
			$this->Buffer['proyecto'] = $oProy->Obtener();
			
			// Importe declarado en la venta.
			$oVentas = new Ventas();
			$oVentas->IdProyecto = $nIdProyecto;
			$oVentas->OrderBy = 'fecha';
			$oVentas->LimitCant = null;
			$this->Buffer['ventas'] = $oVentas->Buscar();
			
			// Facturación asociada al proyecto.
			$oFact = new Facturas();
			$oFact->IdProyecto = $nIdProyecto;
			$oFact->OrderBy = 'fecha';
			$oFact->LimitCant = null;
			$this->Buffer['facturas'] = $oFact->Buscar();
			
			// Gastos asociados al proyecto.
			$oEgr = new Egresos();
			$oEgr->IdProyecto = $nIdProyecto;
			$oEgr->OrderBy = 'fecha';
			$oEgr->LimitCant = null;
			$this->Buffer['egresos'] = $oEgr->Buscar();
			
			// Horas de producción dentro del estudio.
			$oHist = new Historial_trabajo();
			$oHist->IdProyecto = $nIdProyecto;
			$oHist->OrderBy = 'fecha';
			$oHist->LimitCant = null;
			$this->Buffer['historial'] = $oHist->Buscar();
			
			$this->Buffer['informe'] = true;
		}
		
		$this->Buffer['body'] = $this->Template->Load('informes/rentabilidad_proyectos.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
}

include_once('includes/fpdf/fpdf.php');
class MyPDFInformes extends FPDF {
	
	public $Titulo = null;
	
	function Header() {
	    //Select Arial bold 15
	    $this->SetFont('Arial','',20);
	    //Framed title
	    $this->Cell(0,10,utf8_decode($this->Titulo),0,0,'C');
	    //Line break
	    $this->Ln(20);
	}
	
	function Footer() {
	    //Go to 1.5 cm from bottom
	    $this->SetY(-15);
	    //Select Arial italic 8
	    $this->SetFont('Arial','I',8);
	    //Print centered page number
	    $this->Cell(0,10,utf8_decode('Página ').$this->PageNo(),0,0,'C');
	    
	    $this->SetX(0);
	    $this->SetFont('Arial','I',8);
	    $this->SetTextColor(120,120,120);
	    //Print centered page number
	    $this->Cell(0,10,utf8_decode('desarrollado por Estudio Quadra'),0,0,'R');
	}
}

$oCont = new InformesCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>