<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR) && $METHOD != 'x_autocompletar') {
	header("Location: ?p=login");
	die;
}

class MonedasCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Monedas.
	 *
	 * @var Monedas
	 */
	private $Monedas;
		
	function __construct() {
		parent::__construct();
		$this->Monedas = new Monedas();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Monedas.
	 *
	 */
	public function listado() {
		$this->menu_lateral();
		
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Monedas->Nombre = $_GET['nombre'];
			}
			if (@$_GET['formato']) {
				$this->Monedas->Formato = $_GET['formato'];
			}
		}
		
		if(isset($_GET['alfabetica'])) {
			$this->Monedas->PorLetra = $_GET['alfabetica'];
		}
		
		$this->Monedas->Page = @$_GET['pg'];
		$this->Monedas->OrderBy = 'id_moneda';
		$this->Buffer['listado'] = $this->Monedas->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Monedas->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('monedas/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Monedas.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Monedas y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Monedas->IdMoneda = $_GET['id_moneda'];
		$this->Buffer['datos'] = $this->Monedas->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Monedas.
	 *
	 */
	public function formulario() {
		$this->menu_lateral();
		
		$this->Buffer['paso'] = 1;
		
		//$this->Buffer['formulario'] = $this->Template->Load('monedas/formulario-monedas.tpl.php', $this->Buffer);
		//$this->Buffer['body'] = $this->Template->Load('monedas/formulario.tpl.php', $this->Buffer);
		$this->Buffer['body'] = $this->Template->Load('monedas/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Monedas.
	 *
	 */
	public function guardar() {
		$this->Monedas->IdMoneda = $_POST['id_moneda'];
		$this->Monedas->Obtener();
		$this->Monedas->Nombre = $_POST['nombre'];
		$this->Monedas->Formato = $_POST['formato'];
		$this->Monedas->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=monedas"); }
		die;
	}
		
	/**
	 * @desc
	 * Menu lateral para todas las secciones.
	 *
	 */
	private function menu_lateral() {
		$this->Buffer['menu_lateral'] = $this->Template->Load('monedas/menu-lateral.tpl.php');
	}
	
	/**
	 * @desc
	 * Buscador AJAX de Monedas.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Monedas->Nombre = $_GET['nombre'];
			}
			if (@$_GET['formato']) {
				$this->Monedas->Formato = $_GET['formato'];
			}
		}
		
		//$this->Monedas->Activo = null;
		$this->Monedas->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Monedas->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Monedas->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('monedas/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('monedas/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Monedas->IdMoneda = $_POST['id_moneda'];
		$this->Monedas->Nombre = $_POST['nombre'];
		$this->Monedas->Formato = $_POST['formato'];
		$this->Monedas->Guardar();
		
		echo $this->Monedas->IdMoneda;
	}
	
	/**
	 * @desc
	 * Marca un monedas como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Monedas->IdMoneda = $_POST['id_moneda'];
		$this->Monedas->Eliminar();
	}
	
	/**
	 * @desc
	 * Devuelve un Monedas.
	 *
	 */
	public function x_obtener() {
		$this->Monedas->IdMoneda = $_GET['id_moneda'];
		$aDatos = $this->Monedas->Obtener();
		header('Content-type: application/xml; charset=utf-8');
		
		echo "<datos>";
		foreach ($aDatos as $columna => $valor) {
			echo "<{$columna}>".htmlspecialchars($valor, ENT_QUOTES, 'UTF-8')."</{$columna}>\r\n";
		}
		echo "</datos>";
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Monedas->Nombre = @$_GET['q'];
		$this->Monedas->OrderBy = 'nombre';
		$this->Monedas->LimitCant = 50;
		$aDatos = $this->Monedas->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['nombre'])."|{$item['id_moneda']}\n";
		}
	}
}

$oCont = new MonedasCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>