<?
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR) && $METHOD != 'x_autocompletar') {
	header("Location: ./?p=login");
	die;
}

class OperadoresCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Operadores.
	 *
	 * @var Operadores
	 */
	var $Operadores;
	
	function __construct() {
		parent::__construct();
		require_once(APP_MODELS_PATH.'/Operadores.mdl.php');
		$this->Operadores = new Operadores();
	}
	
	function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de operadores.
	 *
	 */
	function listado() {
		$this->menu_lateral();
		
		$this->Operadores->Page = @$_GET['pg'];
		$this->Operadores->OrderBy = 'nombre';
		
		if (@$_GET['nombre']) {
			$this->Operadores->Nombre = $_GET['nombre'];
		}
		if (@$_GET['domicilio']) {
			$this->Operadores->Domicilio = $_GET['domicilio'];
		}
		if (@$_GET['alfabetica']) {
			$this->Operadores->PorLetra = $_GET['alfabetica'];
		}
		
		$this->Buffer['listado'] = $this->Operadores->Buscar();
		
		require_once(APP_SYSTEM_PATH.'/functions/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Operadores->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('operadores/listado.tpl.php', $this->Buffer);
		
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Carga un operador y llama a la accion formulario().
	 *
	 */
	function editar() {
		
		if (!Login::TienePermiso(PERMISOS_SUPER) && $METHOD != 'x_autocompletar') {
			header("Location: ./?p=login");
			die;
		}		
	
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Operadores->IdOperador = $_GET['id_operador'];
		$this->Buffer['datos'] = $this->Operadores->Obtener();
		
		$oFO = new Fases_operador();
		$oFO->IdOperador = $_GET['id_operador'];
		$this->Buffer['fases'] = $oFO->BuscarFases();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de operadores.
	 *
	 */
	function formulario() {
		$this->menu_lateral();
		
		$this->Buffer['body'] = $this->Template->Load('operadores/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Formulario de nuevo operador.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$oFO = new Fases_operador();
		$oFO->IdOperador = '0'; // Simula operador inexistente para mostrar todo en blanco.
		$this->Buffer['fases'] = $oFO->BuscarFases();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Guarda un operador.
	 *
	 */
	function guardar() {
		$this->Operadores->IdOperador = $_POST['id_operador'];
		$this->Operadores->Obtener();
		$this->Operadores->Nombre = $_POST['nombre'];
		$this->Operadores->Usuario = $_POST['usuario'];
		$this->Operadores->Email = $_POST['email'];
		$this->Operadores->Telefono = $_POST['telefono'];
		$this->Operadores->Domicilio = $_POST['domicilio'];
		$this->Operadores->Contacto = $_POST['contacto'];
		$this->Operadores->ControlHistorial = @$_POST['control_historial'];
		$this->Operadores->Proyectosencola = @$_POST['proy_en_cola'];
		$this->Operadores->Vencimientos = @$_POST['vencimientos'];
		$this->Operadores->Servicios = @$_POST['servicios'];
		$this->Operadores->Habilitado = @$_POST['habilitado'];
		if (strlen($_POST['clave'])) {
			$this->Operadores->Clave = $_POST['clave'];
		}
		$this->Operadores->Comentario = $_POST['comentario'];
		
		//$this->Operadores->Activo = @$_POST['activo'];
		$_POST['permisos'][$_POST['permiso']] = 1;
		$this->Operadores->Permisos = @$_POST['permisos'];
		
		$this->Operadores->Guardar();
		
		$oFO = new Fases_operador();
		$oFO->IdOperador = $this->Operadores->IdOperador;
		$oFO->Eliminar();
		
		foreach ((array) @$_POST['id_fase'] as $id_fase) {
			$oFO->IdFase = $id_fase;
			$oFO->Guardar();
		}
		
		header("Location: ./?p=operadores");
		die;
	}
	
	/**
	 * @desc
	 * Elimina un operador.
	 *
	 */
	public function x_eliminar() {
		$this->Operadores->IdOperador = $_POST['id_operador'];
		$this->Operadores->Eliminar();
	}
	
	/**
	 * @desc
	 * Activa o desactiva un operador.
	 *
	 */
	public function activar() {
		$aOperador = $this->Operadores->Obtener($_GET['id']);
		if ($aOperador['activo']) {
			$this->Operadores->Desactivar($_GET['id']);
			echo $this->Template->Load('operadores/ajax-noactivo.tpl.php');
		}
		else {
			$this->Operadores->Activar($_GET['id']);
			echo $this->Template->Load('operadores/ajax-activo.tpl.php');
		}
	}
	
	/**
	 * @desc
	 * Metodo AJAX para obtener un operador.
	 *
	 */
	public function x_obtener() {
		// Busca el operador.
		$this->Operadores->ObtenerPorUsuario($_GET['usuario']);
		
		// Si lo encontro y el ID es diferente, devuelve el ID
		// Si no lo encontro, o bien, si es el mismo ID devuelve la cadena "NULL".
		if ($this->Operadores->IdOperador) {
			if ($this->Operadores->IdOperador != $_GET['id_operador']) {
				die($this->Operadores->IdOperador);
			}
		}
		
		die('NULL');
	}
	
	/**
	 * @desc
	 * Menu lateral para todas las secciones.
	 *
	 */
	public function menu_lateral() {
		$this->Buffer['menu_lateral'] = $this->Template->Load('operadores/menu-lateral.tpl.php');
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Operadores->Nombre = @$_GET['q'];
		$this->Operadores->Habilitado = 1;
		$this->Operadores->LimitCant = 50;
		$this->Operadores->OrderBy = 'nombre';
		$aDatos = $this->Operadores->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['nombre'])."|{$item['id_operador']}|ope\n";
		}
		
		if (false && isset($_GET['id_cliente'])) {
			$oCliente = new Clientes();
			$oCliente->IdCliente = $_GET['id_cliente'];
			$oCliente->Obtener();
			echo str_replace('|', '', $oCliente->Nombre)."|{$oCliente->IdCliente}|cli\n";
		}
	}

}

$oCont = new OperadoresCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>