<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR, PERMISOS_FACTURACION)) {
	header("Location: ?p=login");
	die;
}

class OrdenesCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Ordenes.
	 *
	 * @var Ordenes
	 */
	private $Ordenes;
		
	function __construct() {
		parent::__construct();
		$this->Ordenes = new Ordenes();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Ordenes.
	 *
	 */
	public function listado() {
		$this->menu_lateral();
		
		if (isset($_GET['buscar'])) {
		
			if (@$_GET['desde']) {
				$this->Ordenes->Desde = date2mysql($_GET['desde'], '%d/%m/%Y', false);
			}
			if (@$_GET['hasta']) {
				$this->Ordenes->Hasta = date2mysql($_GET['hasta'], '%d/%m/%Y', false);
			}
			if (@$_GET['id_cliente']) {
				$this->Ordenes->IdCliente = $_GET['id_cliente'];
			}
			if (@$_GET['descripcion']) {
				$this->Ordenes->Descripcion = $_GET['descripcion'];
			}
			if (@$_GET['importe']) {
				$this->Ordenes->Importe = $_GET['importe'];
			}
			if (@$_GET['id_factura']) {
				$this->Ordenes->IdFactura = $_GET['id_factura'];
			}
			if (@$_GET['facturado'] === "0") {
				$this->Ordenes->Facturado = false;
			}
			
		} elseif(isset($_SESSION['clienteactivo'])){
				$this->Ordenes->Facturado = false;
				$this->Ordenes->IdCliente = $_SESSION['clienteactivo'];
		}
		
		$this->Ordenes->Page = @$_GET['pg'];
		if (@$_GET['facturado'] === "0") {
			$this->Ordenes->OrderBy = 'fecha ASC';
		}
		else {
			$this->Ordenes->OrderBy = 'fecha DESC';
		}
		
		$this->Buffer['listado'] = $this->Ordenes->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Ordenes->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('ordenes/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Ordenes.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Ordenes y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Ordenes->IdOrden = $_GET['id_orden'];
		$this->Buffer['datos'] = $this->Ordenes->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Ordenes.
	 *
	 */
	public function formulario() {
		$this->menu_lateral();
		
		$this->Buffer['paso'] = 1;
		
		//$this->Buffer['formulario'] = $this->Template->Load('ordenes/formulario-ordenes.tpl.php', $this->Buffer);
		//$this->Buffer['body'] = $this->Template->Load('ordenes/formulario.tpl.php', $this->Buffer);
		$this->Buffer['body'] = $this->Template->Load('ordenes/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Ordenes.
	 *
	 */
	public function guardar() {
		$this->Ordenes->IdOrden = $_POST['id_orden'];
		$this->Ordenes->Obtener();
		$this->Ordenes->Fecha = date2mysql($_POST['fecha']);
		$this->Ordenes->IdCliente = $_POST['id_cliente'];
		$this->Ordenes->Descripcion = $_POST['descripcion'];
		$this->Ordenes->DescripcionFactura = $_POST['descripcion_factura'];
		$this->Ordenes->Importe = $_POST['importe'];
		//$this->Ordenes->IdFactura = $_POST['id_factura'];
		$this->Ordenes->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=ordenes"); }
		die;
	}
		
	/**
	 * @desc
	 * Menu lateral para todas las secciones.
	 *
	 */
	private function menu_lateral() {
		$this->Buffer['menu_lateral'] = $this->Template->Load('ordenes/menu-lateral.tpl.php');
	}
	
	/**
	 * @desc
	 * Buscador AJAX de Ordenes.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['fecha']) {
				$this->Ordenes->Fecha = $_GET['fecha'];
			}
			if (@$_GET['id_cliente']) {
				$this->Ordenes->IdCliente = $_GET['id_cliente'];
			}
		}
		
		//$this->Ordenes->Activo = null;
		$this->Ordenes->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Ordenes->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Ordenes->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('ordenes/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('ordenes/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Ordenes->IdOrden = $_POST['id_orden'];
		$this->Ordenes->Fecha = $_POST['fecha'];
		$this->Ordenes->IdCliente = $_POST['id_cliente'];
		$this->Ordenes->Descripcion = $_POST['descripcion'];
		$this->Ordenes->Importe = $_POST['importe'];
		$this->Ordenes->IdFactura = $_POST['id_factura'];
		$this->Ordenes->Guardar();
		
		echo $this->Ordenes->IdOrden;
	}
	
	/**
	 * @desc
	 * Marca un ordenes como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Ordenes->IdOrden = $_POST['id_orden'];
		$this->Ordenes->Eliminar();
	}
	
	/**
	 * @desc
	 * Devuelve un Ordenes.
	 *
	 */
	public function x_obtener() {
		$this->Ordenes->IdOrden = $_GET['id_orden'];
		$aDatos = $this->Ordenes->Obtener();
		header('Content-type: application/xml; charset=utf-8');
		
		echo "<datos>";
		foreach ($aDatos as $columna => $valor) {
			echo "<{$columna}>".htmlspecialchars($valor, ENT_QUOTES, 'UTF-8')."</{$columna}>\r\n";
		}
		echo "</datos>";
	}
	
	public function x_listado() {
		$this->Ordenes->IdCliente = $_POST['id_cliente'];
		$this->Ordenes->Facturado = false;
		$this->Ordenes->OrderBy = 'fecha';
		$this->Ordenes->LimitCant = null;
		$this->Buffer['listado'] = $this->Ordenes->Buscar();
		
		echo $this->Template->Load('ordenes/x-listado.tpl.php', $this->Buffer);
	}
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Ordenes->IdOrden = @$_GET['q'];
		$this->Ordenes->OrderBy = 'IdOrden';
		$this->Ordenes->LimitCant = 50;
		$aDatos = $this->Ordenes->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_orden'])."|{$item['id_orden']}\n";
		}
	}
}

$oCont = new OrdenesCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>