<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR)) {
	header("Location: ?p=login");
	die;
}

class PeriodosCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Periodos.
	 *
	 * @var Periodos
	 */
	private $Periodos;
		
	function __construct() {
		parent::__construct();
		$this->Periodos = new Periodos();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Periodos.
	 *
	 */
	public function listado() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Periodos->Nombre = $_GET['nombre'];
			}
		}
		
		if(isset($_GET['alfabetica'])) {
			$this->Periodos->PorLetra = $_GET['alfabetica'];
		}
		
		$this->Periodos->Page = @$_GET['pg'];
		$this->Periodos->OrderBy = 'id_periodo';
		$this->Buffer['listado'] = $this->Periodos->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Periodos->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('periodos/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Periodos.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Periodos y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Periodos->IdPeriodo = $_GET['id_periodo'];
		$this->Buffer['datos'] = $this->Periodos->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Periodos.
	 *
	 */
	public function formulario() {
		$this->Buffer['body'] = $this->Template->Load('periodos/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Periodos.
	 *
	 */
	public function guardar() {
		$this->Periodos->IdPeriodo = $_POST['id_periodo'];
		$this->Periodos->Obtener();
		$this->Periodos->Nombre = $_POST['nombre'];
		$this->Periodos->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=periodos"); }
		die;
	}
		
	/**
	 * @desc
	 * Buscador AJAX de Periodos.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Periodos->Nombre = $_GET['nombre'];
			}
		}
		
		//$this->Periodos->Activo = null;
		$this->Periodos->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Periodos->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Periodos->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('periodos/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('periodos/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Periodos->IdPeriodo = $_POST['id_periodo'];
		$this->Periodos->Nombre = $_POST['nombre'];
		$this->Periodos->Guardar();
		
		echo $this->Periodos->IdPeriodo;
	}
	
	/**
	 * @desc
	 * Marca un registro como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Periodos->IdPeriodo = $_POST['id_periodo'];
		$aData['eliminado'] = $this->Periodos->Eliminar();
		
		echo json_encode($aData);
	}
	
	/**
	 * @desc
	 * Devuelve un Periodos.
	 *
	 */
	public function x_obtener() {
		$this->Periodos->IdPeriodo = $_GET['id_periodo'];
		$aDatos = $this->Periodos->Obtener();
		
		echo json_encode($aDatos);
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Periodos->Nombre = @$_GET['q'];
		$this->Periodos->OrderBy = 'id_periodo';
		$this->Periodos->LimitCant = 50;
		$aDatos = $this->Periodos->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['nombre'])."|{$item['id_periodo']}\n";
		}
	}
}

$oCont = new PeriodosCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>