<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR, PERMISOS_FACTURACION, PERMISOS_VENTAS) && $METHOD != 'x_autocompletar') {
	header("Location: ?p=login");
	die;
}

class PreclientesCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Preclientes.
	 *
	 * @var Preclientes
	 */
	private $Preclientes;
		
	function __construct() {
		parent::__construct();
		$this->Preclientes = new Preclientes();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Preclientes.
	 *
	 */
	public function listado() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['fecha_alta']) {
				$this->Preclientes->FechaAlta = $_GET['fecha_alta'];
			}
			if (@$_GET['id_comercial']) {
				$this->Preclientes->IdComercial = $_GET['id_comercial'];
			}
			if (@$_GET['razon_social']) {
				$this->Preclientes->RazonSocial = $_GET['razon_social'];
			}
			if (@$_GET['id_condicionfiscal']) {
				$this->Preclientes->IdCondicionfiscal = $_GET['id_condicionfiscal'];
			}
			if (@$_GET['cuit']) {
				$this->Preclientes->Cuit = $_GET['cuit'];
			}
			if (@$_GET['domicilio']) {
				$this->Preclientes->Domicilio = $_GET['domicilio'];
			}
			if (@$_GET['localidad']) {
				$this->Preclientes->Localidad = $_GET['localidad'];
			}
			if (@$_GET['telefono']) {
				$this->Preclientes->Telefono = $_GET['telefono'];
			}
			if (@$_GET['email']) {
				$this->Preclientes->Email = $_GET['email'];
			}
			if (@$_GET['web']) {
				$this->Preclientes->Web = $_GET['web'];
			}
			if (@$_GET['id_rubro']) {
				$this->Preclientes->IdRubro = $_GET['id_rubro'];
			}
		}
		
		if ($_SESSION['operador']['permisos']['ventas'] || $_SESSION['operador']['permisos']['facturacion']) {
			$this->Preclientes->IdComercial = $_SESSION['operador']['id_operador'];
		}
		
		if(isset($_GET['alfabetica'])) {
			$this->Preclientes->PorLetra = $_GET['alfabetica'];
		}
		
		$this->Preclientes->Page = @$_GET['pg'];
		$this->Preclientes->OrderBy = 'id_precliente';
		$this->Buffer['listado'] = $this->Preclientes->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Preclientes->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('preclientes/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Preclientes.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Preclientes y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Preclientes->IdPrecliente = $_GET['id_precliente'];
		$this->Buffer['datos'] = $this->Preclientes->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Preclientes.
	 *
	 */
	public function formulario() {
		$this->Buffer['body'] = $this->Template->Load('preclientes/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Preclientes.
	 *
	 */
	public function guardar() {
		$this->Preclientes->IdPrecliente = $_POST['id_precliente'];
		$this->Preclientes->Obtener();
		$this->Preclientes->FechaAlta = date2mysql($_POST['fecha_alta']);
		$this->Preclientes->IdComercial = $_POST['id_comercial'];
		$this->Preclientes->RazonSocial = $_POST['razon_social'];
		$this->Preclientes->IdCondicionfiscal = $_POST['id_condicionfiscal'];
		$this->Preclientes->Cuit = $_POST['cuit'];
		$this->Preclientes->Domicilio = $_POST['domicilio'];
		$this->Preclientes->Localidad = $_POST['localidad'];
		$this->Preclientes->Telefono = $_POST['telefono'];
		$this->Preclientes->Email = $_POST['email'];
		$this->Preclientes->Web = $_POST['web'];
		$this->Preclientes->IdRubro = $_POST['id_rubro'];
		$this->Preclientes->Observacion = $_POST['observacion'];
		$this->Preclientes->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=preclientes"); }
		die;
	}
		
	/**
	 * @desc
	 * Buscador AJAX de Preclientes.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['fecha_alta']) {
				$this->Preclientes->FechaAlta = $_GET['fecha_alta'];
			}
			if (@$_GET['id_comercial']) {
				$this->Preclientes->IdComercial = $_GET['id_comercial'];
			}
		}
		
		//$this->Preclientes->Activo = null;
		$this->Preclientes->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Preclientes->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Preclientes->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('preclientes/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('preclientes/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Preclientes->IdPrecliente = $_POST['id_precliente'];
		$this->Preclientes->FechaAlta = $_POST['fecha_alta'];
		$this->Preclientes->IdComercial = $_POST['id_comercial'];
		$this->Preclientes->RazonSocial = $_POST['razon_social'];
		$this->Preclientes->IdCondicionfiscal = $_POST['id_condicionfiscal'];
		$this->Preclientes->Cuit = $_POST['cuit'];
		$this->Preclientes->Domicilio = $_POST['domicilio'];
		$this->Preclientes->Localidad = $_POST['localidad'];
		$this->Preclientes->Telefono = $_POST['telefono'];
		$this->Preclientes->Email = $_POST['email'];
		$this->Preclientes->Web = $_POST['web'];
		$this->Preclientes->IdRubro = $_POST['id_rubro'];
		$this->Preclientes->Observacion = $_POST['observacion'];
		$this->Preclientes->Guardar();
		
		echo $this->Preclientes->IdPrecliente;
	}
	
	/**
	 * @desc
	 * Marca un registro como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Preclientes->IdPrecliente = $_POST['id_precliente'];
		$aData['eliminado'] = $this->Preclientes->Eliminar();
		
		echo json_encode($aData);
	}
	
	/**
	 * @desc
	 * Devuelve un Preclientes.
	 *
	 */
	public function x_obtener() {
		$this->Preclientes->IdPrecliente = $_GET['id_precliente'];
		$aDatos = $this->Preclientes->Obtener();
		
		echo json_encode($aDatos);
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Preclientes->RazonSocial = @$_GET['q'];
		$this->Preclientes->OrderBy = 'razon_social';
		$this->Preclientes->LimitCant = 50;
		$aDatos = $this->Preclientes->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['razon_social'])."|{$item['id_precliente']}\n";
		}
	}
}

$oCont = new PreclientesCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>