<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR, PERMISOS_GESTION, PERMISOS_FACTURACION, PERMISOS_VENTAS)) {
	header("Location: ?p=login");
	die;
}

class ProveedoresCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Proveedores.
	 *
	 * @var Proveedores
	 */
	private $Proveedores;
		
	function __construct() {
		parent::__construct();
		$this->Proveedores = new Proveedores();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Proveedores.
	 *
	 */
	public function listado() {
		$this->menu_lateral();
		
		if (isset($_GET['buscar'])) {
			if (@$_GET['denominacion']) {
				$this->Proveedores->Denominacion = $_GET['denominacion'];
			}
			if (@$_GET['razon_social']) {
				$this->Proveedores->RazonSocial = $_GET['razon_social'];
			}
			if (@$_GET['cuit']) {
				$this->Proveedores->Cuit = $_GET['cuit'];
			}
			if (@$_GET['email']) {
				$this->Proveedores->Email = $_GET['email'];
			}
			if (@$_GET['telefono']) {
				$this->Proveedores->Telefono = $_GET['telefono'];
			}
			if (@$_GET['domicilio']) {
				$this->Proveedores->Domicilio = $_GET['domicilio'];
			}
			if (@$_GET['pagina_web']) {
				$this->Proveedores->PaginaWeb = $_GET['pagina_web'];
			}
			if (@$_GET['usuario']) {
				$this->Proveedores->Usuario = $_GET['usuario'];
			}
			if (@$_GET['clave']) {
				$this->Proveedores->Clave = $_GET['clave'];
			}
			if (@$_GET['comentarios']) {
				$this->Proveedores->Comentarios = $_GET['comentarios'];
			}
		}
		
		if(isset($_GET['alfabetica'])) {
			$this->Proveedores->PorLetra = $_GET['alfabetica'];
		}
		
		$this->Proveedores->Page = @$_GET['pg'];
		$this->Proveedores->OrderBy = 'denominacion';
		$this->Buffer['listado'] = $this->Proveedores->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Proveedores->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('proveedores/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Proveedores.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Proveedores y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Proveedores->IdProveedor = $_GET['id_proveedor'];
		$this->Buffer['datos'] = $this->Proveedores->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Proveedores.
	 *
	 */
	public function formulario() {
		$this->menu_lateral();
		
		$this->Buffer['paso'] = 1;
		
		//$this->Buffer['formulario'] = $this->Template->Load('proveedores/formulario-proveedores.tpl.php', $this->Buffer);
		//$this->Buffer['body'] = $this->Template->Load('proveedores/formulario.tpl.php', $this->Buffer);
		$this->Buffer['body'] = $this->Template->Load('proveedores/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Proveedores.
	 *
	 */
	public function guardar() {
		$this->Proveedores->IdProveedor = $_POST['id_proveedor'];
		$this->Proveedores->Obtener();
		$this->Proveedores->Denominacion = $_POST['denominacion'];
		$this->Proveedores->RazonSocial = $_POST['razon_social'];
		$this->Proveedores->Cuit = $_POST['cuit'];
		$this->Proveedores->Email = $_POST['email'];
		$this->Proveedores->Telefono = $_POST['telefono'];
		$this->Proveedores->Domicilio = $_POST['domicilio'];
		$this->Proveedores->PaginaWeb = $_POST['pagina_web'];
		$this->Proveedores->Usuario = $_POST['usuario'];
		$this->Proveedores->Clave = $_POST['clave'];
		$this->Proveedores->Comentarios = $_POST['comentarios'];
		$this->Proveedores->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=proveedores"); }
		die;
	}
		
	/**
	 * @desc
	 * Menu lateral para todas las secciones.
	 *
	 */
	private function menu_lateral() {
		$this->Buffer['menu_lateral'] = $this->Template->Load('proveedores/menu-lateral.tpl.php');
	}
	
	/**
	 * @desc
	 * Buscador AJAX de Proveedores.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['denominacion']) {
				$this->Proveedores->Denominacion = $_GET['denominacion'];
			}
			if (@$_GET['razon_social']) {
				$this->Proveedores->RazonSocial = $_GET['razon_social'];
			}
		}
		
		//$this->Proveedores->Activo = null;
		$this->Proveedores->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Proveedores->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Proveedores->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('proveedores/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('proveedores/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Proveedores->IdProveedor = $_POST['id_proveedor'];
		$this->Proveedores->Denominacion = $_POST['denominacion'];
		$this->Proveedores->RazonSocial = $_POST['razon_social'];
		$this->Proveedores->Cuit = $_POST['cuit'];
		$this->Proveedores->Email = $_POST['email'];
		$this->Proveedores->Telefono = $_POST['telefono'];
		$this->Proveedores->Domicilio = $_POST['domicilio'];
		$this->Proveedores->PaginaWeb = $_POST['pagina_web'];
		$this->Proveedores->Usuario = $_POST['usuario'];
		$this->Proveedores->Clave = $_POST['clave'];
		$this->Proveedores->Comentarios = $_POST['comentarios'];
		$this->Proveedores->Guardar();
		
		echo $this->Proveedores->IdProveedor;
	}
	
	/**
	 * @desc
	 * Marca un proveedores como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Proveedores->IdProveedor = $_POST['id_proveedor'];
		$this->Proveedores->Eliminar();
	}
	
	/**
	 * @desc
	 * Devuelve un Proveedores.
	 *
	 */
	public function x_obtener() {
		$this->Proveedores->IdProveedor = $_GET['id_proveedor'];
		$aDatos = $this->Proveedores->Obtener();
		header('Content-type: application/xml; charset=utf-8');
		
		echo "<datos>";
		foreach ($aDatos as $columna => $valor) {
			echo "<{$columna}>".htmlspecialchars($valor, ENT_QUOTES, 'UTF-8')."</{$columna}>\r\n";
		}
		echo "</datos>";
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Proveedores->Denominacion = @$_GET['q'];
		$this->Proveedores->OrderBy = 'denominacion';
		$this->Proveedores->LimitCant = 50;
		$aDatos = $this->Proveedores->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['denominacion'])."|{$item['id_proveedor']}|{$item['cuit']}\n";
		}
	}
}

$oCont = new ProveedoresCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>