<?
// Checkea permisos.

if (!Login::TienePermiso(PERMISOS_SUPER, PERMISOS_ADMINISTRADOR, PERMISOS_FACTURACION, PERMISOS_GESTION, PERMISOS_DESARROLLO, PERMISOS_FREELANCE, PERMISOS_VENTAS)) {
	header("Location: ./?p=login");
	die;
}

if (Login::TienePermiso(PERMISOS_FREELANCE) && $METHOD != 'seguimiento' && $METHOD != 'tareas') {
	header("Location: ./?p=login");
	die;
}

class ProyectosCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Proyectos.
	 *
	 * @var Proyectos
	 */
	private $Proyectos;
		
	function __construct() {
		parent::__construct();
		$this->Proyectos = new Proyectos();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Proyectos.
	 *
	 */
	public function listado() {
//		if (!isset($_GET['buscar'])) {
//			$_GET['buscar'] = 1;
//			$_GET['filtro'] = 'pendiente';
//		}
		
		if (isset($_GET['buscar'])) {
			if (@$_GET['id_cliente']) {
				$this->Proyectos->IdCliente = $_GET['id_cliente'];
			}
			if (@$_GET['id_tipoproyecto']) {
				$this->Proyectos->IdTipoproyecto = $_GET['id_tipoproyecto'];
			}
			if (@$_GET['nombre']) {
				$this->Proyectos->Nombre = $_GET['nombre'];
			}
			if (@$_GET['fecha_carga']) {
				$this->Proyectos->FechaCarga = $_GET['fecha_carga'];
			}
			if (@$_GET['inicio_estimado']) {
				$this->Proyectos->InicioEstimado = $_GET['inicio_estimado'];
			}
			if (@$_GET['fin_estimado']) {
				$this->Proyectos->FinEstimado = $_GET['fin_estimado'];
			}
			if (@$_GET['inicio_real']) {
				$this->Proyectos->InicioReal = $_GET['inicio_real'];
			}
			if (@$_GET['fin_real']) {
				$this->Proyectos->FinReal = $_GET['fin_real'];
			}
			if (@$_GET['descripcion']) {
				$this->Proyectos->Descripcion = $_GET['descripcion'];
			}
			if (@$_GET['notas_privadas']) {
				$this->Proyectos->NotasPrivadas = $_GET['notas_privadas'];
			}
			
			switch (@$_GET['filtro']) {
				case 'pendiente':
					$this->Proyectos->InicioReal = false;
					$this->Proyectos->EstimadosAl = date('Y-m-d');
					break;
				case 'no-iniciado':
					$this->Proyectos->InicioReal = false;
					break;
				case 'iniciado':
					$this->Proyectos->InicioReal = true;
					$this->Proyectos->FinReal = false;
					break;
				case 'finalizado-no-cerrado':
					$this->Proyectos->FinalizadosAl = date('Y-m-d');
					$this->Proyectos->FinReal = false;
					break;
				case 'finalizado':
					$this->Proyectos->FinReal = true;
					break;
			}
			
		} elseif(isset($_SESSION['clienteactivo'])) {
			$this->Proyectos->IdCliente = $_SESSION['clienteactivo'];
		}
		else {
			$this->Proyectos->FinReal = false;
		}
		
		if(isset($_GET['alfabetica'])) {
			$this->Proyectos->PorLetra = $_GET['alfabetica'];
		}
		
		$this->Proyectos->Page = @$_GET['pg'];
		$this->Proyectos->OrderBy = 'fecha_carga DESC';
		$this->Buffer['listado'] = $this->Proyectos->Buscar();
		
		if($this->Proyectos->FoundRows == 1){
			header("Location: ./?p=proyectos|seguimiento&id_proyecto={$this->Buffer['listado'][0]['id_proyecto']}");
		}
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Proyectos->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('proyectos/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Proyectos.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Proyectos y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Proyectos->IdProyecto = $_GET['id_proyecto'];
		$this->Buffer['datos'] = $this->Proyectos->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Proyectos.
	 *
	 */
	public function formulario() {
		$this->Buffer['body'] = $this->Template->Load('proyectos/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Seguimiento de proyectos.
	 *
	 */
	public function seguimiento() {
		$this->Buffer['datos']['id_sector'] = ELEMENTOS_PROYECTO;
		$this->Buffer['datos']['id_entidad'] = $_GET['id_proyecto'];
		
		$oSeguimiento = new Seguimientos();
		$oSeguimiento->IdSector = ELEMENTOS_PROYECTO;
		$oSeguimiento->IdEntidad = $_GET['id_proyecto'];
		$oSeguimiento->OrderBy = 'fecha DESC';
		$oSeguimiento->LimitCant = 100;
		$this->Buffer['listado'] = $oSeguimiento->Buscar();
		
		//echo "<pre>"; print_r($this->Buffer['listado']);  die;
		
		$this->Proyectos->IdProyecto = $_GET['id_proyecto'];
		$this->Buffer['proyecto'] = $this->Proyectos->Obtener();
		
		$oCliente = new Clientes();
		$oCliente->IdCliente = $this->Proyectos->IdCliente;
		$this->Buffer['cliente'] = $oCliente->Obtener();
		
		$this->Buffer['body'] = $this->Template->Load('proyectos/seguimiento.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Seguimiento Total de proyectos.
	 *
	 */
	public function seguimientoTotal() {
		$this->Buffer['datos']['id_sector'] = ELEMENTOS_PROYECTO;
		//$this->Buffer['datos']['id_entidad'] = $_GET['id_proyecto'];
		
		//$_SESSION['operador']['nombre']
		
		$this->Proyectos->LimitCant = 1000;
		$aProyectos = $this->Proyectos->Buscar();
		
		foreach ($aProyectos as $key => $item){
		
			$oSeguimiento = new Seguimientos();
			$oSeguimiento->IdSector = ELEMENTOS_PROYECTO;
			$oSeguimiento->IdEntidad = $item['id_proyecto'];
			$oSeguimiento->OrderBy = 'fecha DESC';
			$oSeguimiento->LimitCant = 1;
			
			$reg = $oSeguimiento->Buscar();
			
			$reg[0]['proyecto'] = $item['nombre'];
			$reg[0]['id_proyecto'] = $item['id_proyecto'];
			$reg[0]['cliente'] = $item['cliente'];
			
			if(NAME=="gestionhessy"){
				$aRec[$key] = $reg;		
			}
			
			if(@$reg[0]['flags'] == SEGUIMIENTO_FLAG_ROJO){
				$aRec[$key] = $reg;
			}
			
			if(@$reg[0]['flags'] == SEGUIMIENTO_FLAG_AMARILLO){
				$aRecAmarillo[$key] = $reg;
			}
			
			
			
		}
		
		$this->Buffer['listado'] = @$aRec;
		$this->Buffer['listadoamarillo'] = @$aRecAmarillo;
		
		
		$this->Buffer['body'] = $this->Template->Load('proyectos/seguimientototal.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
		/**
	 * @desc
	 * Seguimiento Total de proyectos.
	 *
	 */
	public function Tickets() {

		$oSeguimiento = new Seguimientos();
		$aRec = $oSeguimiento->BuscarTickets();
		
		$this->Buffer['listado'] = @$aRec;
		
		$this->Buffer['body'] = $this->Template->Load('proyectos/tickets.tpl.php', $this->Buffer);
		echo $this->Template->Load('default-movil.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Seguimiento de proyectos.
	 *
	 */
	public function pendientes() {
		
		//$this->Buffer['datos']['id_sector'] = ELEMENTOS_PROYECTO;
		//$this->Buffer['datos']['id_entidad'] = $_GET['id_proyecto'];
		
		/*
		SELECT proyectos.id_proyecto, seguimientos.*, flags_seguimiento.valor, MAX(flags_seguimiento.id_seguimiento) id  FROM seguimientos LEFT JOIN flags_seguimiento ON flags_seguimiento.id_seguimiento = seguimientos.id_seguimiento LEFT JOIN proyectos ON seguimientos.id_entidad = proyectos.id_proyecto WHERE flags_seguimiento.valor =17 GROUP BY seguimientos.id_entidad ORDER BY id DESC LIMIT 0, 100
		*/
		$oSeguimiento = new Seguimientos();
		
		$result = mysql_query("SELECT proyectos.id_proyecto, seguimientos.*, flags_seguimiento.valor, MAX(flags_seguimiento.id_seguimiento) id  FROM seguimientos LEFT JOIN flags_seguimiento ON flags_seguimiento.id_seguimiento = seguimientos.id_seguimiento LEFT JOIN proyectos ON seguimientos.id_entidad = proyectos.id_proyecto WHERE flags_seguimiento.valor =17 GROUP BY seguimientos.id_entidad ORDER BY id DESC LIMIT 0, 100");
		
		$aRet = mysql_fetch_array($result);
		
		print_r($aRet);
		die;
		
		/*
		$this->Proyectos->IdProyecto = $_GET['id_proyecto'];
		$this->Buffer['proyecto'] = $this->Proyectos->Obtener();
		
		$this->Buffer['body'] = $this->Template->Load('proyectos/seguimiento.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
		*/
	}
	
	/**
	 * @desc
	 * Tareas del proyecto.
	 *
	 */
	public function tareas() {
		$this->Buffer['datos']['id_sector'] = ELEMENTOS_PROYECTO;
		$this->Buffer['datos']['id_entidad'] = $_GET['id_proyecto'];
		
		$oTareas = new Tareas();
		$oTareas->IdSector = ELEMENTOS_PROYECTO;
		$oTareas->IdEntidad = $_GET['id_proyecto'];
		if (isset($_GET['cerradas'])) {
			$oTareas->Cerrada = 1;
			$oTareas->OrderBy = 'fecha_cerrada DESC';
		}
		else {
			$oTareas->Cerrada = 0;
			$oTareas->OrderBy = 'fecha_creada ASC';
		}
		$oTareas->LimitCant = 50;
		$this->Buffer['listado'] = $oTareas->Buscar();
		
		$this->Proyectos->IdProyecto = $_GET['id_proyecto'];
		$this->Buffer['proyecto'] = $this->Proyectos->Obtener();
		
		$this->Buffer['body'] = $this->Template->Load('proyectos/tareas.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Proyectos.
	 *
	 */
	public function guardar() {
		$this->Proyectos->IdProyecto = $_POST['id_proyecto'];
		$this->Proyectos->Obtener();
		$this->Proyectos->IdCliente = $_POST['id_cliente'];
		$this->Proyectos->Orden = $_POST['orden'];
		$this->Proyectos->IdTipoproyecto = $_POST['id_tipoproyecto'];
		$this->Proyectos->Nombre = $_POST['nombre'];
		$this->Proyectos->FechaCarga = date2mysql($_POST['fecha_carga']);
		$this->Proyectos->InicioEstimado = date2mysql($_POST['inicio_estimado']);
		$this->Proyectos->FinEstimado = date2mysql($_POST['fin_estimado']);
		$this->Proyectos->InicioReal = date2mysql($_POST['inicio_real']);
		
		// Si se esta cerrando el proyecto, pone seguimiento de fase en ANALISIS.
		if ($this->Proyectos->FinReal == null && $_POST['fin_real']) {
			$oSF = new Seguimientos_fase();
			$oSF->IdProyecto = $this->Proyectos->IdProyecto;
			$oSF->IdFase = 1;
			$oSF->IdEstadofase = 0;
			$oSF->Guardar();
		}
		
		$this->Proyectos->FinReal = date2mysql($_POST['fin_real']);
		$this->Proyectos->Descripcion = $_POST['descripcion'];
		$this->Proyectos->Comentario = $_POST['comentario'];
		if (Login::TienePermiso(PERMISOS_ADMINISTRADOR)) {
			$this->Proyectos->NotasPrivadas = $_POST['notas_privadas'];
		}
		
		// Si es un proyecto nuevo, pone el seguimiento de fase en ANALISIS y lo acomoda en la grilla.
		if ($this->Proyectos->IdProyecto == null) {
			$this->Proyectos->IdFaseactiva = 1;
			$this->Proyectos->IdEstadofase = 1;
			$this->Proyectos->Posicion = Proyectos::ObtenerUltimaPosicion(1, 1);
			
			$oSF = new Seguimientos_fase();
			$oSF->IdProyecto = $this->Proyectos->Guardar();
			$oSF->IdFase = 1;
			$oSF->IdEstadofase = 1;
			$oSF->Guardar();
			
			$oFP = new Fases_proyecto();
			$oFP->IdProyecto = $this->Proyectos->IdProyecto;
			$oFP->IdFase = 1;
			$oFP->InicioEstimado = date('Y-m-d');
			$oFP->Guardar();
		}
		else {
			$this->Proyectos->Guardar();
		}
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { 
			if (@$_POST['id_proyecto']) {
				header("Location: ?p=proyectos"); 
			}
			else {
				header("Location: ?p=proyectos|fases&id_proyecto={$this->Proyectos->IdProyecto}");
			}
			
		}
		
		die;
	}
	
	public function datos_cliente() {
		$this->Proyectos->IdProyecto = $_GET['id_proyecto'];
		$this->Buffer['datos'] = $this->Proyectos->Obtener();
		
		$oCliente = new Clientes();
		$oCliente->IdCliente = $this->Proyectos->IdCliente;
		$this->Buffer['cliente'] = $oCliente->Obtener();
		
		$this->Buffer['body'] = $this->Template->Load('proyectos/datos_cliente.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	public function fases() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Proyectos->IdProyecto = $_GET['id_proyecto'];
		$this->Buffer['datos'] = $this->Proyectos->Obtener();
		
		$oFases = new Fases();
		$this->Buffer['fases'] = $oFases->Buscar();
		
		$oFP = new Fases_proyecto();
		$oFO = new Fases_operador();
		$oOFP = new Operadores_fp();
		
		foreach ($this->Buffer['fases'] as $pos => $item) {
			$oFP->IdFase = $item['id_fase'];
			$oFP->IdProyecto = $this->Proyectos->IdProyecto;
			$this->Buffer['fases'][$pos]['datos'] = (array) $oFP->Obtener();
			
			$oFO->IdFase = $item['id_fase'];
			$oFO->OrderBy = 'operadores.nombre';
			//$this->Buffer['fases'][$pos]['operadores'] = $oFO->Buscar();
			
			$oOFP->IdProyecto = $this->Proyectos->IdProyecto;
			$oOFP->IdFase = $item['id_fase'];
			$this->Buffer['fases'][$pos]['operadores'] = $oOFP->BuscarOperadores();
			
			$oFP->Limpiar();
		}
		
		$this->Buffer['body'] = $this->Template->Load('proyectos/fases.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	public function seguimientos_fase() {
		$this->Proyectos->IdProyecto = $_GET['id_proyecto'];
		$this->Buffer['datos'] = $this->Proyectos->Obtener();
		
		$oSF = new Seguimientos_fase();
		$oSF->IdProyecto = $_GET['id_proyecto'];
		$oSF->OrderBy = 'fecha';
		$oSF->LimitCant = null;
		$this->Buffer['listado'] = $oSF->Buscar();
		
		$this->Buffer['body'] = $this->Template->Load('proyectos/seguimientos_fase.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda las fases de un proyecto.
	 *
	 */
	public function guardar_fases() {
		$oFP = new Fases_proyecto();
		$oOFP = new Operadores_fp();
		
		foreach ((array) @$_POST['fase'] as $item) {
			$oFP->IdProyecto = $_POST['id_proyecto'];
			$oFP->IdFase = $item;
			$oFP->Obtener();
			$oFP->IdProyecto = $_POST['id_proyecto']; // Por si no lo encuentra.
			$oFP->IdFase = $item;
			$oFP->Guardar();
			
			// Operadores de la fase.
			$oOFP->IdProyecto = $_POST['id_proyecto'];
			$oOFP->IdFase = $item;
			$aAsignados = $oOFP->Buscar();
			
			foreach ($aAsignados as $item_asignado) {
				$nKey = array_search($item_asignado['id_operador'], (array) @$_POST['id_operador'][$item]);
				if ($nKey !== false) {
					// El operador asignado está en el post, no hay cambios.
					// Se quita del post para después hacer los insert.
					unset($_POST['id_operador'][$item][$nKey]);
				}
				else {
					// Si el operador asignado no está en el post, lo quita.
					$oOFP->IdProyecto = $_POST['id_proyecto'];
					$oOFP->IdFase = $item;
					$oOFP->IdOperador = $item_asignado['id_operador'];
					$oOFP->Eliminar();
				}
			}
			
			
			$oOFP->IdProyecto = $_POST['id_proyecto'];
			$oOFP->IdFase = $item;
			foreach ((array) @$_POST['id_operador'][$item] as $id_operador) {
				$oOFP->IdOperador = $id_operador;
				$oOFP->Posicion = $oOFP->UltimaPosicion();
				$oOFP->Guardar();
			}
			
			// Limpia las propiedades para el proximo ciclo.
			$oFP->Limpiar();
		}
		
		// Si se habia borrado la fase limpia  los datos.
		foreach ((array) @$_POST['fase_ant'] as $id_fase => $item) {
			if ($item && !in_array($id_fase, (array) @$_POST['fase'])) {
				$oFP->Limpiar();
				$oFP->IdProyecto = $_POST['id_proyecto'];
				$oFP->IdFase = $id_fase;
				$oFP->Obtener();
				$oFP->Eliminar();
				
				$oOFP->Limpiar();
				$oOFP->IdProyecto = $_POST['id_proyecto'];
				$oOFP->IdFase = $id_fase;
				$oOFP->Eliminar();
			}
		}
		
		header("Location: ?p=proyectos|editar&id_proyecto={$_POST['id_proyecto']}");
		die;
	}
	
	/**
	 * @desc
	 * Buscador AJAX de Proyectos.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['id_cliente']) {
				$this->Proyectos->IdCliente = $_GET['id_cliente'];
			}
			if (@$_GET['id_tipoproyecto']) {
				$this->Proyectos->IdTipoproyecto = $_GET['id_tipoproyecto'];
			}
		}
		
		//$this->Proyectos->Activo = null;
		$this->Proyectos->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Proyectos->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Proyectos->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('proyectos/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('proyectos/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Proyectos->IdProyecto = $_POST['id_proyecto'];
		$this->Proyectos->IdCliente = $_POST['id_cliente'];
		$this->Proyectos->IdTipoproyecto = $_POST['id_tipoproyecto'];
		$this->Proyectos->Nombre = $_POST['nombre'];
		$this->Proyectos->FechaCarga = $_POST['fecha_carga'];
		$this->Proyectos->InicioEstimado = $_POST['inicio_estimado'];
		$this->Proyectos->FinEstimado = $_POST['fin_estimado'];
		$this->Proyectos->InicioReal = $_POST['inicio_real'];
		$this->Proyectos->FinReal = $_POST['fin_real'];
		$this->Proyectos->Descripcion = $_POST['descripcion'];
		$this->Proyectos->Comentario = $_POST['comentario'];
		$this->Proyectos->NotasPrivadas = $_POST['notas_privadas'];
		$this->Proyectos->Guardar();
		
		echo $this->Proyectos->IdProyecto;
	}
	
	/**
	 * @desc
	 * Marca un registro como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Proyectos->IdProyecto = $_POST['id_proyecto'];
		$aData['eliminado'] = $this->Proyectos->Eliminar();
		
		echo json_encode($aData);
	}
	
	/**
	 * @desc
	 * Devuelve un Proyectos.
	 *
	 */
	public function x_obtener() {
		$this->Proyectos->IdProyecto = $_GET['id_proyecto'];
		$aDatos = $this->Proyectos->Obtener();
		
		echo json_encode($aDatos);
	}
	
	/**
	 * @desc
	 * Actualiza las posiciones de las fases por ajax.
	 *
	 */
	public function x_actualizar_fases() {
		$oOFP = new Operadores_fp();
		
		foreach ((array) @$_POST['id_proyecto'] as $pos => $item) {
			if (@$_GET['id_operador']) {
				$oOFP->IdOperador = $_GET['id_operador'];
				$oOFP->IdProyecto = $item;
				$oOFP->IdFase = $_GET['id_fase'];
				$oOFP->Posicion = $pos;
				$oOFP->Guardar();
			}
			else {
				$this->Proyectos->IdProyecto = $item;
				$this->Proyectos->Obtener();
				
				$this->Proyectos->IdFaseactiva = $_GET['id_fase'];
				$this->Proyectos->IdEstadofase = $_GET['id_estadofase'];
				$this->Proyectos->Posicion = $pos;
				$this->Proyectos->Guardar();
			}
		}
	}
	
	public function x_seguimiento_fases() {
		$oSF = new Seguimientos_fase();
		$oSF->IdProyecto = $_POST['id_proyecto'];
		$oSF->IdFase = $_POST['id_fase'];
		$oSF->IdEstadofase = $_POST['id_estadofase'];
		$oSF->Guardar();
		
		$oFP = new Fases_proyecto();
		$oFP->IdProyecto = $oSF->IdProyecto;
		$oFP->IdFase = $oSF->IdFase;
		$oFP->Obtener();
		
		if ($oFP->InicioEstimado == null || $oFP->InicioEstimado == '0000-00-00') {
			$oFP->InicioEstimado = date('Y-m-d');
			$oFP->Guardar();
		}
	}
	
	public function x_fecha_fase() {
		$this->Proyectos->IdProyecto = $_GET['id_proyecto'];
		$this->Buffer['datos'] = $this->Proyectos->Obtener();
		
		$this->Buffer['body'] = $this->Template->Load('proyectos/x-fecha_fase.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	public function x_guardar_fecha_fase() {
		$this->Proyectos->IdProyecto = $_POST['id_proyecto'];
		$this->Proyectos->Obtener();
		$this->Proyectos->FechaFase = date2mysql($_POST['fecha_fase']);
		$this->Proyectos->Guardar();
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Proyectos->Nombre = @$_GET['q'];
		
		if (@$_GET['id_cliente']) {
			$this->Proyectos->IdCliente = $_GET['id_cliente'];
		}
		
		if (isset($_GET['abierto']) && $_GET['abierto'] == true) {
			$this->Proyectos->FinReal = false;
		}
		
		$this->Proyectos->OrderBy = 'nombre';
		$this->Proyectos->LimitCant = 50;
		$aDatos = $this->Proyectos->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['nombre'])."|{$item['id_proyecto']}|".str_replace('|', '', $item['cliente'])."\n";
		}
	}
}

$oCont = new ProyectosCtl();
if (method_exists($oCont, $METHOD)) {

	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>