<?
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR, PERMISOS_FACTURACION, PERMISOS_VENTAS)) {
	header("Location: ?p=login");
	die;
}

class RubrosCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Rubros.
	 *
	 * @var Rubros
	 */
	private $Rubros;
		
	function __construct() {
		parent::__construct();
		$this->Rubros = new Rubros();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Rubros.
	 *
	 */
	public function listado() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Rubros->Nombre = $_GET['nombre'];
			}
		}
		
		if(isset($_GET['alfabetica'])) {
			$this->Rubros->PorLetra = $_GET['alfabetica'];
		}
		
		$this->Rubros->Page = @$_GET['pg'];
		$this->Rubros->OrderBy = 'nombre';
		$this->Buffer['listado'] = $this->Rubros->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Rubros->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('rubros/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Rubros.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Rubros y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Rubros->IdRubro = $_GET['id_rubro'];
		$this->Buffer['datos'] = $this->Rubros->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Rubros.
	 *
	 */
	public function formulario() {
		$this->Buffer['body'] = $this->Template->Load('rubros/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Rubros.
	 *
	 */
	public function guardar() {
		$this->Rubros->IdRubro = $_POST['id_rubro'];
		$this->Rubros->Obtener();
		$this->Rubros->Nombre = $_POST['nombre'];
		$this->Rubros->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=rubros"); }
		die;
	}
		
	/**
	 * @desc
	 * Buscador AJAX de Rubros.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Rubros->Nombre = $_GET['nombre'];
			}
		}
		
		//$this->Rubros->Activo = null;
		$this->Rubros->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Rubros->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Rubros->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('rubros/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('rubros/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Rubros->IdRubro = $_POST['id_rubro'];
		$this->Rubros->Nombre = $_POST['nombre'];
		$this->Rubros->Guardar();
		
		echo $this->Rubros->IdRubro;
	}
	
	/**
	 * @desc
	 * Marca un registro como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Rubros->IdRubro = $_POST['id_rubro'];
		$aData['eliminado'] = $this->Rubros->Eliminar();
		
		echo json_encode($aData);
	}
	
	/**
	 * @desc
	 * Devuelve un Rubros.
	 *
	 */
	public function x_obtener() {
		$this->Rubros->IdRubro = $_GET['id_rubro'];
		$aDatos = $this->Rubros->Obtener();
		
		echo json_encode($aDatos);
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Rubros->Nombre = @$_GET['q'];
		$this->Rubros->OrderBy = 'nombre';
		$this->Rubros->LimitCant = 50;
		$aDatos = $this->Rubros->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['nombre'])."|{$item['id_rubro']}\n";
		}
	}
}

$oCont = new RubrosCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>