<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR, PERMISOS_FACTURACION, PERMISOS_VENTAS)) {
	header("Location: ?p=login");
	die;
}

class Seguimiento_clientesCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Seguimientos
	 *
	 * @var Seguimientos
	 */
	private $Seguimientos;
		
	function __construct() {
		parent::__construct();
		$this->Seguimientos = new Seguimientos();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->editar();
	}
	
	/**
	 * @desc
	 * Listado de Seguimiento_clientes.
	 *
	 */
	public function listado() {
		$this->menu_lateral();
		
		if (isset($_GET['buscar'])) {
			if (@$_GET['id_cliente']) {
				$this->Seguimientos->IdEntidad = $_GET['id_cliente'];
				$this->Seguimientos->IdSector = ELEMENTOS_CLIENTE;
			}
			if (@$_GET['fecha']) {
				$this->Seguimientos->Fecha = $_GET['fecha'];
			}
			if (@$_GET['texto']) {
				$this->Seguimientos->Texto = $_GET['texto'];
			}
		}
		
		$this->Seguimientos->Page = @$_GET['pg'];
		$this->Seguimientos->OrderBy = 'id_seguimiento';
		$this->Buffer['listado'] = $this->Seguimientos->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Seguimientos->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('seguimiento_clientes/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Seguimiento_clientes.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Seguimiento_clientes y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Seguimientos->IdEntidad = $_GET['id_cliente'];
		$this->Seguimientos->IdSector = ELEMENTOS_CLIENTE;
		$this->Seguimientos->OrderBy = 'fecha DESC';
		$this->Buffer['listado'] = $this->Seguimientos->Buscar();
		
		$oCliente = new Clientes();
		$oCliente->IdCliente = $this->Seguimientos->IdEntidad;
		$this->Buffer['datos'] = $oCliente->Obtener();
		
		$this->Buffer['body'] = $this->Template->Load('seguimiento_clientes/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Formulario de Seguimiento_clientes.
	 *
	 */
	public function formulario() {
		$this->menu_lateral();
		
		$this->Buffer['paso'] = 1;
		
		//$this->Buffer['formulario'] = $this->Template->Load('seguimiento_clientes/formulario-seguimiento_clientes.tpl.php', $this->Buffer);
		//$this->Buffer['body'] = $this->Template->Load('seguimiento_clientes/formulario.tpl.php', $this->Buffer);
		$this->Buffer['body'] = $this->Template->Load('seguimiento_clientes/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Seguimiento_clientes.
	 *
	 */
	public function guardar() {
		$this->Seguimientos->IdSeguimiento = $_POST['id_seguimiento'];
		$this->Seguimientos->Obtener();
		$this->Seguimientos->IdEntidad = $_POST['id_entidad'];
		$this->Seguimientos->IdSector = $_POST['id_sector'];
		$this->Seguimientos->Fecha = date2mysql($_POST['fecha']);
		$this->Seguimientos->Texto = $_POST['texto'];
		$this->Seguimientos->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=seguimiento_clientes"); }
		die;
	}
		
	/**
	 * @desc
	 * Menu lateral para todas las secciones.
	 *
	 */
	private function menu_lateral() {
		$this->Buffer['menu_lateral'] = $this->Template->Load('seguimiento_clientes/menu-lateral.tpl.php');
	}
	
	/**
	 * @desc
	 * Buscador AJAX de Seguimiento_clientes.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['id_cliente']) {
				$this->Seguimientos->IdEntidad = $_GET['id_cliente'];
				$this->Seguimientos->IdSector = ELEMENTOS_CLIENTE;
			}
			if (@$_GET['fecha']) {
				$this->Seguimientos->Fecha = $_GET['fecha'];
			}
		}
		
		//$this->Seguimiento_clientes->Activo = null;
		$this->Seguimientos->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Seguimientos->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Seguimientos->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('seguimiento_clientes/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('seguimiento_clientes/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$_POST['flags'] = (array) @$_POST['flags'];
		
		$this->Seguimientos->IdEntidad = $_POST['id_cliente'];
		$this->Seguimientos->IdSector = ELEMENTOS_CLIENTE;
		$this->Seguimientos->Fecha = date2mysql($_POST['fecha'], '%d/%m/%Y %H:%i', true);
		$this->Seguimientos->Texto = $_POST['texto'];
		$this->Seguimientos->Flags = $_POST['flags'];
		$this->Seguimientos->Guardar();
		
		$aOperadores = explode(',', $_POST['operadores']);
		$oOperador = new Operadores();
		
		$oAlertas = new Alertas_operador();
		
		foreach ($aOperadores as $item) {
			$oOperador->Nombre = trim($item);
			if ($oOperador->Nombre == '') {
				continue;
			}
			
			foreach ($oOperador->Buscar() as $item2) {
				$oAlertas->Limpiar();
				$oAlertas->IdOrigen = $_SESSION['operador']['id_operador'];
				$oAlertas->IdDestino = $item2['id_operador'];
				$oAlertas->Mensaje = "<a href=\'?p=seguimiento_clientes|editar&id_cliente={$_POST['id_cliente']}\' class=\'sin-estilo\'>seguimiento de clientes</a>";
				$oAlertas->Guardar();
			}
		}
		
		$oOperadores = new Operadores();
		$oOperadores->IdOperador = $_SESSION['operador']['id_operador'];
		$oOperadores->Obtener();
		$_POST['operador'] = $oOperadores->Nombre;
		
		$_POST['flags_libres'] = array_values(array_diff(array("1","2","3","4"), $_POST['flags']));
		
		$_POST['texto'] = nl2br($_POST['texto']);
		echo json_encode($_POST);
	}
	
	/**
	 * @desc
	 * Marca un seguimiento_clientes como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Seguimientos->IdSeguimiento = $_POST['id_seguimiento'];
		$this->Seguimientos->Eliminar();
	}
	
	/**
	 * @desc
	 * Devuelve un Seguimiento_clientes.
	 *
	 */
	public function x_obtener() {
		$this->Seguimientos->IdSeguimiento = $_GET['id_seguimiento'];
		$aDatos = $this->Seguimientos->Obtener();
		
		echo json_encode($aDatos);
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Seguimientos->IdSeguimiento = @$_GET['q'];
		$this->Seguimientos->OrderBy = 'IdSeguimiento';
		$this->Seguimientos->LimitCant = 50;
		$aDatos = $this->Seguimientos->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_seguimiento'])."|{$item['id_seguimiento']}\n";
		}
	}
}

$oCont = new Seguimiento_clientesCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>