<?
class SeguimientosCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Seguimientos.
	 *
	 * @var Seguimientos
	 */
	private $Seguimientos;
		
	function __construct() {
		parent::__construct();
		$this->Seguimientos = new Seguimientos();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Seguimientos.
	 *
	 */
	public function listado() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['id_sector']) {
				$this->Seguimientos->IdSector = $_GET['id_sector'];
			}
			if (@$_GET['id_entidad']) {
				$this->Seguimientos->IdEntidad = $_GET['id_entidad'];
			}
			if (@$_GET['fecha']) {
				$this->Seguimientos->Fecha = $_GET['fecha'];
			}
			if (@$_GET['texto']) {
				$this->Seguimientos->Texto = $_GET['texto'];
			}
		}
		
		$this->Seguimientos->Page = @$_GET['pg'];
		$this->Seguimientos->OrderBy = 'id_seguimiento';
		$this->Buffer['listado'] = $this->Seguimientos->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Seguimientos->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('seguimientos/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Seguimientos.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Seguimientos y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Seguimientos->IdSeguimiento = $_GET['id_seguimiento'];
		$this->Buffer['datos'] = $this->Seguimientos->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Seguimientos.
	 *
	 */
	public function formulario() {
		$this->Buffer['body'] = $this->Template->Load('seguimientos/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Seguimientos.
	 *
	 */
	public function guardar() {
		$this->Seguimientos->IdSeguimiento = $_POST['id_seguimiento'];
		$this->Seguimientos->Obtener();
		$this->Seguimientos->IdSector = $_POST['id_sector'];
		$this->Seguimientos->IdEntidad = $_POST['id_entidad'];
		$this->Seguimientos->Fecha = date2mysql($_POST['fecha']);
		$this->Seguimientos->Texto = $_POST['texto'];
		$this->Seguimientos->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=seguimientos"); }
		die;
	}
		
	/**
	 * @desc
	 * Buscador AJAX de Seguimientos.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['id_sector']) {
				$this->Seguimientos->IdSector = $_GET['id_sector'];
			}
			if (@$_GET['id_entidad']) {
				$this->Seguimientos->IdEntidad = $_GET['id_entidad'];
			}
		}
		
		//$this->Seguimientos->Activo = null;
		$this->Seguimientos->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Seguimientos->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Seguimientos->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('seguimientos/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta y visualizacion por AJAX.
	 *
	 */
	public function x_formulario() {
		if (isset($_GET['id_proyecto'])) {
			$oProyectos = new Proyectos();
			$oProyectos->IdProyecto = $_GET['id_proyecto'];
			$oProyectos->Obtener();
			
			$this->Buffer['datos']['id_sector'] = ELEMENTOS_PROYECTO;
			$this->Buffer['datos']['id_entidad'] = $_GET['id_proyecto'];
			$this->Buffer['datos']['id_cliente'] = $oProyectos->IdCliente;
			
			$this->Seguimientos->IdSector = ELEMENTOS_PROYECTO;
			$this->Seguimientos->IdEntidad = $_GET['id_proyecto'];
			$this->Seguimientos->OrderBy = 'fecha DESC';
			$this->Seguimientos->LimitCant = 25;
			$this->Buffer['listado'] = $this->Seguimientos->Buscar();
		}
		
		//$this->Buffer['listado'] = array();
		
		$this->Buffer['body'] = $this->Template->Load('seguimientos/x-formulario.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Seguimientos->IdSeguimiento = $_POST['id_seguimiento'];
		$this->Seguimientos->IdSector = $_POST['id_sector'];
		$this->Seguimientos->IdEntidad = $_POST['id_entidad'];
		$this->Seguimientos->Fecha = date('Y-m-d H:i:s');
		$this->Seguimientos->Texto = $_POST['texto'];
		$this->Seguimientos->Flags = (array) @$_POST['flags'];
		$this->Seguimientos->Guardar();
		
		include_once('includes/class.phpmailer.php');
		$oMail = new PHPMailer();
		//$oMail->SMTPDebug = true;
	
		$oMail->AddReplyTo($_SESSION['operador']['email'], $_SESSION['operador']['nombre']);
		$oMail->From = 'sam@estudioquadra.com';
		$oMail->FromName = $_SESSION['operador']['nombre'];
	
		$oMail->SMTPAuth   = true;                  	// enable SMTP authentication
		$oMail->Port       = 465;                    	// set the SMTP port for the GMAIL server
		$oMail->Username   = "sam@estudioquadra.com"; 	// SMTP account username
		$oMail->Password   = "Quadra789";        		// SMTP account password
				
		// Se definen variables necesarias
		$oOperador = new Operadores();
		$oAlertas = new Alertas_operador();
		$oCliente = new Clientes();
		$oProyecto = new Proyectos();
		
		$mail['datos'] = $this->Seguimientos->Obtener();
		
		$oDS = new Destinatarios_seguimiento();
		
		// Cicla por todos los destinatarios.
		foreach ((array) @$_POST['destinatarios'] as $item) {
			$aDestinatario = explode('_', $item);
			
			$nIdDestinatario = $aDestinatario[1];
			
			switch ($aDestinatario[0]) {
				case 'ope':
					$oDS->IdDestinatario = $nIdDestinatario;
					$oDS->IdSeguimiento = $this->Seguimientos->IdSeguimiento;
					$oDS->Guardar();
					
					$oOperador->IdOperador = $nIdDestinatario;
					$oOperador->Obtener();
					$mail['email'] = $oOperador->Email;
					
					$oAlertas->Limpiar();
					$oAlertas->IdOrigen = $_SESSION['operador']['id_operador'];
					$oAlertas->IdDestino = $nIdDestinatario;
					
					switch ($_POST['id_sector']) {
						case ELEMENTOS_CLIENTE:
							$oCliente->Limpiar();
							$oCliente->IdCliente = $mail['datos']['id_entidad'];
							$oCliente->Obtener();
							$mail['datos']['cliente'] = $oCliente->Nombre;
							$mail['datos']['proyecto'] = '';
							
							$oAlertas->Mensaje = "<a href=\'?p=clientes|seguimiento&id_cliente={$_POST['id_entidad']}\' class=\'sin-estilo\'>cliente {$oCliente->Nombre}</a>";
							break;
							
						case ELEMENTOS_PROYECTO:
							$oProyecto->Limpiar();
							$oProyecto->IdProyecto = $mail['datos']['id_entidad'];
							$aProyecto = $oProyecto->Obtener();
							$mail['datos']['cliente'] = $aProyecto['cliente'];
							$mail['datos']['proyecto'] = $oProyecto->Nombre;
							
							$oAlertas->Mensaje = "<a href=\'?p=proyectos|seguimiento&id_proyecto={$_POST['id_entidad']}\' class=\'sin-estilo\'>proyecto {$oProyecto->Nombre}</a>";
							break;
							
						default:
							$mail['datos']['cliente'] = $mail['datos']['proyecto'] = '';
					}
					
					$oAlertas->Guardar();
					$asunto = "{$mail['datos']['cliente']} - {$mail['datos']['proyecto']} - Nota de seguimiento";
					break;
					
				case 'cli':
					switch ($_POST['id_sector']) {
						case ELEMENTOS_CLIENTE:
							$oCliente->Limpiar();
							$oCliente->IdCliente = $mail['datos']['id_entidad'];
							$oCliente->Obtener();
							$mail['datos']['cliente'] = $oCliente->Nombre;
							$mail['datos']['proyecto'] = '';
							break;
							
						case ELEMENTOS_PROYECTO:
							$oProyecto->Limpiar();
							$oProyecto->IdProyecto = $mail['datos']['id_entidad'];
							$aProyecto = $oProyecto->Obtener();
							$mail['datos']['cliente'] = $aProyecto['cliente'];
							$mail['datos']['proyecto'] = $oProyecto->Nombre;
							break;
							
						default:
							$mail['datos']['cliente'] = $mail['datos']['proyecto'] = '';
					}
					
					
					$oCliente->IdCliente = $nIdDestinatario;
					$oCliente->Obtener();
					$mail['email'] = $oCliente->Email;
					$asunto = "Estudio Quadra - Seguimiento de su Proyecto";
					break;
			}
			
			if ($mail['email']) {
				$mail['datos']['flags'] = (array) @$_POST['flags'];
				$mail['body'] = $this->Template->Load('mails/seguimiento.tpl.php', $mail['datos']);
				if (@$_SESSION['acceso'] == 'sq') {
					$cuerpo = $this->Template->Load('mails/base-sq.tpl.php', $mail);
				}
				else {
					$cuerpo = $this->Template->Load('mails/base.tpl.php', $mail);
				}
				
				$oMail->ClearAddresses();
				$oMail->ClearAttachments();
				
				$oMail->AddAddress($mail['email']);
				
				$oMail->Subject = $asunto;
				$oMail->MsgHTML($cuerpo);
				
				$oMail->Send();
			}
		}
		
		$oOperadores = new Operadores();
		$oOperadores->IdOperador = $_SESSION['operador']['id_operador'];
		$oOperadores->Obtener();
		$_POST['operador'] = $oOperadores->Nombre;
		
		$_POST['flags_libres'] = array_values(array_diff(array(SEGUIMIENTO_FLAG_CRITICO,SEGUIMIENTO_FLAG_CAMBIO,SEGUIMIENTO_FLAG_AVISO,SEGUIMIENTO_FLAG_SCRIPT,SEGUIMIENTO_FLAG_ROJO,SEGUIMIENTO_FLAG_AMARILLO,SEGUIMIENTO_FLAG_VERDE), (array) @$_POST['flags']));
		
		$_POST['texto'] = nl2br($_POST['texto']);
		echo json_encode($_POST);
	}
	
	/**
	 * @desc
	 * Marca un registro como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Seguimientos->IdSeguimiento = $_POST['id_seguimiento'];
		$aData['eliminado'] = $this->Seguimientos->Eliminar();
		
		echo json_encode($aData);
	}
	
	/**
	 * @desc
	 * Devuelve un Seguimientos.
	 *
	 */
	public function x_obtener() {
		$this->Seguimientos->IdSeguimiento = $_GET['id_seguimiento'];
		$aDatos = $this->Seguimientos->Obtener();
		
		echo json_encode($aDatos);
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Seguimientos->IdSeguimiento = @$_GET['q'];
		$this->Seguimientos->OrderBy = 'IdSeguimiento';
		$this->Seguimientos->LimitCant = 50;
		$aDatos = $this->Seguimientos->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_seguimiento'])."|{$item['id_seguimiento']}\n";
		}
	}
}

$oCont = new SeguimientosCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>