<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR, PERMISOS_FACTURACION, PERMISOS_VENTAS)) {
	header("Location: ?p=login");
	die;
}

class ServiciosCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Servicios.
	 *
	 * @var Servicios
	 */
	private $Servicios;
		
	function __construct() {
		parent::__construct();
		$this->Servicios = new Servicios();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Servicios.
	 *
	 */
	public function listado() {
		if (!isset($_GET['activo'])) {
			$_GET['activo'] = 1;
		}
		
		if (isset($_GET['buscar'])) {
			if (@$_GET['id_tiposervicio']) {
				$this->Servicios->IdTiposervicio = $_GET['id_tiposervicio'];
			}
			if (@$_GET['id_cliente']) {
				$this->Servicios->IdCliente = $_GET['id_cliente'];
			}
			if (@$_GET['id_proyecto']) {
				$this->Servicios->IdProyecto = $_GET['id_proyecto'];
			}
			if (@$_GET['por_vencer']) {
				$this->Servicios->PorVencer = true;
			}
		}
		
		$this->Servicios->FechaBaja = $_GET['activo'] ? false : true;
		
		$this->Servicios->Page = @$_GET['pg'];
		$this->Servicios->OrderBy = 'cliente';
		$this->Buffer['listado'] = $this->Servicios->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Servicios->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('servicios/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Servicios.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Servicios y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Servicios->IdServicio = $_GET['id_servicio'];
		$this->Buffer['datos'] = $this->Servicios->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Servicios.
	 *
	 */
	public function formulario() {
		$this->Buffer['body'] = $this->Template->Load('servicios/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Servicios.
	 *
	 */
	public function guardar() {
		$this->Servicios->IdServicio = $_POST['id_servicio'];
		$this->Servicios->Obtener();
		$this->Servicios->IdTiposervicio = $_POST['id_tiposervicio'];
		$this->Servicios->Horas = $_POST['horas'];
		$this->Servicios->IdCliente = $_POST['id_cliente'];
		$this->Servicios->IdProyecto = $_POST['id_proyecto'];
		$this->Servicios->Nombre = $_POST['nombre'];
		$this->Servicios->FechaAlta = date2mysql($_POST['fecha_alta']);
		$this->Servicios->FechaActivacion = date2mysql($_POST['fecha_activacion']);
		$this->Servicios->FechaVencimiento = date2mysql($_POST['fecha_vencimiento']);
		$this->Servicios->FechaFacturacion = date2mysql($_POST['fecha_facturacion']);
		$this->Servicios->FechaBaja = date2mysql($_POST['fecha_baja']);
		$this->Servicios->IdPeriodo = $_POST['id_periodo'];
		$this->Servicios->Importe = $_POST['importe'];
		$this->Servicios->Cuotas = $_POST['cuotas'];
		$this->Servicios->TextoOrden = $_POST['texto_orden'];
		$this->Servicios->Descripcion = $_POST['descripcion'];
		$this->Servicios->Comentario = $_POST['comentario'];
		$this->Servicios->Guardar();
		
		// Si está insertando genera todas las órdenes.
		if ($_POST['id_servicio'] == null || @$_POST['renovar']) {
			$oOrden = new Ordenes();
			
			preg_match('/([0-9]+)\/([0-9]+)\/([0-9]+)/', $_POST['fecha_facturacion'], $aFechaFacturacion);
			
			for ($i=1; $i<=$_POST['cuotas']; ++$i) {
				$oOrden->IdCliente = $this->Servicios->IdCliente;
				$oOrden->Importe = $_POST['importe'];
				
				$nTime = mktime(0, 0, 0, $aFechaFacturacion[2]+ ($i-1) * $_POST['id_periodo'], $aFechaFacturacion[1], $aFechaFacturacion[3]);
				$nTimeTxt = mktime(0, 0, 0, $aFechaFacturacion[2]+ ($i-1) * $_POST['id_periodo'] - 1, $aFechaFacturacion[1], $aFechaFacturacion[3]);
				$oOrden->Fecha = date('Y-m-d', $nTime);
				
				$cTextoOrden = str_replace(array('%n', '%t', '%m', '%y'), array($i, $_POST['cuotas'], strftime('%B', $nTimeTxt), date('Y', $nTimeTxt)), $_POST['texto_orden']);
				$oOrden->Descripcion = $cTextoOrden;
				$oOrden->DescripcionFactura = $cTextoOrden;
				
				$oOrden->Guardar();
				$oOrden->Limpiar();
			}
		}
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=servicios"); }
		die;
	}
		
	/**
	 * @desc
	 * Buscador AJAX de Servicios.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['id_tiposervicio']) {
				$this->Servicios->IdTiposervicio = $_GET['id_tiposervicio'];
			}
			if (@$_GET['id_cliente']) {
				$this->Servicios->IdCliente = $_GET['id_cliente'];
			}
		}
		
		//$this->Servicios->Activo = null;
		$this->Servicios->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Servicios->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Servicios->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('servicios/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('servicios/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Servicios->IdServicio = $_POST['id_servicio'];
		$this->Servicios->IdTiposervicio = $_POST['id_tiposervicio'];
		$this->Servicios->IdCliente = $_POST['id_cliente'];
		$this->Servicios->IdProyecto = $_POST['id_proyecto'];
		$this->Servicios->FechaAlta = $_POST['fecha_alta'];
		$this->Servicios->FechaActivacion = $_POST['fecha_activacion'];
		$this->Servicios->FechaBaja = $_POST['fecha_baja'];
		$this->Servicios->FechaFacturacion = $_POST['fecha_facturacion'];
		$this->Servicios->FechaVencimiento = date2mysql($_POST['fecha_vencimiento']);
		$this->Servicios->IdPeriodo = $_POST['id_periodo'];
		$this->Servicios->Importe = $_POST['importe'];
		$this->Servicios->Cuotas = $_POST['cuotas'];
		$this->Servicios->TextoOrden = $_POST['texto_orden'];
		$this->Servicios->Descripcion = $_POST['descripcion'];
		$this->Servicios->Comentario = $_POST['comentario'];
		$this->Servicios->IdOrden = $_POST['id_orden'];
		$this->Servicios->Guardar();
		
		echo $this->Servicios->IdServicio;
	}
	
	/**
	 * @desc
	 * Marca un registro como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Servicios->IdServicio = $_POST['id_servicio'];
		$aData['eliminado'] = $this->Servicios->Eliminar();
		
		echo json_encode($aData);
	}
	
	/**
	 * @desc
	 * Devuelve un Servicios.
	 *
	 */
	public function x_obtener() {
		$this->Servicios->IdServicio = $_GET['id_servicio'];
		$aDatos = $this->Servicios->Obtener();
		
		echo json_encode($aDatos);
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Servicios->IdServicio = @$_GET['q'];
		$this->Servicios->OrderBy = 'IdServicio';
		$this->Servicios->LimitCant = 50;
		$aDatos = $this->Servicios->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_servicio'])."|{$item['id_servicio']}\n";
		}
	}
}

$oCont = new ServiciosCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>