<?
class TareasCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Tareas.
	 *
	 * @var Tareas
	 */
	private $Tareas;
		
	function __construct() {
		parent::__construct();
		$this->Tareas = new Tareas();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Tareas.
	 *
	 */
	public function listado() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['id_sector']) {
				$this->Tareas->IdSector = $_GET['id_sector'];
			}
			if (@$_GET['id_entidad']) {
				$this->Tareas->IdEntidad = $_GET['id_entidad'];
			}
			if (@$_GET['id_operador']) {
				$this->Tareas->IdOperador = $_GET['id_operador'];
			}
			if (@$_GET['fecha_creada']) {
				$this->Tareas->FechaCreada = $_GET['fecha_creada'];
			}
			if (@$_GET['fecha_cerrada']) {
				$this->Tareas->FechaCerrada = $_GET['fecha_cerrada'];
			}
			if (@$_GET['texto']) {
				$this->Tareas->Texto = $_GET['texto'];
			}
			if (@$_GET['cerrada']) {
				$this->Tareas->Cerrada = $_GET['cerrada'];
			}
		}
		
		$this->Tareas->Page = @$_GET['pg'];
		$this->Tareas->OrderBy = 'id_tarea';
		$this->Buffer['listado'] = $this->Tareas->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Tareas->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('tareas/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Tareas.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Tareas y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Tareas->IdTarea = $_GET['id_tarea'];
		$this->Buffer['datos'] = $this->Tareas->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Tareas.
	 *
	 */
	public function formulario() {
		$this->Buffer['body'] = $this->Template->Load('tareas/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Tareas.
	 *
	 */
	public function guardar() {
		$this->Tareas->IdTarea = $_POST['id_tarea'];
		$this->Tareas->Obtener();
		$this->Tareas->IdSector = $_POST['id_sector'];
		$this->Tareas->IdEntidad = $_POST['id_entidad'];
		$this->Tareas->IdOperador = $_POST['id_operador'];
		$this->Tareas->FechaCreada = date2mysql($_POST['fecha_creada']);
		$this->Tareas->FechaCerrada = date2mysql($_POST['fecha_cerrada']);
		$this->Tareas->Texto = $_POST['texto'];
		$this->Tareas->Cerrada = $_POST['cerrada'];
		$this->Tareas->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=tareas"); }
		die;
	}
		
	/**
	 * @desc
	 * Buscador AJAX de Tareas.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['id_sector']) {
				$this->Tareas->IdSector = $_GET['id_sector'];
			}
			if (@$_GET['id_entidad']) {
				$this->Tareas->IdEntidad = $_GET['id_entidad'];
			}
		}
		
		//$this->Tareas->Activo = null;
		$this->Tareas->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Tareas->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Tareas->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('tareas/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('tareas/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$oOperadores = new Operadores();
		$oOperadores->IdOperador = $_SESSION['operador']['id_operador'];
		$oOperadores->Obtener();
		$_POST['operador'] = $oOperadores->Nombre;
		
		//$this->Tareas->IdTarea = $_POST['id_tarea'];
		$this->Tareas->IdSector = $_POST['id_sector'];
		$this->Tareas->IdEntidad = $_POST['id_entidad'];
		$this->Tareas->IdOperador = $oOperadores->IdOperador;
		$this->Tareas->Texto = $_POST['texto'];
		//$this->Tareas->Cerrada = $_POST['cerrada'];
		$_POST['id_tarea'] = $this->Tareas->Guardar();
		
		$_POST['fecha_creada'] = date('d/m/Y H:i');
		$_POST['fecha_cerrada'] = null;
		$_POST['texto'] = nl2br($_POST['texto']);
		echo json_encode(array_map('stripslashes', $_POST));
	}
	
	/**
	 * @desc
	 * Marca una tarea como cerrada o el estado inverso.
	 *
	 */
	public function x_ac() {
		$this->Tareas->IdTarea = $_POST['id_tarea'];
		$this->Tareas->Obtener();
		
		if ($_POST['cerrada'] == 'checked') {
			$this->Tareas->Cerrada = 1;
			$this->Tareas->FechaCerrada = date('Y-m-d H:i:s');
		}
		else {
			$this->Tareas->Cerrada = 0;
			$this->Tareas->FechaCerrada = null;
		}
		
		$this->Tareas->Guardar();
	}
	
	/**
	 * @desc
	 * Marca un registro como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Tareas->IdTarea = $_POST['id_tarea'];
		$aData['eliminado'] = $this->Tareas->Eliminar();
		
		echo json_encode($aData);
	}
	
	/**
	 * @desc
	 * Devuelve un Tareas.
	 *
	 */
	public function x_obtener() {
		$this->Tareas->IdTarea = $_GET['id_tarea'];
		$aDatos = $this->Tareas->Obtener();
		
		echo json_encode($aDatos);
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Tareas->IdTarea = @$_GET['q'];
		$this->Tareas->OrderBy = 'IdTarea';
		$this->Tareas->LimitCant = 50;
		$aDatos = $this->Tareas->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_tarea'])."|{$item['id_tarea']}\n";
		}
	}
}

$oCont = new TareasCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>