<?
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR, PERMISOS_GESTION, PERMISOS_FACTURACION, PERMISOS_VENTAS)) {
	header("Location: ?p=login");
	die;
}

class TicketsCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Tickets.
	 *
	 * @var Tickets
	 */
	private $Tickets;
		
	function __construct() {
		parent::__construct();
		$this->Tickets = new Tickets();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Tickets.
	 *
	 */
	public function listado() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['fecha_ingreso']) {
				$this->Tickets->FechaIngreso = $_GET['fecha_ingreso'];
			}
			if (@$_GET['fecha_resuelto']) {
				$this->Tickets->FechaResuelto = $_GET['fecha_resuelto'];
			}
			if (@$_GET['id_cliente']) {
				$this->Tickets->IdCliente = $_GET['id_cliente'];
			}
			if (@$_GET['id_proyecto']) {
				$this->Tickets->IdProyecto = $_GET['id_proyecto'];
			}
			if (@$_GET['mensaje']) {
				$this->Tickets->Mensaje = $_GET['mensaje'];
			}
			if (@$_GET['respuesta']) {
				$this->Tickets->Respuesta = $_GET['respuesta'];
			}
		}
		
		$this->Tickets->Abierto = true;
		
		$this->Tickets->Page = @$_GET['pg'];
		$this->Tickets->OrderBy = 'tickets.fecha_ingreso';
		$this->Buffer['listado'] = $this->Tickets->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Tickets->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('tickets/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Tickets.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Tickets y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Tickets->IdTicket = $_GET['id_ticket'];
		$this->Buffer['datos'] = $this->Tickets->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Tickets.
	 *
	 */
	public function formulario() {
		$this->Buffer['body'] = $this->Template->Load('tickets/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Tickets.
	 *
	 */
	public function guardar() {
		$this->Tickets->IdTicket = $_POST['id_ticket'];
		$this->Tickets->Obtener();
		
		include_once('includes/class.phpmailer.php');
		$oMail = new PHPMailer();
		//$oMail->SMTPDebug = true;
		$oMail->IsSMTP(); // telling the class to use SMTP
		$oMail->CharSet = 'utf-8';
		$oMail->Hostname = "smtp.gmail.com"; // SMTP server
		$oMail->Host = "ssl://smtp.gmail.com"; // SMTP server
		$oMail->Port = "465"; // SMTP server
		$oMail->SMTPAuth = true;
		$oMail->Username = 'sam@estudioquadra.com';
		$oMail->Password = 'sam123';
		//$oMail->AddReplyTo('sam@estudioquadra.com', 'SAM Estudio Quadra');
		$oMail->From = 'sam@estudioquadra.com';
		$oMail->FromName = 'SAM Estudio Quadra';
		
		$nCerrado = $this->Tickets->FechaResuelto == null && $_POST['fecha_resuelto'];
		
		$this->Tickets->FechaIngreso = date2mysql($_POST['fecha_ingreso'], '%d/%m/%Y %H:%i', true);
		$this->Tickets->FechaResuelto = date2mysql($_POST['fecha_resuelto'], '%d/%m/%Y %H:%i', true);
		$this->Tickets->IdCliente = $_POST['id_cliente'];
		$this->Tickets->IdProyecto = $_POST['id_proyecto'];
		$this->Tickets->Mensaje = $_POST['mensaje'];
		$this->Tickets->Respuesta = $_POST['respuesta'];
		$this->Tickets->Avisar = $_POST['avisar'];
		$this->Tickets->Guardar();
		
		if ($nCerrado) {
			$mail['datos'] = $this->Tickets->Obtener();
			
			$aOperadores = explode(',', $_POST['avisar']);
			$oOperador = new Operadores();
			
			$oAlertas = new Alertas_operador();
			
			foreach ($aOperadores as $item) {
				$oOperador->Nombre = trim($item);
				if ($oOperador->Nombre == '') {
					continue;
				}
				
				foreach ($oOperador->Buscar() as $item2) {
					$oAlertas->Limpiar();
					$oAlertas->IdOrigen = $_SESSION['operador']['id_operador'];
					$oAlertas->IdDestino = $item2['id_operador'];
					$oAlertas->Mensaje = "<a href=\'?p=tickets|editar&id_ticket={$this->Tickets->IdTicket}\' class=\'sin-estilo\'>ticket cerrado</a>";
					$oAlertas->Guardar();
					
					if ($item2['email']) {
						$mail['body'] = $this->Template->Load('mails/ticket-cerrado.tpl.php', $mail['datos']);
						$cuerpo = $this->Template->Load('mails/base.tpl.php', $mail);
						
						$oMail->ClearAddresses();
						$oMail->ClearAttachments();
						
						$oMail->AddAddress($item2['email']);
						
						$oMail->Subject = "{$mail['datos']['cliente']} - TICKET CERRADO";
						$oMail->MsgHTML($cuerpo);
						
						$oMail->Send();
						//$nOk = mail($item2['email'], "{$mail['datos']['cliente']} - TICKET CERRADO", $cuerpo, "From: sam@estudioquadra.com\nContent-type: text/html;charset=utf-8");
					}
				}
			}
		}
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=tickets"); }
		die;
	}
		
	/**
	 * @desc
	 * Buscador AJAX de Tickets.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['fecha_ingreso']) {
				$this->Tickets->FechaIngreso = $_GET['fecha_ingreso'];
			}
			if (@$_GET['fecha_resuelto']) {
				$this->Tickets->FechaResuelto = $_GET['fecha_resuelto'];
			}
		}
		
		//$this->Tickets->Activo = null;
		$this->Tickets->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Tickets->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Tickets->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('tickets/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('tickets/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Tickets->IdTicket = $_POST['id_ticket'];
		$this->Tickets->FechaIngreso = $_POST['fecha_ingreso'];
		$this->Tickets->FechaResuelto = $_POST['fecha_resuelto'];
		$this->Tickets->IdCliente = $_POST['id_cliente'];
		$this->Tickets->IdProyecto = $_POST['id_proyecto'];
		$this->Tickets->Mensaje = $_POST['mensaje'];
		$this->Tickets->Respuesta = $_POST['respuesta'];
		$this->Tickets->Avisar = $_POST['avisar'];
		$this->Tickets->Guardar();
		
		echo $this->Tickets->IdTicket;
	}
	
	/**
	 * @desc
	 * Marca un registro como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Tickets->IdTicket = $_POST['id_ticket'];
		$aData['eliminado'] = $this->Tickets->Eliminar();
		
		echo json_encode($aData);
	}
	
	/**
	 * @desc
	 * Devuelve un Tickets.
	 *
	 */
	public function x_obtener() {
		$this->Tickets->IdTicket = $_GET['id_ticket'];
		$aDatos = $this->Tickets->Obtener();
		
		echo json_encode($aDatos);
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Tickets->IdTicket = @$_GET['q'];
		$this->Tickets->OrderBy = 'IdTicket';
		$this->Tickets->LimitCant = 50;
		$aDatos = $this->Tickets->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_ticket'])."|{$item['id_ticket']}\n";
		}
	}
}

$oCont = new TicketsCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>