<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR) && $METHOD != 'x_autocompletar') {
	header("Location: ?p=login");
	die;
}

class Tipos_facturaCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Tipos_factura.
	 *
	 * @var Tipos_factura
	 */
	private $Tipos_factura;
		
	function __construct() {
		parent::__construct();
		$this->Tipos_factura = new Tipos_factura();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Tipos_factura.
	 *
	 */
	public function listado() {
		$this->menu_lateral();
		
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Tipos_factura->Nombre = $_GET['nombre'];
			}
		}
		
		if(isset($_GET['alfabetica'])) {
			$this->Tipos_factura->PorLetra = $_GET['alfabetica'];
		}
		
		$this->Tipos_factura->Page = @$_GET['pg'];
		$this->Tipos_factura->OrderBy = 'nombre';
		$this->Buffer['listado'] = $this->Tipos_factura->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Tipos_factura->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('tipos_factura/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Tipos_factura.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Tipos_factura y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Tipos_factura->IdTipofactura = $_GET['id_tipofactura'];
		$this->Buffer['datos'] = $this->Tipos_factura->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Tipos_factura.
	 *
	 */
	public function formulario() {
		$this->menu_lateral();
		
		$this->Buffer['paso'] = 1;
		
		//$this->Buffer['formulario'] = $this->Template->Load('tipos_factura/formulario-tipos_factura.tpl.php', $this->Buffer);
		//$this->Buffer['body'] = $this->Template->Load('tipos_factura/formulario.tpl.php', $this->Buffer);
		$this->Buffer['body'] = $this->Template->Load('tipos_factura/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Tipos_factura.
	 *
	 */
	public function guardar() {
		$this->Tipos_factura->IdTipofactura = $_POST['id_tipofactura'];
		$this->Tipos_factura->Obtener();
		$this->Tipos_factura->Nombre = $_POST['nombre'];
		$this->Tipos_factura->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=tipos_factura"); }
		die;
	}
		
	/**
	 * @desc
	 * Menu lateral para todas las secciones.
	 *
	 */
	private function menu_lateral() {
		$this->Buffer['menu_lateral'] = $this->Template->Load('tipos_factura/menu-lateral.tpl.php');
	}
	
	/**
	 * @desc
	 * Buscador AJAX de Tipos_factura.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Tipos_factura->Nombre = $_GET['nombre'];
			}
		}
		
		//$this->Tipos_factura->Activo = null;
		$this->Tipos_factura->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Tipos_factura->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Tipos_factura->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('tipos_factura/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('tipos_factura/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Tipos_factura->IdTipofactura = $_POST['id_tipofactura'];
		$this->Tipos_factura->Nombre = $_POST['nombre'];
		$this->Tipos_factura->Guardar();
		
		echo $this->Tipos_factura->IdTipofactura;
	}
	
	/**
	 * @desc
	 * Marca un tipos_factura como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Tipos_factura->IdTipofactura = $_POST['id_tipofactura'];
		$this->Tipos_factura->Eliminar();
	}
	
	/**
	 * @desc
	 * Devuelve un Tipos_factura.
	 *
	 */
	public function x_obtener() {
		$this->Tipos_factura->IdTipofactura = $_GET['id_tipofactura'];
		$aDatos = $this->Tipos_factura->Obtener();
		header('Content-type: application/xml; charset=utf-8');
		
		echo "<datos>";
		foreach ($aDatos as $columna => $valor) {
			echo "<{$columna}>".htmlspecialchars($valor, ENT_QUOTES, 'UTF-8')."</{$columna}>\r\n";
		}
		echo "</datos>";
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Tipos_factura->Nombre = @$_GET['q'];
		$this->Tipos_factura->OrderBy = 'Nombre';
		$this->Tipos_factura->LimitCant = 50;
		$aDatos = $this->Tipos_factura->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['nombre'])."|{$item['id_tipofactura']}\n";
		}
	}
}

$oCont = new Tipos_facturaCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>