<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR)) {
	header("Location: ?p=login");
	die;
}

class VencimientosCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Vencimientos.
	 *
	 * @var Vencimientos
	 */
	private $Vencimientos;
		
	function __construct() {
		parent::__construct();
		$this->Vencimientos = new Vencimientos();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Vencimientos.
	 *
	 */
	public function listado() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Vencimientos->Nombre = $_GET['nombre'];
			}
			if (@$_GET['id_periodo']) {
				$this->Vencimientos->IdPeriodo = $_GET['id_periodo'];
			}
			if (@$_GET['visto']) {
				$this->Vencimientos->Visto = $_GET['visto'];
			}
		}
		
		$this->Vencimientos->Page = @$_GET['pg'];
		$this->Vencimientos->OrderBy = 'nombre';
		$this->Buffer['listado'] = $this->Vencimientos->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Vencimientos->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('vencimientos/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Vencimientos.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Vencimientos y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Vencimientos->IdVencimiento = $_GET['id_vencimiento'];
		$this->Buffer['datos'] = $this->Vencimientos->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Vencimientos.
	 *
	 */
	public function formulario() {
		$this->Buffer['body'] = $this->Template->Load('vencimientos/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Vencimientos.
	 *
	 */
	public function guardar() {
		$this->Vencimientos->IdVencimiento = $_POST['id_vencimiento'];
		$this->Vencimientos->Obtener();
		$this->Vencimientos->Nombre = $_POST['nombre'];
		$this->Vencimientos->IdPeriodo = $_POST['id_periodo'];
		$this->Vencimientos->Visto = date2mysql($_POST['visto']);
		$this->Vencimientos->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=vencimientos"); }
		die;
	}
		
	/**
	 * @desc
	 * Buscador AJAX de Vencimientos.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['nombre']) {
				$this->Vencimientos->Nombre = $_GET['nombre'];
			}
			if (@$_GET['id_periodo']) {
				$this->Vencimientos->IdPeriodo = $_GET['id_periodo'];
			}
		}
		
		//$this->Vencimientos->Activo = null;
		$this->Vencimientos->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Vencimientos->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Vencimientos->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('vencimientos/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('vencimientos/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Vencimientos->IdVencimiento = $_POST['id_vencimiento'];
		$this->Vencimientos->Nombre = $_POST['nombre'];
		$this->Vencimientos->IdPeriodo = $_POST['id_periodo'];
		$this->Vencimientos->Visto = $_POST['visto'];
		$this->Vencimientos->Guardar();
		
		echo $this->Vencimientos->IdVencimiento;
	}
	
	/**
	 * @desc
	 * Marca un registro como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Vencimientos->IdVencimiento = $_POST['id_vencimiento'];
		$aData['eliminado'] = $this->Vencimientos->Eliminar();
		
		echo json_encode($aData);
	}
	
	/**
	 * @desc
	 * Devuelve un Vencimientos.
	 *
	 */
	public function x_obtener() {
		$this->Vencimientos->IdVencimiento = $_GET['id_vencimiento'];
		$aDatos = $this->Vencimientos->Obtener();
		
		echo json_encode($aDatos);
	}
	
	public function x_visto() {
		$this->Vencimientos->IdVencimiento = $_POST['id'];
		$this->Vencimientos->Obtener();
		$this->Vencimientos->Sumar = true;
		$this->Vencimientos->Guardar();
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Vencimientos->IdVencimiento = @$_GET['q'];
		$this->Vencimientos->OrderBy = 'IdVencimiento';
		$this->Vencimientos->LimitCant = 50;
		$aDatos = $this->Vencimientos->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_vencimiento'])."|{$item['id_vencimiento']}\n";
		}
	}
}

$oCont = new VencimientosCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>