<?
// Checkea permisos.
if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR, PERMISOS_FACTURACION, PERMISOS_VENTAS)) {
	header("Location: ?p=login");
	die;
}

class VentasCtl extends Controller {
	
	/**
	 * @desc
	 * Modelo de Ventas.
	 *
	 * @var Ventas
	 */
	private $Ventas;
		
	function __construct() {
		parent::__construct();
		$this->Ventas = new Ventas();
	}
	
	/**
	 * @desc
	 * Metodo predeterminado.
	 *
	 */
	public function index() {
		$this->listado();
	}
	
	/**
	 * @desc
	 * Listado de Ventas.
	 *
	 */
	public function listado() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['id_comercial']) {
				$this->Ventas->IdComercial = $_GET['id_comercial'];
			}
			if (@$_GET['fecha']) {
				$this->Ventas->Fecha = $_GET['fecha'];
			}
			if (@$_GET['id_precliente']) {
				$this->Ventas->IdPrecliente = $_GET['id_precliente'];
			}
			if (@$_GET['id_cliente']) {
				$this->Ventas->IdCliente = $_GET['id_cliente'];
			}
			if (@$_GET['importe']) {
				$this->Ventas->Importe = $_GET['importe'];
			}
			if (@$_GET['notas']) {
				$this->Ventas->Notas = $_GET['notas'];
			}
		}
		/*
		if (!Login::TienePermiso(PERMISOS_ADMINISTRADOR)) {
			$this->Ventas->IdComercial = $_SESSION['operador']['id_operador'];
		}*/
		$this->Ventas->IdComercial = $_SESSION['operador']['id_operador'];
		
		$this->Ventas->Page = @$_GET['pg'];
		$this->Ventas->OrderBy = 'fecha DESC';
		$this->Buffer['listado'] = $this->Ventas->Buscar();
		
		require_once(APP_FUNCTIONS_PATH.'/utils_functions.php');
		$this->Buffer['paginador'] = paginator_range($this->Ventas->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg']);
		
		$this->Buffer['body'] = $this->Template->Load('ventas/listado.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Nuevo Ventas.
	 *
	 */
	public function nuevo() {
		$this->Buffer['ModoForm'] = 'a';
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Carga un Ventas y llama a la accion formulario().
	 *
	 */
	public function editar() {
		$this->Buffer['ModoForm'] = 'c';
		$this->Buffer['Editable'] = 'disabled="disabled"';
		
		$this->Ventas->IdVenta = $_GET['id_venta'];
		$this->Buffer['datos'] = $this->Ventas->Obtener();
		
		$this->formulario();
	}
	
	/**
	 * @desc
	 * Formulario de Ventas.
	 *
	 */
	public function formulario() {
		$this->Buffer['body'] = $this->Template->Load('ventas/formulario.tpl.php', $this->Buffer);
		echo $this->Template->Load('default.tpl.php', $this->Buffer);
	}
	
	/**
	 * @desc
	 * Guarda un Ventas.
	 *
	 */
	public function guardar() {
		$this->Ventas->IdVenta = $_POST['id_venta'];
		$this->Ventas->Obtener();
		$this->Ventas->IdComercial = $_POST['id_comercial'];
		$this->Ventas->Fecha = date2mysql($_POST['fecha']);
		$this->Ventas->IdPrecliente = $_POST['id_precliente'];
		$this->Ventas->IdCliente = $_POST['id_cliente'];
		$this->Ventas->IdProyecto = $_POST['id_proyecto'];
		$this->Ventas->Importe = $_POST['importe'];
		$this->Ventas->Comision = $_POST['comision'];
		$this->Ventas->Notas = $_POST['notas'];
		$this->Ventas->Guardar();
		
		if (@$_POST['x-volver']) { header("Location: {$_POST['x-volver']}"); }
		else { header("Location: ?p=ventas"); }
		die;
	}
		
	/**
	 * @desc
	 * Buscador AJAX de Ventas.
	 *
	 */
	public function x_buscar() {
		if (isset($_GET['buscar'])) {
			if (@$_GET['id_comercial']) {
				$this->Ventas->IdComercial = $_GET['id_comercial'];
			}
			if (@$_GET['fecha']) {
				$this->Ventas->Fecha = $_GET['fecha'];
			}
		}
		
		//$this->Ventas->Activo = null;
		$this->Ventas->Page = @$_GET['pg'];
		
		$this->Buffer['callback'] = isset($_GET['callback']) ? $_GET['callback'] : 'seleccionar';
		$this->Buffer['listado'] = $this->Ventas->Buscar();
		
		$this->Buffer['paginador'] = paginator_range($this->Ventas->FoundRows, APP_MYSQL_LIMIT, @$_GET['pg'], 5);
		$this->Buffer['body'] = $this->Template->Load('ventas/x-buscar.tpl.php', $this->Buffer);
		
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Formulario de alta por AJAX.
	 *
	 */
	public function x_agregar() {
		$this->Buffer['body'] = $this->Template->Load('ventas/x-agregar.tpl.php', $this->Buffer);
		$vista = $this->Template->Load('ajax.tpl.php', $this->Buffer);
		echo $vista;
	}
	
	/**
	 * @desc
	 * Grabado por AJAX.
	 *
	 */
	public function x_guardar() {
		$this->Ventas->IdVenta = $_POST['id_venta'];
		$this->Ventas->IdComercial = $_POST['id_comercial'];
		$this->Ventas->Fecha = $_POST['fecha'];
		$this->Ventas->IdPrecliente = $_POST['id_precliente'];
		$this->Ventas->IdCliente = $_POST['id_cliente'];
		$this->Ventas->Importe = $_POST['importe'];
		$this->Ventas->Notas = $_POST['notas'];
		$this->Ventas->Guardar();
		
		echo $this->Ventas->IdVenta;
	}
	
	/**
	 * @desc
	 * Marca un registro como eliminado.
	 *
	 */
	public function x_eliminar() {
		$this->Ventas->IdVenta = $_POST['id_venta'];
		$aData['eliminado'] = $this->Ventas->Eliminar();
		
		echo json_encode($aData);
	}
	
	/**
	 * @desc
	 * Devuelve un Ventas.
	 *
	 */
	public function x_obtener() {
		$this->Ventas->IdVenta = $_GET['id_venta'];
		$aDatos = $this->Ventas->Obtener();
		
		echo json_encode($aDatos);
	}
	
	/**
	 * @desc
	 * Devuelve codigo para el autocompletado.
	 *
	 */
	public function x_autocompletar() {
		$this->Ventas->IdVenta = @$_GET['q'];
		$this->Ventas->OrderBy = 'IdVenta';
		$this->Ventas->LimitCant = 50;
		$aDatos = $this->Ventas->Buscar();
		
		foreach($aDatos as $item) {
			echo str_replace('|', '', $item['id_venta'])."|{$item['id_venta']}\n";
		}
	}
}

$oCont = new VentasCtl();
if (method_exists($oCont, $METHOD)) {
	$oCont->$METHOD();
}
else {
	$cTmp = APP_DEFAULT_METHOD;
	$oCont->$cTmp();
}
?>