<script type="text/javascript">
(function($) {
	
	$.menu = {};
	
	$.menu.defaults = {		 
		highlightClass : "foco",
		selectedClass : "entro",
		superiorClass : "superior",
		showDelay: 50,
		hideDelay: 50
	};   		
	
	$.fn.menu = function (options) {
		var options = $.extend({}, $.menu.defaults, options);
		
		var KEY = {
			RETURN:		13,
			ESC:			27,
			LEFT:			37,
			UP:			38,
			RIGHT:		39,
			DOWN:			40
		}
		
		
		return this.each(function(){
			var $menu = $(this);
			
			/**
			 * Cuando el mouse entra en un elemento superior del menu.
			 * Si ya se habia hecho click y se cambia de menu superior simula otro click.
			 */
			$menu.find("button." + options.superiorClass).mouseenter(function () {
				var $this = $(this);
				
				// Para que no titile cuando se posa en el menu y viene desde el submenu.
				if ($this.prop("clicked") == true) {
					return;
				}
				
				var $submenu = $menu.find("button." + options.highlightClass).removeClass(options.highlightClass);
				
				$this.addClass(options.highlightClass);
				
				if ($submenu.length) {
					hide($submenu.next(":first"));
					$submenu.prop("clicked", false)
					$this.click();
				}
				
			});
			
			/**
			 * Si el mouse sale del item superior y no se habia hecho click limpia todo.
			 */
			$menu.find("button." + options.superiorClass).mouseleave(function () {
				var $this = $(this);
				
				if ($this.prop("clicked") != true) {
					$(this).removeClass(options.highlightClass);
				}
			});
			
			/**
			 * Cuando se hace click muestra el submenu.
			 * Si ya lo estaba mostrando entonces lo oculta.
			 */
			$menu.find("button." + options.superiorClass).click(function () {
				var $this = $(this);
				
				if ($this.prop("clicked") == true) {
					$this.prop("clicked", false);
					//$this.removeClass(options.highlightClass);
					hide($this.next());
					
					$this.blur();
					return;
				}
				
				$this.prop("clicked", true);
				$this.addClass(options.highlightClass);
				
				show($this.next());
				
				$this.focus();
			});
			
			/**
			 * Cuando el mouse entra en un elemento inferior del menu.
			 */
			$menu.find("button:not(." + options.superiorClass + ")").mouseenter(function () {
				var $this = $(this);
				var $parent = $this.parent();
				
				if ($this.hasClass(options.highlightClass)) {
					$this.next().find("." + options.highlightClass).removeClass(options.highlightClass);
					hide($this.next().find("div"));
					return;
				}
				
				hide($parent.find("." + options.highlightClass).next("div:first"));
				$parent.find("." + options.highlightClass).removeClass(options.highlightClass);
				$this.addClass(options.highlightClass);
				
				show($this.next("div:first"));
			});
			
			$menu.find("button").keydown(function (e) {
				var $this = $(this);
				
				switch (e.keyCode) {
					case KEY.RETURN:
						if ($this.hasClass("superior")) {
							$this.click();
						}
						else {
							if ($this.next("div").length) {
								$this.mouseenter();
							}
							else {
								$this.click();
							}
						}
						
						
						$this.next().find("button:first").focus();
						return false;
						break;
						
					case KEY.ESC:
						if ($this.hasClass(options.superiorClass)) {
							$("input[readonly!=readonly]:enabled:visible:first").focus();
						}
						else {
							$this.parent()
								.fadeOut(options.hideDelay)
								.prev().focus()
								.prop("clicked", false)
								.removeClass(options.highlightClass);
						}
						return false;
						break;
						
					case KEY.LEFT:
						if ($this.hasClass(options.superiorClass)) {
							$this.parent().prev().find("button:first").focus();
						}
						else {
							if (!$this.parent().prev().hasClass(options.superiorClass)) {
								$this.parent().prev().focus().removeClass(options.highligthClass);
								hide($this.parent());
							}
						}
						return false;
						break;
						
					case KEY.UP:
						var nExito = $this.prevAll("button:first").focus().length;
						
						// Si estaba arriba de todo se va hacia el final.
						if (nExito == 0) {
							$this.nextAll("button:last").focus();
						}
						return false;
						break;
						
					case KEY.RIGHT:
						if ($this.hasClass(options.superiorClass)) {
							$this.parent().next().find("button:first").focus();
						}
						else {
							if ($this.next("div").length) {
								$this.mouseenter();
								$this.next().find("button:first").focus();
							}
						}
						return false;
						break;
						
					case KEY.DOWN:
						if ($this.hasClass(options.superiorClass)) {
							if ($this.prop("clicked") == true) {
								$this.next().find("button:first").focus();
							}
							else {
								$this.click();
								$this.next().find("button:first").focus();
							}
						}
						else {
							var nExito = $this.nextAll("button:first").focus().length;
							
							// Si estaba abajo de todo se va hacia arriba.
							if (nExito == 0) {
								$this.prevAll("button:last").focus();
							}
						}
						return false;
						break;
				}
			});
			
			function hide($item) {
				$item.fadeOut(options.hideDelay);
			}
			
			function show($item) {
				$item.fadeIn(options.showDelay);
			}
			
			function key_down($this) {
				
				return;
				if ($this.hasClass(options.superiorClass)) {
					var $submenu = $this.next();
					show($submenu);
					$submenu.find("button:first").focus();
					//$this.addClass(options.highlightClass);
				}
				else {
					var nExito = $this.nextAll("button:first").focus().length;
					
					// Si estaba abajo de todo se va hacia arriba.
					if (nExito == 0) {
						$this.prevAll("button:last").focus();
					}
				}
			}
			
			/**
			 * Si se hace click en cualquier otra parte del menu lo cierra.
			 */
			$(document).click(function (e) {
				if ($(e.target).parents("#" + $menu.prop("id")).length == 0) {
					$botones = $menu.find("button[clicked=true]");
					hide($botones.next());
					
					$menu.find("button").prop("clicked", false);
					$menu.find("."+options.highlightClass).removeClass(options.highlightClass);
					hide($menu.find("div div")); // Oculta todos los submenues.
				}
			});
			
			var altGr = false;
			$(document).keyup(function (e) {
				if (e.keyCode == 17 && e.altKey == true) {
					altGr = true;
					return true;
				}
				if (e.keyCode == 18) {
					if (altGr == true) {
						return altGr = false;
					}
					
					if ($menu.find("button[clicked=true]").length == 0) {
						$menu.find("button:first").focus();
					}
				}
			});
		});
	};
})(jQuery);
</script>