<?
abstract class Utils {
	
	/**
	 * @desc
	 * Guarda un nuevo elemento en la base de datos y devuelve el ID
	 * del mismo.
	 *
	 * @param int $nTipo
	 * @param int $nIdEntidad
	 * @return int
	 */
	public static function GuardarElemento($nTipo, $nIdEntidad) {
		$oDB = new Dbconnection();
		$cSql = "INSERT INTO elementos SET ".
			"id_tipoelemento = '{$nTipo}', ".
			"id_operador = '{$_SESSION['operador']['id_operador']}', ".
			"id_entidad = '{$nIdEntidad}' ";
			
		$nId = $oDB->QueryInsert($cSql);
		
		return $nId;
	}
	
	/**
	 * @desc
	 * Guarda una nueva relacion en la base de datos.
	 *
	 * @param int $nIdElemento1
	 * @param int $nIdElemento2
	 * @return bool
	 */
	public static function GuardarRelacion($nIdElemento1, $nIdElemento2) {
		$oDB = new Dbconnection();
		$cSql = "INSERT IGNORE INTO relaciones SET ".
			"id_elemento1 = '{$nIdElemento1}', ".
			"id_elemento2 = '{$nIdElemento2}', ".
			"id_operador = '{$_SESSION['operador']['id_operador']}' ";
			
		$oDB->Query($cSql);
		
		return true;
	}
	
	/**
	 * @desc
	 * Elimina una relacion.
	 *
	 * @param int $nIdElemento1
	 * @param int $nIdElemento2
	 * @return bool
	 */
	public static function EliminarRelacion($nIdElemento1, $nIdElemento2) {
		$oDB = new Dbconnection();
		$cSql = "DELETE FROM relaciones WHERE ".
			"id_elemento1 = '{$nIdElemento1}' AND ".
			"id_elemento2 = '{$nIdElemento2}', ";
			
		$oDB->Query($cSql);
		
		return true;
	}
	
	/**
	 * @desc
	 * Elimina elementos y relaciones del elemento.
	 * Recibe el id de la entidad y el tipo de elemento
	 *
	 * @param int $nTipo
	 * @param int $nIdEntidad
	 * @return bool
	 */
	public static function EliminarElemento($nTipo, $nIdEntidad) {
		$oDB = new Dbconnection();
		
		// Marca el elemento como eliminado.
		$cSql = "UPDATE elementos SET eliminado = 1 WHERE id_tipoelemento = '{$nTipo}' AND id_entidad = '{$nIdEntidad}' LIMIT 1";
		$oDB->Query($cSql);
		return true;
	}
	
	/**
	 * @desc
	 * Devuelve el ID del elemento segun los parametros recibidos.
	 *
	 * @param int $nTipo
	 * @param int $nIdEntidad
	 * @return int
	 */
	public static function ObtenerElemento($nTipo, $nIdEntidad) {
		$oDB = new Dbconnection();
		
		$cSql = "SELECT id_elemento FROM elementos WHERE id_tipoelemento = '{$nTipo}' AND id_entidad = '{$nIdEntidad}' LIMIT 1";
		$oDB->Query($cSql);
		
		return $oDB->Field('id_elemento');
	}
	
	/**
	 * @desc
	 * Devuelve un array con los elementos relacionados al elemento $nIdElemento.
	 * El argumento $aTiposElementos debe ser un array con los tipos de argumentos a buscar.
	 *
	 * @param int $nIdElemento
	 * @param array $aTiposElementos
	 * @return array
	 */
	public static function BuscarElementos($nIdElemento, $aTiposElementos, $nPage=null, &$nTotalRegistros=null, $cOrderBy='relaciones.fecha DESC') {
		$oDB = new Dbconnection();
		
		// Paginacion.
		if ($nPage !== null) {
			if ($nPage < 1) {
				$nPage = 1;
			}
			
			$nLimit = ($nPage - 1) * APP_MYSQL_LIMIT;
			$cLimit = "LIMIT {$nLimit}, ".APP_MYSQL_LIMIT;
		}
		else {
			$cLimit = '';
		}
		
		$cSql = "SELECT SQL_CALC_FOUND_ROWS elementos.* FROM elementos INNER JOIN relaciones ON elementos.id_elemento = relaciones.id_elemento2 WHERE elementos.eliminado = 0 AND relaciones.id_elemento1 = '{$nIdElemento}' AND elementos.id_tipoelemento IN (".join(',',$aTiposElementos).") ORDER BY {$cOrderBy} {$cLimit}";
		$oDB->Query($cSql);
		$aRet = $oDB->GetRecordset();
		
		$cSql = "SELECT FOUND_ROWS() AS total";
		$oDB->Query($cSql);
		$nTotalRegistros = $oDB->Field('total');
		
		return $aRet;
	}
}

/**
 * @desc
 * Si el script falla por algun motivo se ejecuta automaticamente
 * esta funcion para cancelar la transaccion en curso de la base de datos.
 *
 */
function RollbackTransaction() {
	$oDB = new Dbconnection();
	$cSql = "ROLLBACK";
	$oDB->Query($cSql);
}
?>