<?
class Cheques_cobranza extends Model {
	
	
	/**
	 * @desc
	 * Cadena con el ORDER BY.
	 *
	 * @var string
	 */
	public $OrderBy;
	
	/**
	 * @desc
	 * Numero de pagina.
	 * Comienza en 1 (1 = primer pagina).
	 * 
	 * Si se pasa un valor menor a 1 lo ignora.
	 *
	 * @var int
	 */
	public $Page;
	
	
	/**
	 * @desc
	 * Limite de consulta.
	 * Se usa junto a Page.
	 * 
	 * Si se asigna NULL no se hace un limite en la consulta.
	 *
	 * @var int
	 */
	public $LimitCant = APP_MYSQL_LIMIT;
	
	/**
	 * @desc
	 * Indica la cantidad total de registros si no se
	 * ubiera usado la clausula LIMIT en la consulta.
	 *
	 * @var int
	 */
	public $FoundRows;
	
	/**
	 * @desc
	 * Propiedades del modelo.
	 *
	 * @var mixed
	 */
	public $IdChequecobranza, $IdCobranza, $IdCheque;
	
	function __construct() {
		parent::__construct();
	}
	
	/**
	 * @desc
	 * Realiza una busqueda de Cheques_cobranza.
	 * Ordena por la propiedad OrderBy.
	 * Limita registros por las propiedades Page y LimitCant.
	 * 
	 * Calcula la cantidad de registros sin el limite y lo pone en la
	 * propiedad FoundRows.
	 *
	 * @return array
	 */
	public function Buscar() {
		$cOrderBy = $cLimit = '';
		$aWhere = array();
		
		// Ordenacion.
		if ($this->OrderBy) {
			$cOrderBy = "ORDER BY {$this->OrderBy}";
		}
		
		// Paginacion.
		if ($this->Page < 1) {
			$this->Page = 1;
		}
		if ($this->LimitCant !== null) {
			$nLimit = ($this->Page - 1) * $this->LimitCant;
			$cLimit = "LIMIT {$nLimit}, {$this->LimitCant}";
		}
		else {
			$cLimit = '';
		}
		
		if ($this->IdCobranza !== null) {
			$aWhere[] = "cheques_cobranza.id_cobranza = '{$this->IdCobranza}'";
		}
		if ($this->IdCheque !== null) {
			$aWhere[] = "cheques_cobranza.id_cheque = '{$this->IdCheque}'";
		}
		
		// Arma la cadena SQL.
		$cWhere = $aWhere ? 'WHERE '.join(' AND ', $aWhere) : '';
		
		$cSql = "SELECT SQL_CALC_FOUND_ROWS cheques_cobranza.* FROM cheques_cobranza INNER JOIN elementos ON elementos.id_entidad = cheques_cobranza.id_chequecobranza AND elementos.id_tipoelemento = ".ELEMENTOS_CHEQUECOBRANZA." AND elementos.eliminado = 0 {$cWhere} {$cOrderBy} {$cLimit}";
		$this->DB->Query($cSql);
		$aRet = $this->DB->GetRecordset();
		
		$cSql = "SELECT FOUND_ROWS() total";
		$this->DB->Query($cSql);
		
		$this->FoundRows = $this->DB->Field('total');
		
		return $aRet;
	}
	
	/**
	 * @desc
	 * Devuelve el Cheques_cobranza con ID $this->IdChequecobranza.
	 *
	 * @param int $nId
	 * @return array
	 */
	public function Obtener() {
		$cSql = "SELECT cheques_cobranza.* FROM cheques_cobranza WHERE cheques_cobranza.id_chequecobranza = '{$this->IdChequecobranza}' LIMIT 1";
		
		$this->DB->Query($cSql);
		$aRet = $this->DB->Field();
		
		if ($aRet) {
			$this->Set($aRet);
		}
		else {
			$this->Limpiar();
		}
		
		return $aRet;
	}
	
	/**
	 * @desc
	 * Guarda un Cheques_cobranza.
	 * Devuelve el ID del Cheques_cobranza guardado.
	 *
	 * @param array $aData
	 * @return int
	 */
	public function Guardar() {
		$this->DB->Begin();
		
		if ($this->IdChequecobranza) {
			$cSql = "UPDATE cheques_cobranza SET ".
				"id_cobranza = '{$this->IdCobranza}', ".
				"id_cheque = '{$this->IdCheque}' ".
				"WHERE id_chequecobranza = '{$this->IdChequecobranza}' LIMIT 1";
			
			$this->DB->Query($cSql);
		}
		else {
			$cSql = "INSERT INTO cheques_cobranza SET ".
				"id_cobranza = '{$this->IdCobranza}', ".
				"id_cheque = '{$this->IdCheque}'";
			
			$this->IdChequecobranza = $this->DB->QueryInsert($cSql);
			
			Utils::GuardarElemento(ELEMENTOS_CHEQUECOBRANZA, $this->IdChequecobranza);
		}
		
		if ($this->DB->GetLastError()) {
			$this->DB->Rollback();
			return 0;
		}
		else {
			$this->DB->Commit();
			return $this->IdChequecobranza;
		}
	}
	
	/**
	 * @desc
	 * Elimina un Cheques_cobranza.
	 *
	 */
	public function Eliminar() {
		$this->DB->Begin();
		
		Utils::EliminarElemento(ELEMENTOS_CHEQUECOBRANZA, $this->IdChequecobranza);
		
		$this->DB->Commit();
	}
	
	/**
	 * @desc
	 * Llena las propiedades del modelo con los datos
	 * provistos en el array $aDatos.
	 *
	 * @param array $aDatos
	 */
	private function Set($aDatos) {
		$this->IdChequecobranza = $aDatos['id_chequecobranza'];
		$this->IdCobranza = $aDatos['id_cobranza'];
		$this->IdCheque = $aDatos['id_cheque'];
	}
	
	/**
	 * @desc
	 * Limpia las propiedades del objeto.
	 *
	 */
	public function Limpiar() {
		$this->IdChequecobranza = $this->IdCobranza = $this->IdCheque = null;
	}
}
?>