<?
class Login extends Model {
	
	/**
	 * @desc
	 * Modelo de Operadores.
	 *
	 * @var Operadores
	 */
	private $Operadores;
	
	function __construct() {
		parent::__construct();
		$this->Operadores = new Operadores();
	}
	
	/**
	 * @desc
	 * Intenta iniciar sesion con los datos proporcionados.
	 *
	 * @param string $cUser
	 * @param string $cPass
	 * @return bool
	 */
	function InitSession($cUser, $cPass) {
	
		$aOperador = $this->Operadores->ObtenerPorUsuario($cUser);

		// Sesion iniciada.
		if ($aOperador) {
			
			if ($aOperador['clave'] == $cPass && $aOperador['habilitado']) {
				$_SESSION['operador'] = $aOperador;
				return true;
			}
		}
		
		return false; // Fallo el inicio de sesion.
	}
	
	/**
	 * @desc
	 * Devuelve verdadero o falso segun el operador que inicio sesion
	 * tenga los permisos indicados en $cPerm.
	 *
	 * @param string $cPerm
	 * @return bool
	 */
	static function TienePermiso($cPerm) {
		$aArgs = func_get_args();
		
		$nRet = false;
		
		foreach ($aArgs as $item) {
			
			if (isset($_SESSION['operador']['permisos'][$item]) && $_SESSION['operador']['permisos'][$item]) {
				$nRet = true;
			}
		}
		
		return $nRet;
	}
	
	/**
	 * @desc
	 * Devuelve verdadero si el operador esta logueado.
	 *
	 * @return bool
	 */
	static function EstaLogueado() {
		return (bool) @$_SESSION['operador']['id_operador'];
	}
}
?>